/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2010 Thierry Lagarde <thierry@autoscan-network.com>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include "Recherche.h"
#include "Debug.h"
#include "Equipement.h"
#include "Equipement_Port.h"
#include "Objet.h"
#include "Reseau.h"
#include "Root_Interface.h"
#include "Equipement_Port.h"
#include "Debug.h"


void Recherche_Par_Addresse_IP (gchar * Adresse_Ip)
{
	struct Struct_Equipement *Equipement = NULL;
	struct Struct_Modele_Objet *Objet = NULL,*Objet_Liste_Selectionner = NULL;
	GtkWidget *Win_Non_Trouve = NULL;
	guint     Nb_Objet_Liste, i;

	ERROR_if (Adresse_Ip == NULL);
	Nb_Objet_Liste = g_list_length (Reseau_Selectionner->GList_Liste_Equipement);
	for (i = 0; i < Nb_Objet_Liste; i++) {
		Objet = g_list_nth_data (Reseau_Selectionner->GList_Liste_Equipement, i);
		if (Objet->Nb_Enfant == 0) {
			Equipement = (struct Struct_Equipement *) Objet->Pointeur_Attacher;
			if (strcmp (Equipement->Adresse_Ip_Char, Adresse_Ip) == 0) {
			
				if (Reseau_Selectionner->Mode_Liste_Detaille)
					Objet_Liste_Selectionner = Equipement->Objet_Liste_Par_Ip;
				else 
					Objet_Liste_Selectionner = Equipement->Objet_Liste_Par_Type;
				Selectionne_Objet_Dans_Liste (Objet_Liste_Selectionner, Reseau_Selectionner);
				Action_Selection_Equipement ((gpointer *) Objet_Liste_Selectionner);
				return;
			}
		}
	}
	Win_Non_Trouve = gtk_message_dialog_new (GTK_WINDOW (window_root), GTK_DIALOG_MODAL, GTK_MESSAGE_QUESTION, GTK_BUTTONS_OK, "Equipment not found");
	gtk_dialog_run (GTK_DIALOG (Win_Non_Trouve));
	gtk_widget_destroy (Win_Non_Trouve);
}


void Recherche_Par_Addresse_MAC (gchar * Adresse_MAC)
{
	struct Struct_Equipement *Equipement = NULL;
	struct Struct_Modele_Objet *Objet = NULL,*Objet_Liste_Selectionner = NULL;
	GtkWidget *Win_Non_Trouve = NULL;
	guint     Nb_Objet_Liste, i;

	Nb_Objet_Liste = g_list_length (Reseau_Selectionner->GList_Liste_Equipement);
	for (i = 0; i < Nb_Objet_Liste; i++) {
		Objet = g_list_nth_data (Reseau_Selectionner->GList_Liste_Equipement, i);
		if (Objet->Nb_Enfant == 0) {
			Equipement = (struct Struct_Equipement *) Objet->Pointeur_Attacher;
			if (strcmp (Equipement->Adresse_MAC_Char, Adresse_MAC) == 0) {
			
				if (Reseau_Selectionner->Mode_Liste_Detaille)
					Objet_Liste_Selectionner = Equipement->Objet_Liste_Par_Ip;
				else 
					Objet_Liste_Selectionner = Equipement->Objet_Liste_Par_Type;
				Selectionne_Objet_Dans_Liste (Objet_Liste_Selectionner, Reseau_Selectionner);
				Action_Selection_Equipement ((gpointer *) Objet_Liste_Selectionner);
				return;
			}
		}
	}
	Win_Non_Trouve = gtk_message_dialog_new (GTK_WINDOW (window_root), GTK_DIALOG_MODAL, GTK_MESSAGE_QUESTION, GTK_BUTTONS_OK, "Equipment not found");
	gtk_dialog_run (GTK_DIALOG (Win_Non_Trouve));
	gtk_widget_destroy (Win_Non_Trouve);
}


void Recherche_Par_HostName (gchar * HostName)
{
	struct Struct_Equipement *Equipement = NULL;
	struct Struct_Modele_Objet *Objet = NULL,*Objet_Liste_Selectionner = NULL;
	GtkWidget *Win_Non_Trouve = NULL;
	guint     Nb_Objet_Liste, i;

	Nb_Objet_Liste = g_list_length (Reseau_Selectionner->GList_Liste_Equipement);
	for (i = 0; i < Nb_Objet_Liste; i++) {
		Objet = g_list_nth_data (Reseau_Selectionner->GList_Liste_Equipement, i);
		if (Objet->Nb_Enfant == 0) {
			Equipement = (struct Struct_Equipement *) Objet->Pointeur_Attacher;
			if (strcmp (Equipement->Smb.HostName, HostName) == 0) {
			
				if (Reseau_Selectionner->Mode_Liste_Detaille)
					Objet_Liste_Selectionner = Equipement->Objet_Liste_Par_Ip;
				else 
					Objet_Liste_Selectionner = Equipement->Objet_Liste_Par_Type;
				Selectionne_Objet_Dans_Liste (Objet_Liste_Selectionner, Reseau_Selectionner);
				Action_Selection_Equipement ((gpointer *) Objet_Liste_Selectionner);
				return;
			}
		}
	}
	Win_Non_Trouve = gtk_message_dialog_new (GTK_WINDOW (window_root), GTK_DIALOG_MODAL, GTK_MESSAGE_QUESTION, GTK_BUTTONS_OK, "Equipment not found");
	gtk_dialog_run (GTK_DIALOG (Win_Non_Trouve));
	gtk_widget_destroy (Win_Non_Trouve);
}


void Recherche_Par_Port (gint Num_Du_Port)
{
	struct Struct_Equipement *Equipement = NULL;
	struct Struct_Modele_Objet *Objet = NULL,*Objet_Liste_Selectionner = NULL;
	GtkWidget *Win_Non_Trouve = NULL;
	guint     Nb_Objet_Liste, i;

	Nb_Objet_Liste = g_list_length (Reseau_Selectionner->GList_Liste_Equipement);
	for (i = 0; i < Nb_Objet_Liste; i++) {
		Objet = g_list_nth_data (Reseau_Selectionner->GList_Liste_Equipement, i);
		if (Objet->Nb_Enfant == 0) {
			Equipement = (struct Struct_Equipement *) Objet->Pointeur_Attacher;
			if (Cherche_Si_Port_Ouvert (Equipement, Num_Du_Port)) {
				if (Reseau_Selectionner->Mode_Liste_Detaille)
					Objet_Liste_Selectionner = Equipement->Objet_Liste_Par_Ip;
				else 
					Objet_Liste_Selectionner = Equipement->Objet_Liste_Par_Type;
				Selectionne_Objet_Dans_Liste (Objet_Liste_Selectionner, Reseau_Selectionner);
				Action_Selection_Equipement ((gpointer *) Objet_Liste_Selectionner);
				return;
			}
		}
	}
	Win_Non_Trouve = gtk_message_dialog_new (GTK_WINDOW (window_root), GTK_DIALOG_MODAL, GTK_MESSAGE_QUESTION, GTK_BUTTONS_OK, "Equipment not found");
	gtk_dialog_run (GTK_DIALOG (Win_Non_Trouve));
	gtk_widget_destroy (Win_Non_Trouve);
}
