/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2010 Thierry Lagarde <thierry@autoscan-network.com>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include "Root_Callbacks.h"
#include "Root_Interface.h"
#include "Combo.h"
#include "Declaration_Constante.h"
#include "Configuration.h"
#include "Objet_Liste.h"
#include "Modules.h"
#include "Image.h"
#include "Snmp.h"

extern struct Struct_Combo_Liste Liste_ComboTrueFalse[];
extern struct Struct_Combo_Liste Liste_ComboNetwork[];
		
void create_window_root (void)
{
#ifdef         __GNOME_ENABLE
	tooltips = gtk_tooltips_new ();
#endif 
#ifndef         __MAEMO
	window_root = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	window_root_icon_pixbuf = Load_Pixbuf("AutoScan.png");
	if (window_root_icon_pixbuf) {
		gtk_window_set_icon (GTK_WINDOW (window_root), window_root_icon_pixbuf);
		gdk_pixbuf_unref (window_root_icon_pixbuf);
	}
	gtk_window_unfullscreen(GTK_WINDOW(window_root));
#else
	window_root = gtk_window_new_maemo ();
#endif
	gtk_widget_set_size_request (window_root, Config_Root_Size_X,Config_Root_Size_Y);

	gtk_window_move (GTK_WINDOW (window_root), Config_Root_Position_X,Config_Root_Position_Y);
	gtk_window_set_title (GTK_WINDOW (window_root), VERSION_AUTOSCAN);

	
	list_store_combo_True_False = gtk_list_store_new (1, G_TYPE_STRING);
	gtk_list_store_append (list_store_combo_True_False, &iter_Combo);
    gtk_list_store_set (list_store_combo_True_False, &iter_Combo, 0, Liste_ComboTrueFalse[0].Chaine, -1);
    gtk_list_store_append (list_store_combo_True_False, &iter_Combo);
    gtk_list_store_set (list_store_combo_True_False, &iter_Combo, 0, Liste_ComboTrueFalse[1].Chaine, -1);
	
	list_store_combo_Network = gtk_list_store_new (1, G_TYPE_STRING);
	gtk_list_store_append (list_store_combo_Network, &iter_Combo);
    gtk_list_store_set (list_store_combo_Network, &iter_Combo, 0, Liste_ComboNetwork[0].Chaine, -1);
    gtk_list_store_append (list_store_combo_Network, &iter_Combo);
    gtk_list_store_set (list_store_combo_Network, &iter_Combo, 0, Liste_ComboNetwork[1].Chaine, -1);
	gtk_list_store_append (list_store_combo_Network, &iter_Combo);
    gtk_list_store_set (list_store_combo_Network, &iter_Combo, 0, Liste_ComboNetwork[2].Chaine, -1);
	
	vbox_root = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_root);
	gtk_container_add (GTK_CONTAINER (window_root), vbox_root);

	toolbar = gtk_toolbar_new ();
	gtk_widget_show (toolbar);
	gtk_box_pack_start (GTK_BOX (vbox_root), toolbar, FALSE, FALSE, 0);
   
	gtk_toolbar_set_style (GTK_TOOLBAR (toolbar), GTK_TOOLBAR_BOTH);
	tmp_toolbar_icon_size = gtk_toolbar_get_icon_size (GTK_TOOLBAR (toolbar));

	tmp_image = Load_Pixmap ("connect_to_network.png");
	gtk_widget_show (tmp_image);
	toolbutton_Add_Network = (GtkWidget *) gtk_tool_button_new (tmp_image, "Add a network");
	gtk_widget_show (toolbutton_Add_Network);
	gtk_container_add (GTK_CONTAINER (toolbar), toolbutton_Add_Network);


	tmp_image = Load_Pixmap ("view_tree.png");
	gtk_widget_show (tmp_image);
	toolbutton_View = (GtkWidget *) gtk_tool_button_new (tmp_image, "View");
#ifndef         __MAEMO
	gtk_widget_show (toolbutton_View);
#endif
	gtk_widget_set_sensitive (toolbutton_View, FALSE);
	gtk_container_add (GTK_CONTAINER (toolbar), toolbutton_View);

	tmp_image = Load_Pixmap ("filesave.png");
	gtk_widget_show (tmp_image);
	toolbutton_Save = (GtkWidget *) gtk_tool_button_new (tmp_image, "Save");
	gtk_widget_show (toolbutton_Save);
	gtk_widget_set_sensitive (toolbutton_Save, FALSE);
	gtk_container_add (GTK_CONTAINER (toolbar), toolbutton_Save);

	tmp_image = Load_Pixmap ("find.png");
	gtk_widget_show (tmp_image);
	toolbutton_Search = (GtkWidget *) gtk_tool_button_new (tmp_image, "Search");
	gtk_widget_show (toolbutton_Search);
	gtk_widget_set_sensitive (toolbutton_Search, FALSE);
	gtk_container_add (GTK_CONTAINER (toolbar), toolbutton_Search);

	tmp_image = Load_Pixmap ("configure.png");
	gtk_widget_show (tmp_image);
	toolbutton_Settings = (GtkWidget *) gtk_tool_button_new (tmp_image, "Settings");
	gtk_widget_show (toolbutton_Settings);
	gtk_container_add (GTK_CONTAINER (toolbar), toolbutton_Settings);

	separatortoolitem_1 = (GtkWidget *) gtk_separator_tool_item_new ();
	gtk_widget_show (separatortoolitem_1);
	gtk_container_add (GTK_CONTAINER (toolbar), separatortoolitem_1);

	toggletoolbutton_Notification = (GtkWidget *) gtk_toggle_tool_button_new ();
	gtk_tool_button_set_label (GTK_TOOL_BUTTON (toggletoolbutton_Notification), "Notification");
	tmp_image = Load_Pixmap ("Notifications.png");
	gtk_widget_show (tmp_image);
	gtk_tool_button_set_icon_widget (GTK_TOOL_BUTTON (toggletoolbutton_Notification), tmp_image);
	gtk_widget_show (toggletoolbutton_Notification);
	gtk_container_add (GTK_CONTAINER (toolbar), toggletoolbutton_Notification);
	gtk_widget_set_sensitive (toggletoolbutton_Notification, FALSE);

	toggletoolbutton_Alert_Intrusion = (GtkWidget *) gtk_toggle_tool_button_new ();
	gtk_tool_button_set_label (GTK_TOOL_BUTTON (toggletoolbutton_Alert_Intrusion), "Intrusion Alert");
	tmp_image = Load_Pixmap ("new_equipment.png");
	gtk_widget_show (tmp_image);
	gtk_widget_set_sensitive (toggletoolbutton_Alert_Intrusion, FALSE);
	gtk_tool_button_set_icon_widget (GTK_TOOL_BUTTON (toggletoolbutton_Alert_Intrusion), tmp_image);
	gtk_widget_show (toggletoolbutton_Alert_Intrusion);
	gtk_container_add (GTK_CONTAINER (toolbar), toggletoolbutton_Alert_Intrusion);

	separatortoolitem_2 = (GtkWidget *) gtk_separator_tool_item_new ();
	gtk_widget_show (separatortoolitem_2);
	gtk_container_add (GTK_CONTAINER (toolbar), separatortoolitem_2);

	tmp_image = Load_Pixmap ("help.png");
	gtk_widget_show (tmp_image);
	toolbutton_Help = (GtkWidget *) gtk_tool_button_new (tmp_image, "Help");
	gtk_widget_show (toolbutton_Help);
	gtk_widget_set_sensitive (toolbutton_Help, TRUE);
	gtk_container_add (GTK_CONTAINER (toolbar), toolbutton_Help);

	toolbutton_About = (GtkWidget *) gtk_tool_button_new_from_stock ("gtk-about");
	gtk_widget_show (toolbutton_About);
	gtk_container_add (GTK_CONTAINER (toolbar), toolbutton_About);
	
	tmp_image = Load_Pixmap ("xconsole.png");
	gtk_widget_show (tmp_image);
	toolbutton_Console = (GtkWidget *) gtk_tool_button_new (tmp_image, "Console");

	gtk_widget_show (toolbutton_Console);
	gtk_container_add (GTK_CONTAINER (toolbar), toolbutton_Console);	
	/*tmp_image = Load_Pixmap ("About.png");
	gtk_widget_show (tmp_image);
	toolbutton_fullscreen = (GtkWidget *) gtk_tool_button_new (tmp_image, "FullScreen");
	gtk_widget_show (toolbutton_fullscreen);
	gtk_container_add (GTK_CONTAINER (toolbar), toolbutton_fullscreen);*/
	
	separatortoolitem_3 = (GtkWidget *) gtk_separator_tool_item_new ();
	gtk_widget_show (separatortoolitem_3);
	gtk_container_add (GTK_CONTAINER (toolbar), separatortoolitem_3);

	tmp_image = Load_Pixmap ("exit.png");
	gtk_widget_show (tmp_image);
	toolbutton_Exit = (GtkWidget *) gtk_tool_button_new (tmp_image, "Exit");
	gtk_widget_show (toolbutton_Exit);
	gtk_container_add (GTK_CONTAINER (toolbar), toolbutton_Exit);

	hpaned_root = gtk_hpaned_new ();
	gtk_widget_show (hpaned_root);
	gtk_box_pack_start (GTK_BOX (vbox_root), hpaned_root, TRUE, TRUE, 0);
	gtk_paned_set_position (GTK_PANED (hpaned_root), Config_H_Paned_Position);


	vbox_network = gtk_vbox_new (FALSE, 0);
    gtk_widget_show (vbox_network);
	gtk_paned_pack1 (GTK_PANED (hpaned_root), vbox_network, FALSE, TRUE);
   
	

	

	scrollwin_liste_equipement = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrollwin_liste_equipement);
	gtk_box_pack_start (GTK_BOX (vbox_network), scrollwin_liste_equipement, TRUE, TRUE, 0);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrollwin_liste_equipement), GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);

	
	vbox_root_network = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_root_network);
	gtk_box_pack_start (GTK_BOX (vbox_network), vbox_root_network, FALSE, TRUE, 0);
	
	label_my_network_list = gtk_label_new_with_mnemonic ("My Network List");
	gtk_widget_show (label_my_network_list);
	gtk_box_pack_start (GTK_BOX (vbox_root_network), label_my_network_list, FALSE, FALSE, 0);
	
	scrolledwindow_network = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow_network);
  	gtk_box_pack_start (GTK_BOX (vbox_root_network), scrolledwindow_network, TRUE, TRUE, 0);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_network), GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
	treeview_network = Create_Liste (FALSE, FALSE, FALSE, FALSE,FALSE, TRUE,list_store_combo_Network);
	gtk_widget_show (treeview_network);
	gtk_container_add (GTK_CONTAINER (scrolledwindow_network), treeview_network);
	gtk_widget_set_size_request(scrolledwindow_network,-1,0);

	vpaned_root = gtk_vpaned_new ();
	gtk_widget_show (vpaned_root);
	gtk_paned_pack2 (GTK_PANED (hpaned_root), vpaned_root, TRUE, TRUE);
	gtk_container_set_border_width (GTK_CONTAINER (vpaned_root), 2);
	gtk_paned_set_position (GTK_PANED (vpaned_root), Config_V_Paned_Position);




  	viewport_Notebook_Info = gtk_viewport_new (NULL, NULL);
  	gtk_widget_show (viewport_Notebook_Info);
	gtk_paned_pack1 (GTK_PANED (vpaned_root), viewport_Notebook_Info, FALSE, TRUE);
	gtk_viewport_set_shadow_type (GTK_VIEWPORT (viewport_Notebook_Info), GTK_SHADOW_NONE);
  	
 	notebook_Info = gtk_notebook_new ();
  	gtk_widget_show (notebook_Info);
  	gtk_container_add (GTK_CONTAINER (viewport_Notebook_Info), notebook_Info);
  	gtk_notebook_set_show_border (GTK_NOTEBOOK (notebook_Info), FALSE);
  	gtk_notebook_set_tab_pos (GTK_NOTEBOOK (notebook_Info), GTK_POS_BOTTOM);
	gtk_notebook_set_show_tabs (GTK_NOTEBOOK (notebook_Info), FALSE);
	gtk_notebook_set_scrollable (GTK_NOTEBOOK (notebook_Info), TRUE);
	Page_Notebook_Info = 0; 
	
	vbox_Treeview_Info = gtk_vbox_new (FALSE, 0);
  	gtk_widget_show (vbox_Treeview_Info);
  	gtk_container_add (GTK_CONTAINER (notebook_Info), vbox_Treeview_Info);
   	

 	hbox_notebook_Info = gtk_hbox_new (FALSE, 0);
  	gtk_widget_show (hbox_notebook_Info);
	gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook_Info), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info), ONGLET_BASE), hbox_notebook_Info);
	image_notebook_Info = (GdkPixbuf *)Load_Pixmap ("Onglet/Info_Base.png");
  	gtk_widget_show ((GtkWidget *)image_notebook_Info);
  	gtk_box_pack_start (GTK_BOX (hbox_notebook_Info), (GtkWidget *)image_notebook_Info, TRUE, TRUE, 0);
  	label_notebook_Info = gtk_label_new ("Summary");
  	gtk_widget_show (label_notebook_Info);
  	gtk_box_pack_start (GTK_BOX (hbox_notebook_Info), label_notebook_Info, FALSE, FALSE, 0);
	scrolledwindow_Info_Base = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow_Info_Base);
  	gtk_box_pack_start (GTK_BOX (vbox_Treeview_Info), scrolledwindow_Info_Base, TRUE, TRUE, 0);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_Info_Base), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	treeview_Info = Create_Liste (FALSE, FALSE, TRUE, TRUE, FALSE, FALSE,NULL);
	gtk_widget_show (treeview_Info);

	gtk_container_add (GTK_CONTAINER (scrolledwindow_Info_Base), treeview_Info);
	gtk_tree_view_set_headers_visible (GTK_TREE_VIEW (treeview_Info), FALSE);
  


	scrolledwindow_Config = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow_Config);
  	gtk_container_add (GTK_CONTAINER (notebook_Info), scrolledwindow_Config);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_Config), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
 
 	hbox_notebook_Config = gtk_hbox_new (FALSE, 0);
  	gtk_widget_show (hbox_notebook_Config);
	gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook_Info), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info), ONGLET_CONFIG), hbox_notebook_Config);

	image_notebook_Config = Load_Pixmap ("Onglet/Info_Autre.png");
  	gtk_widget_show (image_notebook_Config);
  	gtk_box_pack_start (GTK_BOX (hbox_notebook_Config), image_notebook_Config, TRUE, TRUE, 0);

  	label_notebook_Config = gtk_label_new ("Config");
  	gtk_widget_show (label_notebook_Config);
  	gtk_box_pack_start (GTK_BOX (hbox_notebook_Config), label_notebook_Config, FALSE, FALSE, 0);

 	treeview_Config = Create_Liste (FALSE, FALSE, FALSE, TRUE, FALSE, FALSE,list_store_combo_True_False);
	gtk_widget_show (treeview_Config);
	gtk_container_add (GTK_CONTAINER (scrolledwindow_Config), treeview_Config);
	gtk_tree_view_set_headers_visible (GTK_TREE_VIEW (treeview_Config), FALSE);



	scrolledwindow_Info_Autre = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow_Info_Autre);
  	gtk_container_add (GTK_CONTAINER (notebook_Info), scrolledwindow_Info_Autre);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_Info_Autre), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
 
 	hbox_notebook_Info_Autre = gtk_hbox_new (FALSE, 0);
  	gtk_widget_show (hbox_notebook_Info_Autre);
	gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook_Info), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info), ONGLET_INFO_AUTRE), hbox_notebook_Info_Autre);

	image_notebook_Info_Autre = (GdkPixbuf *)Load_Pixmap ("Onglet/Info_Autre.png");
  	gtk_widget_show ((GtkWidget *)image_notebook_Info_Autre);
  	gtk_box_pack_start (GTK_BOX (hbox_notebook_Info_Autre), (GtkWidget *)image_notebook_Info_Autre, TRUE, TRUE, 0);

  	label_notebook_Info_Autre = gtk_label_new ("Info");
  	gtk_widget_show (label_notebook_Info_Autre);
  	gtk_box_pack_start (GTK_BOX (hbox_notebook_Info_Autre), label_notebook_Info_Autre, FALSE, FALSE, 0);

 	treeview_Info_Autre = Create_Liste (FALSE, FALSE, FALSE, TRUE, FALSE, FALSE,NULL);
	gtk_widget_show (treeview_Info_Autre);
	gtk_container_add (GTK_CONTAINER (scrolledwindow_Info_Autre), treeview_Info_Autre);
	gtk_tree_view_set_headers_visible (GTK_TREE_VIEW (treeview_Info_Autre), FALSE);


	scrolledwindow_Info_Snmp = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow_Info_Snmp);
  	gtk_container_add (GTK_CONTAINER (notebook_Info), scrolledwindow_Info_Snmp);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_Info_Snmp), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  
 	hbox_notebook_Info_Snmp = gtk_hbox_new (FALSE, 0);
  	gtk_widget_show (hbox_notebook_Info_Snmp);
	gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook_Info), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info), ONGLET_INFO_SNMP), hbox_notebook_Info_Snmp);

	image_notebook_Info_Snmp = (GdkPixbuf *)Load_Pixmap ("Onglet/Snmp.png");
  	gtk_widget_show ((GtkWidget *)image_notebook_Info_Snmp);
  	gtk_box_pack_start (GTK_BOX (hbox_notebook_Info_Snmp), (GtkWidget *)image_notebook_Info_Snmp, TRUE, TRUE, 0);

  	label_notebook_Info_Snmp = gtk_label_new ("Snmp");
  	gtk_widget_show (label_notebook_Info_Snmp);
  	gtk_box_pack_start (GTK_BOX (hbox_notebook_Info_Snmp), label_notebook_Info_Snmp, FALSE, FALSE, 0);

	treeview_Info_Snmp = Create_Liste (FALSE, FALSE, FALSE, TRUE, FALSE, FALSE,NULL);
	gtk_widget_show (treeview_Info_Snmp);
	gtk_container_add (GTK_CONTAINER (scrolledwindow_Info_Snmp), treeview_Info_Snmp);
	gtk_tree_view_set_headers_visible (GTK_TREE_VIEW (treeview_Info_Snmp), FALSE);

	scrolledwindow_Info_Software = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow_Info_Software);
  	gtk_container_add (GTK_CONTAINER (notebook_Info), scrolledwindow_Info_Software);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_Info_Software), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  
 	hbox_notebook_Info_Software = gtk_hbox_new (FALSE, 0);
  	gtk_widget_show (hbox_notebook_Info_Software);
	gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook_Info), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info), ONGLET_INFO_SOFT), hbox_notebook_Info_Software);

	image_notebook_Info_Software = (GdkPixbuf *)Load_Pixmap ("Onglet/Software.png");
  	gtk_widget_show ((GtkWidget *)image_notebook_Info_Software);
  	gtk_box_pack_start (GTK_BOX (hbox_notebook_Info_Software), (GtkWidget *)image_notebook_Info_Software, TRUE, TRUE, 0);

  	label_notebook_Info_Software = gtk_label_new ("Software");
  	gtk_widget_show (label_notebook_Info_Software);
  	gtk_box_pack_start (GTK_BOX (hbox_notebook_Info_Software), label_notebook_Info_Software, FALSE, FALSE, 0);
 	 
	treeview_Info_Software = Create_Liste_Snmp(SNMP_SOFTWARE);//Create_Liste (FALSE, FALSE, FALSE, TRUE, FALSE);
	gtk_widget_show (treeview_Info_Software);
	gtk_container_add (GTK_CONTAINER (scrolledwindow_Info_Software), treeview_Info_Software);
	gtk_tree_view_set_headers_visible (GTK_TREE_VIEW (treeview_Info_Software), TRUE);


	scrolledwindow_Info_Tcp = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow_Info_Tcp);
  	gtk_container_add (GTK_CONTAINER (notebook_Info), scrolledwindow_Info_Tcp);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_Info_Tcp), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
 
  	hbox_notebook_Info_Tcp = gtk_hbox_new (FALSE, 0);
  	gtk_widget_show (hbox_notebook_Info_Tcp);
	gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook_Info), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info), ONGLET_INFO_TCP), hbox_notebook_Info_Tcp);

	image_notebook_Info_Tcp = (GdkPixbuf *)Load_Pixmap ("Onglet/Tcp.png");
  	gtk_widget_show ((GtkWidget *)image_notebook_Info_Tcp);
  	gtk_box_pack_start (GTK_BOX (hbox_notebook_Info_Tcp), (GtkWidget *)image_notebook_Info_Tcp, TRUE, TRUE, 0);

  	label_notebook_Info_Tcp = gtk_label_new ("TCP/IP");
  	gtk_widget_show (label_notebook_Info_Tcp);
  	gtk_box_pack_start (GTK_BOX (hbox_notebook_Info_Tcp), label_notebook_Info_Tcp, FALSE, FALSE, 0);
   	
	treeview_Info_Tcp = Create_Liste_Snmp(SNMP_NETWORK_TCPIP_TCP_CONNECTIONS);
	gtk_widget_show (treeview_Info_Tcp);
	gtk_container_add (GTK_CONTAINER (scrolledwindow_Info_Tcp), treeview_Info_Tcp);
	gtk_tree_view_set_headers_visible (GTK_TREE_VIEW (treeview_Info_Tcp), TRUE);


	scrolledwindow_Info_Route = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow_Info_Route);
  	gtk_container_add (GTK_CONTAINER (notebook_Info), scrolledwindow_Info_Route);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_Info_Route), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
 
  	hbox_notebook_Info_Route = gtk_hbox_new (FALSE, 0);
  	gtk_widget_show (hbox_notebook_Info_Route);
	gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook_Info), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info), ONGLET_INFO_ROUTE), hbox_notebook_Info_Route);

	image_notebook_Info_Route = (GdkPixbuf *)Load_Pixmap ("Onglet/Route.png");
  	gtk_widget_show ((GtkWidget *)image_notebook_Info_Route);
  	gtk_box_pack_start (GTK_BOX (hbox_notebook_Info_Route), (GtkWidget *)image_notebook_Info_Route, TRUE, TRUE, 0);

  	label_notebook_Info_Route = gtk_label_new ("Route");
  	gtk_widget_show (label_notebook_Info_Route);
  	gtk_box_pack_start (GTK_BOX (hbox_notebook_Info_Route), label_notebook_Info_Route, FALSE, FALSE, 0);
   	
	treeview_Info_Route = Create_Liste_Snmp(SNMP_NETWORK_ROUTES);
	gtk_widget_show (treeview_Info_Route);
	gtk_container_add (GTK_CONTAINER (scrolledwindow_Info_Route), treeview_Info_Route);
	gtk_tree_view_set_headers_visible (GTK_TREE_VIEW (treeview_Info_Route), TRUE);

	scrolledwindow_Info_Arp = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow_Info_Arp);
  	gtk_container_add (GTK_CONTAINER (notebook_Info), scrolledwindow_Info_Arp);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_Info_Arp), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
 
 	hbox_notebook_Info_Arp = gtk_hbox_new (FALSE, 0);
  	gtk_widget_show (hbox_notebook_Info_Arp);
	gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook_Info), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info), ONGLET_INFO_ARP), hbox_notebook_Info_Arp);

	image_notebook_Info_Arp = (GdkPixbuf *)Load_Pixmap ("Onglet/Arp.png");
  	gtk_widget_show ((GtkWidget *)image_notebook_Info_Arp);
  	gtk_box_pack_start (GTK_BOX (hbox_notebook_Info_Arp), (GtkWidget *)image_notebook_Info_Arp, TRUE, TRUE, 0);

  	label_notebook_Info_Arp = gtk_label_new ("Arp");
  	gtk_widget_show (label_notebook_Info_Arp);
  	gtk_box_pack_start (GTK_BOX (hbox_notebook_Info_Arp), label_notebook_Info_Arp, FALSE, FALSE, 0);
   	
	treeview_Info_Arp = Create_Liste_Snmp(SNMP_NETWORK_ARP);
	gtk_widget_show (treeview_Info_Arp);
	gtk_container_add (GTK_CONTAINER (scrolledwindow_Info_Arp), treeview_Info_Arp);
	gtk_tree_view_set_headers_visible (GTK_TREE_VIEW (treeview_Info_Arp), TRUE);
	
	scrolledwindow_Info_Peripherique = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow_Info_Peripherique);
  	gtk_container_add (GTK_CONTAINER (notebook_Info), scrolledwindow_Info_Peripherique);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_Info_Peripherique), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
 
  	hbox_notebook_Info_Peripherique = gtk_hbox_new (FALSE, 0);
  	gtk_widget_show (hbox_notebook_Info_Peripherique);
	gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook_Info), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info), ONGLET_INFO_PERIPHERIQUE), hbox_notebook_Info_Peripherique);

	image_notebook_Info_Peripherique = (GdkPixbuf *) Load_Pixmap ("Onglet/Peripherique.png");
  	gtk_widget_show ((GtkWidget *)image_notebook_Info_Peripherique);
  	gtk_box_pack_start (GTK_BOX (hbox_notebook_Info_Peripherique), (GtkWidget *)image_notebook_Info_Peripherique, TRUE, TRUE, 0);

  	label_notebook_Info_Peripherique = gtk_label_new ("Device");
  	gtk_widget_show (label_notebook_Info_Peripherique);
  	gtk_box_pack_start (GTK_BOX (hbox_notebook_Info_Peripherique), label_notebook_Info_Peripherique, FALSE, FALSE, 0);
   	
	treeview_Info_Peripherique = Create_Liste_Snmp(SNMP_SYSTEM_DEVICE);
	gtk_widget_show (treeview_Info_Peripherique);
	gtk_container_add (GTK_CONTAINER (scrolledwindow_Info_Peripherique), treeview_Info_Peripherique);
	gtk_tree_view_set_headers_visible (GTK_TREE_VIEW (treeview_Info_Peripherique), TRUE);


	scrolledwindow_Info_Service = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow_Info_Service);
  	gtk_container_add (GTK_CONTAINER (notebook_Info), scrolledwindow_Info_Service);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_Info_Service), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
 
 	hbox_notebook_Info_Service = gtk_hbox_new (FALSE, 0);
  	gtk_widget_show (hbox_notebook_Info_Service);
	gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook_Info), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info), ONGLET_INFO_SERVICE), hbox_notebook_Info_Service);

	image_notebook_Info_Service = (GdkPixbuf *)Load_Pixmap ("Onglet/Service.png");
  	gtk_widget_show ((GtkWidget *)image_notebook_Info_Service);
  	gtk_box_pack_start (GTK_BOX (hbox_notebook_Info_Service), (GtkWidget *)image_notebook_Info_Service, TRUE, TRUE, 0);

  	label_notebook_Info_Service = gtk_label_new ("Service");
  	gtk_widget_show (label_notebook_Info_Service);
  	gtk_box_pack_start (GTK_BOX (hbox_notebook_Info_Service), label_notebook_Info_Service, FALSE, FALSE, 0);
  	
	treeview_Info_Service = Create_Liste_Snmp(SNMP_SYSTEM_SERVICE);
	gtk_widget_show (treeview_Info_Service);
	gtk_container_add (GTK_CONTAINER (scrolledwindow_Info_Service), treeview_Info_Service);
	gtk_tree_view_set_headers_visible (GTK_TREE_VIEW (treeview_Info_Service), TRUE);

	scrolledwindow_Info_Interface = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow_Info_Interface);
  	gtk_container_add (GTK_CONTAINER (notebook_Info), scrolledwindow_Info_Interface);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_Info_Interface), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
 
 	hbox_notebook_Info_Interface = gtk_hbox_new (FALSE, 0);
  	gtk_widget_show (hbox_notebook_Info_Interface);
	gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook_Info), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info), ONGLET_INFO_INTERFACE), hbox_notebook_Info_Interface);

	image_notebook_Info_Interface = (GdkPixbuf *)Load_Pixmap ("Onglet/Interface.png");
  	gtk_widget_show ((GtkWidget *)image_notebook_Info_Interface);
  	gtk_box_pack_start (GTK_BOX (hbox_notebook_Info_Interface), (GtkWidget *)image_notebook_Info_Interface, TRUE, TRUE, 0);

  	label_notebook_Info_Interface = gtk_label_new ("Interface");
  	gtk_widget_show (label_notebook_Info_Interface);
  	gtk_box_pack_start (GTK_BOX (hbox_notebook_Info_Interface), label_notebook_Info_Interface, FALSE, FALSE, 0);
	  	
	treeview_Info_Interface = Create_Liste_Snmp(SNMP_NETWORK_INTERFACES_BASIC);
	gtk_widget_show (treeview_Info_Interface);
	gtk_container_add (GTK_CONTAINER (scrolledwindow_Info_Interface), treeview_Info_Interface);
	gtk_tree_view_set_headers_visible (GTK_TREE_VIEW (treeview_Info_Interface), TRUE);

	scrolledwindow_Info_Inventaire = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow_Info_Inventaire);
  	gtk_container_add (GTK_CONTAINER (notebook_Info), scrolledwindow_Info_Inventaire);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_Info_Inventaire), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
 
 	hbox_notebook_Info_Inventaire = gtk_hbox_new (FALSE, 0);
  	gtk_widget_show (hbox_notebook_Info_Inventaire);
	gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook_Info), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info), ONGLET_INFO_INVENTAIRE), hbox_notebook_Info_Inventaire);

	image_notebook_Info_Inventaire = (GdkPixbuf *)Load_Pixmap ("Onglet/Inventaire.png");
  	gtk_widget_show ((GtkWidget *)image_notebook_Info_Inventaire);
  	gtk_box_pack_start (GTK_BOX (hbox_notebook_Info_Inventaire), (GtkWidget *)image_notebook_Info_Inventaire, TRUE, TRUE, 0);

  	label_notebook_Info_Inventaire = gtk_label_new ("Inventory");
  	gtk_widget_show (label_notebook_Info_Inventaire);
  	gtk_box_pack_start (GTK_BOX (hbox_notebook_Info_Inventaire), label_notebook_Info_Inventaire, FALSE, FALSE, 0);
  		
	treeview_Info_Inventaire = Create_Liste (FALSE, FALSE, FALSE, TRUE, FALSE, FALSE,NULL);
	gtk_widget_show (treeview_Info_Inventaire);
	gtk_container_add (GTK_CONTAINER (scrolledwindow_Info_Inventaire), treeview_Info_Inventaire);
	gtk_tree_view_set_headers_visible (GTK_TREE_VIEW (treeview_Info_Inventaire), FALSE);

	scrolledwindow_Info_Historique = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow_Info_Historique);
  	gtk_container_add (GTK_CONTAINER (notebook_Info), scrolledwindow_Info_Historique);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_Info_Historique), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
 
 	hbox_notebook_Info_Historique = gtk_hbox_new (FALSE, 0);
  	gtk_widget_show (hbox_notebook_Info_Historique);
	gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook_Info), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info), ONGLET_INFO_HISTORIQUE), hbox_notebook_Info_Historique);

	image_notebook_Info_Historique = (GdkPixbuf *)Load_Pixmap ("Onglet/Historique.png");
  	gtk_widget_show ((GtkWidget *)image_notebook_Info_Historique);
  	gtk_box_pack_start (GTK_BOX (hbox_notebook_Info_Historique), (GtkWidget *)image_notebook_Info_Historique, TRUE, TRUE, 0);

  	label_notebook_Info_Historique = gtk_label_new ("History");
  	gtk_widget_show (label_notebook_Info_Historique);
  	gtk_box_pack_start (GTK_BOX (hbox_notebook_Info_Historique), label_notebook_Info_Historique, FALSE, FALSE, 0);
  	
	treeview_Info_Historique = Create_Liste (FALSE, FALSE, FALSE, TRUE, FALSE, FALSE,NULL);
	gtk_widget_show (treeview_Info_Historique);
	gtk_container_add (GTK_CONTAINER (scrolledwindow_Info_Historique), treeview_Info_Historique);
	gtk_tree_view_set_headers_visible (GTK_TREE_VIEW (treeview_Info_Historique), FALSE);


	vbox_Info_Debug_Daemon = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Info_Debug_Daemon);
	gtk_container_add (GTK_CONTAINER (notebook_Info), vbox_Info_Debug_Daemon);

	hbox_notebook_Info_Debug_Daemon = gtk_hbox_new (FALSE, 0);
  	gtk_widget_show (hbox_notebook_Info_Debug_Daemon);
	gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook_Info), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info), ONGLET_INFO_DEBUG_DAEMON), hbox_notebook_Info_Debug_Daemon);

	image_notebook_Info_Debug_Daemon = (GdkPixbuf *)Load_Pixmap ("Onglet/Inventaire.png");
  	gtk_widget_show ((GtkWidget *)image_notebook_Info_Debug_Daemon);
  	gtk_box_pack_start (GTK_BOX (hbox_notebook_Info_Debug_Daemon), (GtkWidget *)image_notebook_Info_Debug_Daemon, TRUE, TRUE, 0);

  	label_notebook_Info_Debug_Daemon = gtk_label_new ("Debug");
  	gtk_widget_show (label_notebook_Info_Debug_Daemon);
  	gtk_box_pack_start (GTK_BOX (hbox_notebook_Info_Debug_Daemon), label_notebook_Info_Debug_Daemon, FALSE, FALSE, 0);
  	
	scrolledwindow_Info_Debug_Daemon = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow_Info_Debug_Daemon);
  	gtk_box_pack_start (GTK_BOX (vbox_Info_Debug_Daemon), scrolledwindow_Info_Debug_Daemon, TRUE, TRUE, 0);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_Info_Debug_Daemon), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	
	treeview_Info_Debug_Daemon = Create_Liste (FALSE, FALSE, FALSE, TRUE, FALSE, FALSE,NULL);	
	gtk_widget_show (treeview_Info_Debug_Daemon);
	gtk_container_add (GTK_CONTAINER (scrolledwindow_Info_Debug_Daemon), treeview_Info_Debug_Daemon);
	gtk_tree_view_set_headers_visible (GTK_TREE_VIEW (treeview_Info_Debug_Daemon), FALSE);
	

	Button_Info_Debug_Daemon_Erreur_Inform = gtk_button_new ();
	gtk_widget_show (Button_Info_Debug_Daemon_Erreur_Inform);
	gtk_box_pack_start (GTK_BOX (vbox_Info_Debug_Daemon), Button_Info_Debug_Daemon_Erreur_Inform, FALSE, FALSE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (Button_Info_Debug_Daemon_Erreur_Inform), 3);

	alignment_Info_Debug_Daemon_Erreur_Inform = gtk_alignment_new (0.5, 0.5, 0, 0);
	gtk_widget_show (alignment_Info_Debug_Daemon_Erreur_Inform);
	gtk_container_add (GTK_CONTAINER (Button_Info_Debug_Daemon_Erreur_Inform), alignment_Info_Debug_Daemon_Erreur_Inform);

	hbox_Info_Debug_Daemon_Erreur_Inform = gtk_hbox_new (FALSE, 2);
	gtk_widget_show (hbox_Info_Debug_Daemon_Erreur_Inform);
	gtk_container_add (GTK_CONTAINER (alignment_Info_Debug_Daemon_Erreur_Inform), hbox_Info_Debug_Daemon_Erreur_Inform);

	image_Info_Debug_Daemon_Erreur_Inform = gtk_image_new_from_stock ("gtk-dialog-warning", GTK_ICON_SIZE_BUTTON);
	gtk_widget_show (image_Info_Debug_Daemon_Erreur_Inform);
	gtk_box_pack_start (GTK_BOX (hbox_Info_Debug_Daemon_Erreur_Inform), image_Info_Debug_Daemon_Erreur_Inform, FALSE, FALSE, 0);

	label_Info_Debug_Daemon_Erreur_Inform = gtk_label_new_with_mnemonic ("Inform developper");
	gtk_widget_show (label_Info_Debug_Daemon_Erreur_Inform);
	gtk_box_pack_start (GTK_BOX (hbox_Info_Debug_Daemon_Erreur_Inform), label_Info_Debug_Daemon_Erreur_Inform, FALSE, FALSE, 0);



	vbox_Milieu = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Milieu);
	gtk_paned_pack2 (GTK_PANED (vpaned_root), vbox_Milieu, TRUE, TRUE);



	hbox_Milieu = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Milieu);
	gtk_box_pack_start (GTK_BOX (vbox_Milieu), hbox_Milieu, FALSE, FALSE, 0);

	combobox_liste_Modules = creation_combo (TRUE,FALSE);
	gtk_box_pack_start (GTK_BOX (hbox_Milieu), combobox_liste_Modules, TRUE, TRUE, 0);
	gtk_widget_set_sensitive (combobox_liste_Modules, FALSE);

	fixed_milieu = gtk_fixed_new ();
	gtk_widget_show (fixed_milieu);
	gtk_box_pack_start (GTK_BOX (hbox_Milieu), fixed_milieu, TRUE, TRUE, 0);

	hbox_milieu = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_milieu);
	gtk_box_pack_start (GTK_BOX (hbox_Milieu), hbox_milieu, FALSE, FALSE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (hbox_milieu), 1);

	button_Erase = gtk_button_new ();
	gtk_widget_set_name (button_Erase, "button_Erase");
	gtk_widget_show (button_Erase);
	gtk_widget_set_sensitive (button_Erase, FALSE);
	gtk_box_pack_start (GTK_BOX (hbox_milieu), button_Erase, FALSE, FALSE, 0);
	gtk_button_set_relief (GTK_BUTTON (button_Erase), GTK_RELIEF_NONE);
	
	alignment_Erase = gtk_alignment_new (0.5, 0.5, 0, 0);
	gtk_widget_show (alignment_Erase);
	gtk_container_add (GTK_CONTAINER (button_Erase), alignment_Erase);

	hbox_Erase = gtk_hbox_new (FALSE, 2);
	gtk_widget_show (hbox_Erase);
	gtk_container_add (GTK_CONTAINER (alignment_Erase), hbox_Erase);

	image_Erase = Load_Pixmap ("eraser.png");
	gtk_widget_show (image_Erase);
	gtk_box_pack_start (GTK_BOX (hbox_Erase), image_Erase, FALSE, FALSE, 0);
	
	button_Refresh = gtk_button_new ();
	gtk_widget_set_name (button_Refresh, "button_Refresh");
	gtk_widget_show (button_Refresh);
	gtk_widget_set_sensitive (button_Refresh, FALSE);
	gtk_box_pack_start (GTK_BOX (hbox_milieu), button_Refresh, FALSE, FALSE, 0);
	gtk_button_set_relief (GTK_BUTTON (button_Refresh), GTK_RELIEF_NONE);

	alignment_Refresh = gtk_alignment_new (0.5, 0.5, 0, 0);
	gtk_widget_show (alignment_Refresh);
	gtk_container_add (GTK_CONTAINER (button_Refresh), alignment_Refresh);

	hbox_Refresh = gtk_hbox_new (FALSE, 2);
	gtk_widget_show (hbox_Refresh);
	gtk_container_add (GTK_CONTAINER (alignment_Refresh), hbox_Refresh);

	image_Refresh = Load_Pixmap ("reload.png");
	gtk_widget_show (image_Refresh);
	gtk_box_pack_start (GTK_BOX (hbox_Refresh), image_Refresh, FALSE, FALSE, 0);

	viewport_Modules = gtk_viewport_new (NULL, NULL);
	gtk_widget_show (viewport_Modules);
	gtk_box_pack_start (GTK_BOX (vbox_Milieu), viewport_Modules, TRUE, TRUE, 0);

	g_signal_connect ((gpointer) window_root, "delete_event", G_CALLBACK (on_window_root_delete_event), NULL);
	g_signal_connect ((gpointer) toolbutton_Add_Network, "clicked", G_CALLBACK (on_toolbutton_Add_Network_clicked), NULL);
	g_signal_connect ((gpointer) toolbutton_View, "clicked", G_CALLBACK (on_toolbutton_View), NULL);
	g_signal_connect ((gpointer) toolbutton_Save, "clicked", G_CALLBACK (on_toolbutton_Save_clicked), NULL);
	g_signal_connect ((gpointer) toolbutton_Search, "clicked", G_CALLBACK (on_toolbutton_Search_clicked), NULL);
	g_signal_connect ((gpointer) toolbutton_Settings, "clicked", G_CALLBACK (on_toolbutton_Settings_clicked), NULL);
	g_signal_connect ((gpointer) toggletoolbutton_Notification, "clicked", G_CALLBACK (on_toggletoolbutton_Notification_clicked), NULL);
	g_signal_connect ((gpointer) toggletoolbutton_Alert_Intrusion, "toggled", G_CALLBACK (on_toggletoolbutton_Alert_Intrusion_toggled), NULL);
	g_signal_connect ((gpointer) toolbutton_Help, "clicked", G_CALLBACK (on_toolbutton_Help_clicked), NULL);
	g_signal_connect ((gpointer) toolbutton_About, "clicked", G_CALLBACK (on_toolbutton_About_clicked), NULL);
	g_signal_connect ((gpointer)toolbutton_Console, "clicked", G_CALLBACK (on_toolbutton_toolbutton_Console), NULL);

	g_signal_connect ((gpointer) toolbutton_Exit, "clicked", G_CALLBACK (on_toolbutton_Exit_clicked), NULL);
	g_signal_connect ((gpointer) notebook_Info, "switch_page", G_CALLBACK (on_notebook_Info_switch_page), NULL);
	g_signal_connect ((gpointer) button_Erase, "clicked", G_CALLBACK (on_button_Erase_clicked), NULL);
	g_signal_connect ((gpointer) button_Refresh, "clicked", G_CALLBACK (on_button_Rafraichir_clicked), NULL);
	g_signal_connect ((gpointer) Button_Info_Debug_Daemon_Erreur_Inform, "clicked", G_CALLBACK (on_button_Debug_Daemon_Erreur_Inform), NULL);
   
#ifdef   __MAEMO
	g_signal_connect(G_OBJECT(window_root), "key_press_event", G_CALLBACK(key_press_maemo),window_root);
#endif
	Modification_Toggle_En_Cours = FALSE;
	gtk_widget_hide (vbox_Milieu);
	

	pixbuf_network_reload = Chargement_Image ("reload.png", COULEUR);

	/*pixbuf_inter_autoscan = Chargement_Image ("Inter-AutoScan.png", COULEUR);
	pixbuf_thread = Chargement_Image ("thread.png", COULEUR);*/
}
