/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2010 Thierry Lagarde <thierry@autoscan-network.com>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include <gtk/gtk.h>

#include "Settings_Callbacks.h"
#include "Settings_Interface.h"
#include "Open_Save_Interface.h"
#include "Open_Save_Callbacks.h"
#include "Settings_Signature.h"
#include "Settings_Port.h"
#include "Settings_Script.h"
#include "Debug.h"
#include "Settings.h"
#include "Settings_Restore.h"
#include "Debug.h"

gboolean on_dialog_Settings_delete_event (GtkWidget * widget, GdkEvent * event, gpointer user_data)
{
	return TRUE;
}


void on_radiobutton_General_Internet_Direct_clicked (GtkButton * button, gpointer user_data)
{
	gtk_widget_set_sensitive (spinbutton_General_Internet_Port, FALSE);
	gtk_widget_set_sensitive (entry_General_Internet_Http_Proxy, FALSE);
	gtk_widget_set_sensitive (entry_General_Internet_Url, FALSE);
}


void on_radiobutton_General_Internet_Http_Proxy_clicked (GtkButton * button, gpointer user_data)
{
	gtk_widget_set_sensitive (spinbutton_General_Internet_Port, TRUE);
	gtk_widget_set_sensitive (entry_General_Internet_Http_Proxy, TRUE);
	gtk_widget_set_sensitive (entry_General_Internet_Url, FALSE);
}


void on_radiobutton_General_Internet_Url_clicked (GtkButton * button, gpointer user_data)
{	
	gtk_widget_set_sensitive (spinbutton_General_Internet_Port, FALSE);
	gtk_widget_set_sensitive (entry_General_Internet_Http_Proxy, FALSE);
	gtk_widget_set_sensitive (entry_General_Internet_Url, TRUE);
}


void on_checkbutton_General_Internet_Authentication_clicked (GtkButton * button, gpointer user_data)
{
	DEBUG_INFO("toggle");
	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (button))) {
		gtk_widget_set_sensitive (entry_General_Internet_Authentication_Password, TRUE);
		gtk_widget_set_sensitive (entry_General_Internet_Authentication_User, TRUE);
	}
	else {
		gtk_widget_set_sensitive (entry_General_Internet_Authentication_Password, FALSE);
		gtk_widget_set_sensitive (entry_General_Internet_Authentication_User, FALSE);
	}
}



void on_button_Settings_Save_clicked (GtkButton * button, gpointer user_data)
{
	gtk_widget_hide (dialog_Settings);
	Enregistrement_Donnee_Xml_Signature ();
	Enregistrement_Donnee_Xml_Port ();
#ifdef         __SCRIPT_ENABLE
	Enregistrement_Donnee_Xml_Script ();
#endif
	Enregistrement_Donnee_Xml_Restore ();
	Enregistre_Champ_Connection_Internet ();
	Enregistre_Parametre_General ();
}


void Liste_Ports_changed (GtkEditable * editable, gpointer user_data)
{
	if (!Liste_Port_Modification_Interface) {
		gtk_widget_set_sensitive (button_Liste_Ports_Ok, TRUE);
		gtk_widget_set_sensitive (button_Liste_Ports_Cancel, TRUE);
		gtk_widget_set_sensitive (button_Liste_Ports_Add, FALSE);
		gtk_widget_set_sensitive (button_Liste_Ports_Delete, FALSE);
		gtk_widget_set_sensitive (button_Liste_Ports_Program_Add, TRUE);
		gtk_widget_set_sensitive (button_Liste_Ports_Program_Delete, FALSE);
		if (Port_Selectionner == NULL)
			DEBUG_WARNING("Port_Selectionner == NULL");
		Port_Modification = Port_Selectionner;
		Modification_Port_Program = FALSE;
	}
}


void Liste_Ports_changed_Program (GtkEditable * editable, gpointer user_data)
{
	if (!Liste_Port_Modification_Interface) {
		DEBUG_INFO("Liste_Port_Modification_Interface OK\n");
		gtk_widget_set_sensitive (button_Liste_Ports_Ok, TRUE);
		gtk_widget_set_sensitive (button_Liste_Ports_Cancel, TRUE);
		gtk_widget_set_sensitive (button_Liste_Ports_Add, FALSE);
		gtk_widget_set_sensitive (button_Liste_Ports_Delete, FALSE);
		gtk_widget_set_sensitive (button_Liste_Ports_Program_Add, FALSE);
		gtk_widget_set_sensitive (button_Liste_Ports_Program_Delete, FALSE);
		if (Port_Selectionner == NULL)
			DEBUG_WARNING("Port_Selectionner == NULL");
		Port_Modification = Port_Selectionner;
		Modification_Port_Program = TRUE;
	}
}


void on_button_Liste_Ports_Program_Add_clicked (GtkButton * button, gpointer user_data)
{
	Liste_Port_Sensible (FALSE);
	Liste_Port_Program_Sensible (TRUE);
	gtk_widget_set_sensitive (button_Liste_Ports_Ok, TRUE);
	gtk_widget_set_sensitive (button_Liste_Ports_Cancel, TRUE);
	gtk_widget_set_sensitive (button_Liste_Ports_Add, FALSE);
	gtk_widget_set_sensitive (button_Liste_Ports_Delete, FALSE);
	gtk_widget_set_sensitive (button_Liste_Ports_Program_Add, FALSE);
	gtk_widget_set_sensitive (button_Liste_Ports_Program_Delete, FALSE);
	Port_Modification = NULL;
}


void on_button_Liste_Ports_Program_Delete_clicked (GtkButton * button, gpointer user_data)
{
	Supprime_Port_liste (Port_Selectionner);
	Liste_Port_Efface_Champs ();
	Liste_Port_Sensible (FALSE);
	Liste_Port_Program_Sensible (FALSE);
	gtk_widget_set_sensitive (button_Liste_Ports_Ok, FALSE);
	gtk_widget_set_sensitive (button_Liste_Ports_Cancel, FALSE);
	gtk_widget_set_sensitive (button_Liste_Ports_Add, TRUE);
	gtk_widget_set_sensitive (button_Liste_Ports_Delete, FALSE);
	gtk_widget_set_sensitive (button_Liste_Ports_Program_Add, FALSE);
	gtk_widget_set_sensitive (button_Liste_Ports_Program_Delete, FALSE);
	Port_Selectionner = NULL;
	Port_Modification = NULL;
}


void on_button_Liste_Ports_Ok_clicked (GtkButton * button, gpointer user_data)
{
	Modifie_Ajoute_Nouveau_Port ();
	Liste_Port_Efface_Champs ();
	Liste_Port_Sensible (FALSE);
	Liste_Port_Program_Sensible (FALSE);
	gtk_widget_set_sensitive (button_Liste_Ports_Ok, FALSE);
	gtk_widget_set_sensitive (button_Liste_Ports_Cancel, FALSE);
	gtk_widget_set_sensitive (button_Liste_Ports_Add, TRUE);
	gtk_widget_set_sensitive (button_Liste_Ports_Delete, FALSE);
	gtk_widget_set_sensitive (button_Liste_Ports_Program_Add, FALSE);
	gtk_widget_set_sensitive (button_Liste_Ports_Program_Delete, FALSE);
	Port_Selectionner = NULL;
	Port_Modification = NULL;
}


void on_button_Liste_Ports_Cancel_clicked (GtkButton * button, gpointer user_data)
{
	Liste_Port_Efface_Champs ();
	Liste_Port_Sensible (FALSE);
	Liste_Port_Program_Sensible (FALSE);
	gtk_widget_set_sensitive (button_Liste_Ports_Ok, FALSE);
	gtk_widget_set_sensitive (button_Liste_Ports_Cancel, FALSE);
	gtk_widget_set_sensitive (button_Liste_Ports_Add, TRUE);
	gtk_widget_set_sensitive (button_Liste_Ports_Delete, FALSE);
	gtk_widget_set_sensitive (button_Liste_Ports_Program_Add, FALSE);
	gtk_widget_set_sensitive (button_Liste_Ports_Program_Delete, FALSE);
	Port_Selectionner = NULL;
	Port_Modification = NULL;
}


void on_button_Liste_Ports_Delete_clicked (GtkButton * button, gpointer user_data)
{
	Supprime_Port_liste (Port_Selectionner);
	Liste_Port_Efface_Champs ();
	Liste_Port_Sensible (FALSE);
	Liste_Port_Program_Sensible (FALSE);
	gtk_widget_set_sensitive (button_Liste_Ports_Ok, FALSE);
	gtk_widget_set_sensitive (button_Liste_Ports_Cancel, FALSE);
	gtk_widget_set_sensitive (button_Liste_Ports_Add, TRUE);
	gtk_widget_set_sensitive (button_Liste_Ports_Delete, FALSE);
	gtk_widget_set_sensitive (button_Liste_Ports_Program_Add, FALSE);
	gtk_widget_set_sensitive (button_Liste_Ports_Program_Delete, FALSE);
	Port_Selectionner = NULL;
	Port_Modification = NULL;
}


void on_button_Liste_Ports_Add_clicked (GtkButton * button, gpointer user_data)
{
	Liste_Port_Efface_Champs ();
	Liste_Port_Sensible (TRUE);
	Liste_Port_Program_Sensible (FALSE);
	gtk_widget_set_sensitive (button_Liste_Ports_Ok, FALSE);
	gtk_widget_set_sensitive (button_Liste_Ports_Cancel, FALSE);
	gtk_widget_set_sensitive (button_Liste_Ports_Add, TRUE);
	gtk_widget_set_sensitive (button_Liste_Ports_Delete, FALSE);
	gtk_widget_set_sensitive (button_Liste_Ports_Program_Add, FALSE);
	gtk_widget_set_sensitive (button_Liste_Ports_Program_Delete, FALSE);
	Port_Selectionner = NULL;
	Port_Modification = NULL;
}


void Liste_Signatures_changed (GtkEditable * editable, gpointer user_data)
{
	if (!Liste_Signatures_Modification_Interface) {
		gtk_widget_set_sensitive (button_Liste_Signature_Ok, TRUE);
		gtk_widget_set_sensitive (button_Liste_Signature_Cancel, TRUE);
		gtk_widget_set_sensitive (button_Liste_Signature_Add, FALSE);
		gtk_widget_set_sensitive (button_Liste_Signature_Delete, FALSE);
		gtk_widget_set_sensitive (button_Liste_Ports_Program_Add, FALSE);
		gtk_widget_set_sensitive (button_Liste_Ports_Program_Delete, FALSE);
		Signature_Modification = Signature_Selectionner;
	}
}


void on_button_Liste_Signature_Ok_clicked (GtkButton * button, gpointer user_data)
{
	Modifie_Ajoute_Nouvelle_Signature ();
	Liste_Signature_Efface_Champs ();
	Liste_Signature_Sensible (FALSE);
	gtk_widget_set_sensitive (button_Liste_Signature_Ok, FALSE);
	gtk_widget_set_sensitive (button_Liste_Signature_Cancel, FALSE);
	gtk_widget_set_sensitive (button_Liste_Signature_Add, TRUE);
	gtk_widget_set_sensitive (button_Liste_Signature_Delete, FALSE);
	gtk_widget_set_sensitive (button_Liste_Ports_Program_Add, FALSE);
	gtk_widget_set_sensitive (button_Liste_Ports_Program_Delete, FALSE);
	Signature_Selectionner = NULL;
	Signature_Modification = NULL;
}


void on_button_Liste_Signature_Cancel_clicked (GtkButton * button, gpointer user_data)
{
	Liste_Signature_Efface_Champs ();
	Liste_Signature_Sensible (FALSE);
	gtk_widget_set_sensitive (button_Liste_Signature_Ok, FALSE);
	gtk_widget_set_sensitive (button_Liste_Signature_Cancel, FALSE);
	gtk_widget_set_sensitive (button_Liste_Signature_Add, TRUE);
	gtk_widget_set_sensitive (button_Liste_Signature_Delete, FALSE);
	gtk_widget_set_sensitive (button_Liste_Ports_Program_Add, FALSE);
	gtk_widget_set_sensitive (button_Liste_Ports_Program_Delete, FALSE);
	Signature_Selectionner = NULL;
	Signature_Modification = NULL;
}


void on_button_Liste_Signature_Delete_clicked (GtkButton * button, gpointer user_data)
{
	Supprime_Signature_liste (Signature_Selectionner);
	Liste_Signature_Efface_Champs ();
	Liste_Signature_Sensible (FALSE);
	gtk_widget_set_sensitive (button_Liste_Signature_Ok, FALSE);
	gtk_widget_set_sensitive (button_Liste_Signature_Cancel, FALSE);
	gtk_widget_set_sensitive (button_Liste_Signature_Add, TRUE);
	gtk_widget_set_sensitive (button_Liste_Signature_Delete, FALSE);
	gtk_widget_set_sensitive (button_Liste_Ports_Program_Add, FALSE);
	gtk_widget_set_sensitive (button_Liste_Ports_Program_Delete, FALSE);
	Signature_Modification = NULL;
	Signature_Selectionner = NULL;
}


void on_button_Liste_Signature_Add_clicked (GtkButton * button, gpointer user_data)
{
	Liste_Signature_Efface_Champs ();
	Liste_Signature_Sensible (TRUE);
	gtk_widget_set_sensitive (entry_Liste_Signature_Md5, TRUE);
	gtk_widget_set_sensitive (button_Liste_Signature_Ok, TRUE);
	gtk_widget_set_sensitive (button_Liste_Signature_Cancel, TRUE);
	gtk_widget_set_sensitive (button_Liste_Signature_Add, FALSE);
	gtk_widget_set_sensitive (button_Liste_Signature_Delete, FALSE);
	gtk_widget_set_sensitive (button_Liste_Ports_Program_Add, FALSE);
	gtk_widget_set_sensitive (button_Liste_Ports_Program_Delete, FALSE);
	Signature_Selectionner = NULL;
	Signature_Modification = NULL;
}



void Liste_Script_changed (GtkEditable * editable, gpointer user_data)
{
#ifdef         __SCRIPT_ENABLE
	if (!Liste_Script_Modification_Interface) {
		gtk_widget_set_sensitive (button_Liste_Scripts_Add, FALSE);
		gtk_widget_set_sensitive (button_Liste_Scripts_Delete, FALSE);
		gtk_widget_set_sensitive (button_Liste_Scripts_Ok, TRUE);
		gtk_widget_set_sensitive (button_Liste_Scripts_Cancel, TRUE);
		Script_Modification = Script_Selectionner;
	}
#endif
}


void on_button_Liste_Scripts_Add_clicked (GtkButton * button, gpointer user_data)
{
#ifdef         __SCRIPT_ENABLE
	Liste_Script_Efface_Champs ();
	Liste_Script_Sensible (TRUE);
	gtk_widget_set_sensitive (button_Liste_Scripts_Add, FALSE);
	gtk_widget_set_sensitive (button_Liste_Scripts_Delete, FALSE);
	gtk_widget_set_sensitive (button_Liste_Scripts_Ok, TRUE);
	gtk_widget_set_sensitive (button_Liste_Scripts_Cancel, TRUE);
	Script_Modification = NULL;
	Script_Selectionner = NULL;
#endif
}


void on_button_Liste_Scripts_Delete_clicked (GtkButton * button, gpointer user_data)
{
#ifdef         __SCRIPT_ENABLE
	Supprime_Script_liste (Script_Selectionner);
	Liste_Script_Efface_Champs ();
	Liste_Script_Sensible (FALSE);
	gtk_widget_set_sensitive (button_Liste_Scripts_Add, TRUE);
	gtk_widget_set_sensitive (button_Liste_Scripts_Delete, FALSE);
	gtk_widget_set_sensitive (button_Liste_Scripts_Ok, FALSE);
	gtk_widget_set_sensitive (button_Liste_Scripts_Cancel, FALSE);
	Script_Modification = NULL;
	Script_Selectionner = NULL;
#endif
}


void on_button_Liste_Scripts_Ok_clicked (GtkButton * button, gpointer user_data)
{
#ifdef         __SCRIPT_ENABLE
	Modifie_Ajoute_Nouveau_Script ();
	Liste_Script_Efface_Champs ();
	Liste_Script_Sensible (FALSE);
	gtk_widget_set_sensitive (button_Liste_Scripts_Add, TRUE);
	gtk_widget_set_sensitive (button_Liste_Scripts_Delete, FALSE);
	gtk_widget_set_sensitive (button_Liste_Scripts_Ok, FALSE);
	gtk_widget_set_sensitive (button_Liste_Scripts_Cancel, FALSE);
	Script_Modification = NULL;
	Script_Selectionner = NULL;
#endif
}


void on_button_Liste_Scripts_Cancel_clicked (GtkButton * button, gpointer user_data)
{
#ifdef         __SCRIPT_ENABLE
	Liste_Script_Efface_Champs ();
	Liste_Script_Sensible (FALSE);
	gtk_widget_set_sensitive (button_Liste_Scripts_Add, TRUE);
	gtk_widget_set_sensitive (button_Liste_Scripts_Delete, FALSE);
	gtk_widget_set_sensitive (button_Liste_Scripts_Ok, FALSE);
	gtk_widget_set_sensitive (button_Liste_Scripts_Cancel, FALSE);
	Script_Modification = NULL;
	Script_Selectionner = NULL;
#endif
}


gboolean on_treeview_Liste_Restore_button_press_event (GtkWidget * widget, GdkEventButton * event, gpointer user_data)
{

	return FALSE;
}


void Liste_Restore_changed (GtkEditable * editable, gpointer user_data)
{
	if (!Liste_Restore_Modification_Interface) {
		gtk_widget_set_sensitive (button_Liste_Restore_Add, FALSE);
		gtk_widget_set_sensitive (button_Liste_Restore_Delete, FALSE);
		gtk_widget_set_sensitive (button_Liste_Restore_Ok, TRUE);
		gtk_widget_set_sensitive (button_Liste_Restore_Cancel, TRUE);
		Restore_Modification = Restore_Selectionner;
	}
}


void on_button_Liste_Restore_Add_clicked (GtkButton * button, gpointer user_data)
{
	Liste_Restore_Efface_Champs ();
	Liste_Restore_Sensible (TRUE);
	gtk_widget_set_sensitive (button_Liste_Restore_Add, FALSE);
	gtk_widget_set_sensitive (button_Liste_Restore_Delete, FALSE);
	gtk_widget_set_sensitive (button_Liste_Restore_Ok, TRUE);
	gtk_widget_set_sensitive (button_Liste_Restore_Cancel, TRUE);
	Restore_Modification = NULL;
	Restore_Selectionner = NULL;
}


void on_button_Liste_Restore_Delete_clicked (GtkButton * button, gpointer user_data)
{
	Supprime_Restore_liste (Restore_Selectionner);
	Liste_Restore_Efface_Champs ();
	Liste_Restore_Sensible (FALSE);
	gtk_widget_set_sensitive (button_Liste_Restore_Add, TRUE);
	gtk_widget_set_sensitive (button_Liste_Restore_Delete, FALSE);
	gtk_widget_set_sensitive (button_Liste_Restore_Ok, FALSE);
	gtk_widget_set_sensitive (button_Liste_Restore_Cancel, FALSE);
	Restore_Modification = NULL;
	Restore_Selectionner = NULL;
}


void on_button_Liste_Restore_Ok_clicked (GtkButton * button, gpointer user_data)
{
	if (strlen((gtk_entry_get_text (GTK_ENTRY (entry_Liste_Restore))))!=0){
		Modifie_Ajoute_Nouveau_Restore ();
		Liste_Restore_Efface_Champs ();
		Liste_Restore_Sensible (FALSE);
		gtk_widget_set_sensitive (button_Liste_Restore_Add, TRUE);
		gtk_widget_set_sensitive (button_Liste_Restore_Delete, FALSE);
		gtk_widget_set_sensitive (button_Liste_Restore_Ok, FALSE);
		gtk_widget_set_sensitive (button_Liste_Restore_Cancel, FALSE);
		Restore_Modification = NULL;
		Restore_Selectionner = NULL;
	}
}


void on_button_Liste_Restore_Cancel_clicked (GtkButton * button, gpointer user_data)
{
	Liste_Restore_Efface_Champs ();
	Liste_Restore_Sensible (FALSE);
	gtk_widget_set_sensitive (button_Liste_Restore_Add, TRUE);
	gtk_widget_set_sensitive (button_Liste_Restore_Delete, FALSE);
	gtk_widget_set_sensitive (button_Liste_Restore_Ok, FALSE);
	gtk_widget_set_sensitive (button_Liste_Restore_Cancel, FALSE);
	Restore_Modification = NULL;
	Restore_Selectionner = NULL;
}


void      on_button_Liste_Restore_Open_clicked (GtkButton * button, gpointer user_data){
	create_file_Open ();	
	gtk_widget_show (file_Open);
	entry_Open_File = entry_Liste_Restore; 
	if (strlen(gtk_entry_get_text (GTK_ENTRY (entry_Liste_Restore)))!=0){
		gtk_file_chooser_select_filename  (GTK_FILE_CHOOSER (file_Open), gtk_entry_get_text (GTK_ENTRY (entry_Liste_Restore)));
	}
}



void      on_button_Liste_Ports_Program_Path_Open_clicked (GtkButton * button, gpointer user_data){
	create_file_Open ();
	gtk_widget_show (file_Open);
	entry_Open_File = entry_Liste_Ports_Program_Path; 
	if (strlen(gtk_entry_get_text (GTK_ENTRY (entry_Liste_Ports_Program_Path)))!=0){
		gtk_file_chooser_select_filename  (GTK_FILE_CHOOSER (file_Open), gtk_entry_get_text (GTK_ENTRY (entry_Liste_Ports_Program_Path)));
	}
}

#ifdef         __SCRIPT_ENABLE
void      on_button_Liste_Scripts_Path_Open_clicked (GtkButton * button, gpointer user_data){
	create_file_Open ();
	gtk_widget_show (file_Open);
	entry_Open_File = entry_Liste_Scripts_Path; 
	if (strlen(gtk_entry_get_text (GTK_ENTRY (entry_Liste_Scripts_Path)))!=0){
		gtk_file_chooser_select_filename  (GTK_FILE_CHOOSER (file_Open), gtk_entry_get_text (GTK_ENTRY (entry_Liste_Scripts_Path)));
	}
}
#endif
