/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2010 Thierry Lagarde <thierry@autoscan-network.com>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include <gtk/gtk.h>

#include "Root_Interface.h"
#include "Settings_Callbacks.h"
#include "Settings_Interface.h"
#include "Maemo.h"
#include "Declaration_Constante.h"
#include "Settings_Signature.h"
#include "Settings_Port.h"
#include "Settings_Script.h"
#include "Settings_Restore.h"
#include "Combo.h"
#include "Configuration.h"

void create_dialog_Settings (void)
{

	GSList   *radiobutton_General_Internet_Direct_group = NULL;

	dialog_Settings = gtk_dialog_new ();
#ifndef         __MAEMO
	gtk_widget_set_size_request (dialog_Settings, Config_Setting_Size_X, Config_Setting_Size_Y);
#else
	gtk_widget_set_size_request (dialog_Settings, 800, 640);
#endif
	gtk_window_set_title (GTK_WINDOW (dialog_Settings), "Settings");
	gtk_window_set_modal (GTK_WINDOW (dialog_Settings), TRUE);
	gtk_window_set_position (GTK_WINDOW (dialog_Settings), GTK_WIN_POS_CENTER_ON_PARENT);
	gtk_window_set_transient_for (GTK_WINDOW (dialog_Settings), GTK_WINDOW (window_root));
	gtk_window_set_policy (GTK_WINDOW (dialog_Settings), TRUE, TRUE, FALSE);
	dialog_Settings_icon_pixbuf = (GdkPixbuf *) Load_Pixbuf("AutoScan.png");
	if (dialog_Settings_icon_pixbuf) {
		gtk_window_set_icon (GTK_WINDOW (dialog_Settings), dialog_Settings_icon_pixbuf);
		gdk_pixbuf_unref (dialog_Settings_icon_pixbuf);
	}
	gtk_window_set_type_hint (GTK_WINDOW (dialog_Settings), GDK_WINDOW_TYPE_HINT_DIALOG);

	dialog_vbox_Settings = GTK_DIALOG (dialog_Settings)->vbox;
	gtk_widget_show (dialog_vbox_Settings);

	notebook_Settings = gtk_notebook_new ();
	gtk_widget_show (notebook_Settings);
	gtk_box_pack_start (GTK_BOX (dialog_vbox_Settings), notebook_Settings, TRUE, TRUE, 0);
	gtk_notebook_set_tab_pos (GTK_NOTEBOOK (notebook_Settings), GTK_POS_LEFT);
	gtk_notebook_set_scrollable (GTK_NOTEBOOK (notebook_Settings), TRUE);

	scrolledwindow_General = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow_General);
	gtk_container_add (GTK_CONTAINER (notebook_Settings), scrolledwindow_General);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_General), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

	viewport_General = gtk_viewport_new (NULL, NULL);
	gtk_widget_show (viewport_General);
	gtk_container_add (GTK_CONTAINER (scrolledwindow_General), viewport_General);
	gtk_viewport_set_shadow_type (GTK_VIEWPORT (viewport_General), GTK_SHADOW_NONE);

	vbox_General = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_General);
	gtk_container_add (GTK_CONTAINER (viewport_General), vbox_General);

	frame_General_Interface = gtk_frame_new (NULL);
	gtk_widget_show (frame_General_Interface);
	gtk_box_pack_start (GTK_BOX (vbox_General), frame_General_Interface, FALSE, TRUE, 0);

	alignment_General_Interface = gtk_alignment_new (0.5, 0.5, 1, 1);
	gtk_widget_show (alignment_General_Interface);
	gtk_container_add (GTK_CONTAINER (frame_General_Interface), alignment_General_Interface);
	gtk_alignment_set_padding (GTK_ALIGNMENT (alignment_General_Interface), 0, 0, 12, 0);

	vbox_General_General = gtk_vbox_new (TRUE, 0);
	gtk_widget_show (vbox_General_General);
	gtk_container_add (GTK_CONTAINER (alignment_General_Interface), vbox_General_General);


#ifdef         __EGGTRAYICON_ENABLE
	checkbutton_General_Interface_TrayIcon = gtk_check_button_new_with_mnemonic ("Minimize to trayicon");
	gtk_widget_show (checkbutton_General_Interface_TrayIcon);
	gtk_box_pack_start (GTK_BOX (vbox_General_General), checkbutton_General_Interface_TrayIcon, FALSE, FALSE, 0);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_General_Interface_TrayIcon), Config_Minimized_Tray_Icon);

	checkbutton_General_Interface_Minimized = gtk_check_button_new_with_mnemonic ("Start minimized");
	gtk_widget_show (checkbutton_General_Interface_Minimized);
	gtk_box_pack_start (GTK_BOX (vbox_General_General), checkbutton_General_Interface_Minimized, FALSE, FALSE, 0);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_General_Interface_Minimized), Config_Start_Minimized);
#endif

	hbox_General_SMTP = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_General_SMTP);
	gtk_box_pack_start (GTK_BOX (vbox_General_General), hbox_General_SMTP, TRUE, TRUE, 0);

	label_General_SMTP = gtk_label_new ("SMTP : ");
	gtk_widget_show (label_General_SMTP);
	gtk_box_pack_start (GTK_BOX (hbox_General_SMTP), label_General_SMTP, FALSE, FALSE, 0);

	entry_General_SMTP = gtk_entry_new ();
	gtk_widget_show (entry_General_SMTP);
	gtk_box_pack_start (GTK_BOX (hbox_General_SMTP), entry_General_SMTP, FALSE, TRUE, 0);
	gtk_entry_set_text (GTK_ENTRY (entry_General_SMTP), Config_Server_Smtp);

#ifdef  __SOUND_ENABLE
	hbox_General_Audio_Device = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_General_Audio_Device);
	gtk_box_pack_start (GTK_BOX (vbox_General_General), hbox_General_Audio_Device, TRUE, TRUE, 0);

	label_General_Audio_Device = gtk_label_new ("Audio device : ");
	gtk_widget_show (label_General_Audio_Device);
	gtk_box_pack_start (GTK_BOX (hbox_General_Audio_Device), label_General_Audio_Device, FALSE, FALSE, 0);

	combobox_General_Audio_Device = creation_combo (FALSE,FALSE);
	creation_combo_Audio_Device ();
	gtk_widget_show (combobox_General_Audio_Device);
	gtk_box_pack_start (GTK_BOX (hbox_General_Audio_Device), combobox_General_Audio_Device, FALSE, TRUE, 0);
#endif

	label_General_Interface = gtk_label_new ("General");
	gtk_widget_show (label_General_Interface);
	gtk_frame_set_label_widget (GTK_FRAME (frame_General_Interface), label_General_Interface);
	gtk_label_set_use_markup (GTK_LABEL (label_General_Interface), TRUE);

	/*frame_General_Internet = gtk_frame_new (NULL);
	gtk_widget_show (frame_General_Internet);
	gtk_box_pack_start (GTK_BOX (vbox_General), frame_General_Internet, FALSE, TRUE, 5);

	alignment_General_Internet = gtk_alignment_new (0.5, 0.5, 1, 1);
	gtk_widget_show (alignment_General_Internet);
	gtk_container_add (GTK_CONTAINER (frame_General_Internet), alignment_General_Internet);
	gtk_alignment_set_padding (GTK_ALIGNMENT (alignment_General_Internet), 0, 0, 12, 0);

	vbox_General_Connection = gtk_vbox_new (TRUE, 0);
	gtk_widget_show (vbox_General_Connection);
	gtk_container_add (GTK_CONTAINER (alignment_General_Internet), vbox_General_Connection);

	radiobutton_General_Internet_Direct = gtk_radio_button_new_with_mnemonic (NULL, "Direct connection to the Internet");
	gtk_widget_show (radiobutton_General_Internet_Direct);
	gtk_box_pack_start (GTK_BOX (vbox_General_Connection), radiobutton_General_Internet_Direct, FALSE, FALSE, 1);
	gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobutton_General_Internet_Direct), radiobutton_General_Internet_Direct_group);
	radiobutton_General_Internet_Direct_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton_General_Internet_Direct));

	radiobutton_General_Internet_Http_Proxy = gtk_radio_button_new_with_mnemonic (NULL, "Manual proxy configuration");
	gtk_widget_show (radiobutton_General_Internet_Http_Proxy);
	gtk_box_pack_start (GTK_BOX (vbox_General_Connection), radiobutton_General_Internet_Http_Proxy, FALSE, FALSE, 0);
	gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobutton_General_Internet_Http_Proxy), radiobutton_General_Internet_Direct_group);
	radiobutton_General_Internet_Direct_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton_General_Internet_Http_Proxy));
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (radiobutton_General_Internet_Http_Proxy), TRUE);

	hbox_General_Connection_Manual = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_General_Connection_Manual);
	gtk_box_pack_start (GTK_BOX (vbox_General_Connection), hbox_General_Connection_Manual, TRUE, TRUE, 0);

	label_General_Internet_Http_Proxy = gtk_label_new ("HTTP Proxy :");
	gtk_widget_show (label_General_Internet_Http_Proxy);
	gtk_box_pack_start (GTK_BOX (hbox_General_Connection_Manual), label_General_Internet_Http_Proxy, FALSE, FALSE, 10);

	entry_General_Internet_Http_Proxy = gtk_entry_new ();
	gtk_widget_show (entry_General_Internet_Http_Proxy);
	gtk_box_pack_start (GTK_BOX (hbox_General_Connection_Manual), entry_General_Internet_Http_Proxy, FALSE, TRUE, 0);
	gtk_editable_set_editable (GTK_EDITABLE (entry_General_Internet_Http_Proxy), TRUE);

	label_General_Internet_Port = gtk_label_new ("Port :");
	gtk_widget_show (label_General_Internet_Port);
	gtk_box_pack_start (GTK_BOX (hbox_General_Connection_Manual), label_General_Internet_Port, FALSE, FALSE, 10);

	spinbutton_General_Internet_Port_adj = gtk_adjustment_new (8080, 1, 65535, 1, 10, 10);
	spinbutton_General_Internet_Port = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_General_Internet_Port_adj), 1, 0);
	gtk_widget_show (spinbutton_General_Internet_Port);
	gtk_box_pack_start (GTK_BOX (hbox_General_Connection_Manual), spinbutton_General_Internet_Port, FALSE, TRUE, 0);

	radiobutton_General_Internet_Url = gtk_radio_button_new_with_mnemonic (NULL, "Automatic proxy configuration");
	gtk_widget_show (radiobutton_General_Internet_Url);
	gtk_box_pack_start (GTK_BOX (vbox_General_Connection), radiobutton_General_Internet_Url, FALSE, FALSE, 0);
	gtk_radio_button_set_group (GTK_RADIO_BUTTON (radiobutton_General_Internet_Url), radiobutton_General_Internet_Direct_group);
	radiobutton_General_Internet_Direct_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton_General_Internet_Url));

	hbox_General_Connection_Auto = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_General_Connection_Auto);
	gtk_box_pack_start (GTK_BOX (vbox_General_Connection), hbox_General_Connection_Auto, TRUE, TRUE, 0);

	label_Generel_Internet_Url = gtk_label_new ("URL :");
	gtk_widget_show (label_Generel_Internet_Url);
	gtk_box_pack_start (GTK_BOX (hbox_General_Connection_Auto), label_Generel_Internet_Url, FALSE, FALSE, 14);

	entry_General_Internet_Url = gtk_entry_new ();
	gtk_widget_show (entry_General_Internet_Url);
	gtk_box_pack_start (GTK_BOX (hbox_General_Connection_Auto), entry_General_Internet_Url, FALSE, TRUE, 0);
	gtk_editable_set_editable (GTK_EDITABLE (entry_General_Internet_Url), TRUE);

	checkbutton_General_Internet_Authentication = gtk_check_button_new_with_mnemonic ("Authentication");
	gtk_widget_show (checkbutton_General_Internet_Authentication);
	gtk_box_pack_start (GTK_BOX (vbox_General_Connection), checkbutton_General_Internet_Authentication, FALSE, FALSE, 0);

	hbox_General_Connection_Authentication_User = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_General_Connection_Authentication_User);
	gtk_box_pack_start (GTK_BOX (vbox_General_Connection), hbox_General_Connection_Authentication_User, TRUE, TRUE, 0);

	label_General_Internet_Authentication_User = gtk_label_new ("User :");
	gtk_widget_show (label_General_Internet_Authentication_User);
	gtk_box_pack_start (GTK_BOX (hbox_General_Connection_Authentication_User), label_General_Internet_Authentication_User, FALSE, FALSE, 15);

	entry_General_Internet_Authentication_User = gtk_entry_new ();
	gtk_widget_show (entry_General_Internet_Authentication_User);
	gtk_box_pack_start (GTK_BOX (hbox_General_Connection_Authentication_User), entry_General_Internet_Authentication_User, FALSE, TRUE, 0);
	gtk_editable_set_editable (GTK_EDITABLE (entry_General_Internet_Authentication_User), TRUE);

	hbox_General_Connection_Authentication_Password = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_General_Connection_Authentication_Password);
	gtk_box_pack_start (GTK_BOX (vbox_General_Connection), hbox_General_Connection_Authentication_Password, FALSE, TRUE, 0);

	label_General_Internet_Authentication_Password = gtk_label_new ("Password : ");
	gtk_widget_show (label_General_Internet_Authentication_Password);
	gtk_box_pack_start (GTK_BOX (hbox_General_Connection_Authentication_Password), label_General_Internet_Authentication_Password, FALSE, FALSE, 0);

	entry_General_Internet_Authentication_Password = gtk_entry_new ();
	gtk_widget_show (entry_General_Internet_Authentication_Password);
	gtk_box_pack_start (GTK_BOX (hbox_General_Connection_Authentication_Password), entry_General_Internet_Authentication_Password, FALSE, TRUE, 0);
	gtk_editable_set_editable (GTK_EDITABLE (entry_General_Internet_Authentication_Password), TRUE);
	gtk_entry_set_visibility (GTK_ENTRY (entry_General_Internet_Authentication_Password), FALSE);

	label_General_Internet = gtk_label_new ("Connection to the Internet");
	gtk_widget_show (label_General_Internet);
	gtk_frame_set_label_widget (GTK_FRAME (frame_General_Internet), label_General_Internet);
	gtk_label_set_use_markup (GTK_LABEL (label_General_Internet), TRUE);*/

	vbox_General_Icone = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_General_Icone);
	gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook_Settings), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Settings), 0), vbox_General_Icone);

	image_General = (GtkWidget *)Load_Pixmap ("configure.png");
	gtk_widget_show (image_General);
	gtk_box_pack_start (GTK_BOX (vbox_General_Icone), image_General, TRUE, TRUE, 0);

	label_General = gtk_label_new ("General");
	gtk_widget_show (label_General);
	gtk_box_pack_start (GTK_BOX (vbox_General_Icone), label_General, FALSE, FALSE, 0);

	scrolledwindow_Liste_Ports_Root = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow_Liste_Ports_Root);
	gtk_container_add (GTK_CONTAINER (notebook_Settings), scrolledwindow_Liste_Ports_Root);
	gtk_widget_set_size_request (scrolledwindow_Liste_Ports_Root, 51, 70);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_Liste_Ports_Root), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

	viewport_Liste_Ports = gtk_viewport_new (NULL, NULL);
	gtk_widget_show (viewport_Liste_Ports);
	gtk_container_add (GTK_CONTAINER (scrolledwindow_Liste_Ports_Root), viewport_Liste_Ports);
	gtk_viewport_set_shadow_type (GTK_VIEWPORT (viewport_Liste_Ports), GTK_SHADOW_NONE);

	vbox_Liste_Ports = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Liste_Ports);
	gtk_container_add (GTK_CONTAINER (viewport_Liste_Ports), vbox_Liste_Ports);

	scrolledwindow_Liste_Ports = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow_Liste_Ports);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports), scrolledwindow_Liste_Ports, TRUE, TRUE, 0);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_Liste_Ports), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow_Liste_Ports), GTK_SHADOW_IN);


	Create_Liste_Port ();
	gtk_widget_show (treeview_Liste_Ports);
	gtk_container_add (GTK_CONTAINER (scrolledwindow_Liste_Ports), treeview_Liste_Ports);
	gtk_tree_view_set_enable_search (GTK_TREE_VIEW (treeview_Liste_Ports), FALSE);

	hbox_Liste_Ports = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Ports);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports), hbox_Liste_Ports, FALSE, TRUE, 0);

	frame_Liste_Ports = gtk_frame_new (NULL);
	gtk_widget_show (frame_Liste_Ports);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports), frame_Liste_Ports, TRUE, TRUE, 0);

	vbox_Liste_Ports_Change = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Liste_Ports_Change);
	gtk_container_add (GTK_CONTAINER (frame_Liste_Ports), vbox_Liste_Ports_Change);

	hbox_Liste_Ports_Change = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Ports_Change);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports_Change), hbox_Liste_Ports_Change, FALSE, TRUE, 0);

	vbox_Liste_Ports_Change_Port = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Liste_Ports_Change_Port);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports_Change), vbox_Liste_Ports_Change_Port, TRUE, TRUE, 0);

	hbox_Liste_Ports_Change_Port_Port = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Ports_Change_Port_Port);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports_Change_Port), hbox_Liste_Ports_Change_Port_Port, FALSE, TRUE, 2);

	label_Liste_Ports_Info_Port = gtk_label_new ("Port :");
	gtk_widget_show (label_Liste_Ports_Info_Port);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports_Change_Port_Port), label_Liste_Ports_Info_Port, FALSE, FALSE, 20);

	spinbutton_Liste_Ports_Info_Port_adj = gtk_adjustment_new (1, 0, 65535, 1, 10, 10);
	spinbutton_Liste_Ports_Info_Port = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_Liste_Ports_Info_Port_adj), 1, 0);
	gtk_widget_show (spinbutton_Liste_Ports_Info_Port);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports_Change_Port_Port), spinbutton_Liste_Ports_Info_Port, FALSE, TRUE, 0);

	label_Liste_Ports_Info_Type = gtk_label_new ("Type :");
	gtk_widget_show (label_Liste_Ports_Info_Type);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports_Change_Port_Port), label_Liste_Ports_Info_Type, FALSE, FALSE, 6);

	combobox_Liste_Ports_Info_Type = creation_combo (FALSE,FALSE);
	creation_combo_type_port ();
	gtk_widget_show (combobox_Liste_Ports_Info_Type);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports_Change_Port_Port), combobox_Liste_Ports_Info_Type, FALSE, TRUE, 6);

	hbox_Liste_Ports_Change_Port_Service = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Ports_Change_Port_Service);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports_Change_Port), hbox_Liste_Ports_Change_Port_Service, FALSE, TRUE, 2);

	label_Liste_Ports_Info_Service = gtk_label_new ("Service : ");
	gtk_widget_show (label_Liste_Ports_Info_Service);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports_Change_Port_Service), label_Liste_Ports_Info_Service, FALSE, FALSE, 11);

	entry_Liste_Ports_Info_Service = gtk_entry_new ();
	gtk_widget_show (entry_Liste_Ports_Info_Service);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports_Change_Port_Service), entry_Liste_Ports_Info_Service, TRUE, TRUE, 0);

	hbox_Liste_Ports_Change_Port_Description = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Ports_Change_Port_Description);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports_Change_Port), hbox_Liste_Ports_Change_Port_Description, FALSE, TRUE, 2);

	label_Liste_Ports_Info_Description = gtk_label_new ("Description : ");
	gtk_widget_show (label_Liste_Ports_Info_Description);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports_Change_Port_Description), label_Liste_Ports_Info_Description, FALSE, FALSE, 2);

	entry_Liste_Ports_Info_Description = gtk_entry_new ();
	gtk_widget_show (entry_Liste_Ports_Info_Description);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports_Change_Port_Description), entry_Liste_Ports_Info_Description, TRUE, TRUE, 0);

	vbox_Liste_Ports_Change_Port_Icon = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Liste_Ports_Change_Port_Icon);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports_Change), vbox_Liste_Ports_Change_Port_Icon, FALSE, TRUE, 8);

	fixed_Liste_Ports_Change_Port_Icon_Haut = gtk_fixed_new ();
	gtk_widget_show (fixed_Liste_Ports_Change_Port_Icon_Haut);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports_Change_Port_Icon), fixed_Liste_Ports_Change_Port_Icon_Haut, TRUE, TRUE, 0);


	combobox_Liste_Ports_Info = creation_combo (FALSE,FALSE);
	Creation_Combo_Liste_Fichier_Image (combobox_Liste_Ports_Info, "Port/", TRUE);
	gtk_widget_show (combobox_Liste_Ports_Info);	
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports_Change_Port_Icon), combobox_Liste_Ports_Info, FALSE, FALSE, 0);

	fixed_Liste_Ports_Change_Port_Icon_Bas = gtk_fixed_new ();
	gtk_widget_show (fixed_Liste_Ports_Change_Port_Icon_Bas);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports_Change_Port_Icon), fixed_Liste_Ports_Change_Port_Icon_Bas, TRUE, TRUE, 0);

	frame_Liste_Ports_Program = gtk_frame_new (NULL);
	gtk_widget_show (frame_Liste_Ports_Program);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports_Change), frame_Liste_Ports_Program, FALSE, TRUE, 0);

	hbox_Liste_Ports_Change_Program = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Ports_Change_Program);
	gtk_container_add (GTK_CONTAINER (frame_Liste_Ports_Program), hbox_Liste_Ports_Change_Program);

	vbox_Liste_Ports_Change_Program_Program = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Liste_Ports_Change_Program_Program);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports_Change_Program), vbox_Liste_Ports_Change_Program_Program, TRUE, TRUE, 0);

	hbox_Liste_Ports_Change_Program_Name = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Ports_Change_Program_Name);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports_Change_Program_Program), hbox_Liste_Ports_Change_Program_Name, FALSE, TRUE, 0);

	label_Liste_Ports_Program_Name = gtk_label_new ("Name :");
	gtk_widget_show (label_Liste_Ports_Program_Name);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports_Change_Program_Name), label_Liste_Ports_Program_Name, FALSE, FALSE, 5);

	entry_Liste_Ports_Program_Name = gtk_entry_new ();
	gtk_widget_show (entry_Liste_Ports_Program_Name);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports_Change_Program_Name), entry_Liste_Ports_Program_Name, TRUE, TRUE, 0);

	hbox_Liste_Ports_Change_Program_Path = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Ports_Change_Program_Path);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports_Change_Program_Program), hbox_Liste_Ports_Change_Program_Path, TRUE, TRUE, 0);

	label_Liste_Ports_Program_Path = gtk_label_new ("Path :");
	gtk_widget_show (label_Liste_Ports_Program_Path);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports_Change_Program_Path), label_Liste_Ports_Program_Path, FALSE, FALSE, 9);


	entry_Liste_Ports_Program_Path = gtk_entry_new ();
  	gtk_widget_show (entry_Liste_Ports_Program_Path);
  	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports_Change_Program_Path), entry_Liste_Ports_Program_Path, TRUE, TRUE, 0);
  	gtk_widget_set_sensitive (entry_Liste_Ports_Program_Path, FALSE);

  	button_Liste_Ports_Program_Path = gtk_button_new_from_stock ("gtk-open");
  	gtk_widget_show (button_Liste_Ports_Program_Path);
  	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports_Change_Program_Path), button_Liste_Ports_Program_Path, FALSE, FALSE, 0);
  	gtk_widget_set_sensitive (button_Liste_Ports_Program_Path, FALSE);


	hbox_Liste_Ports_Change_Program_Params = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Ports_Change_Program_Params);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports_Change_Program_Program), hbox_Liste_Ports_Change_Program_Params, FALSE, TRUE, 0);

	label_Liste_Ports_Program_Param = gtk_label_new ("Params :");
	gtk_widget_show (label_Liste_Ports_Program_Param);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports_Change_Program_Params), label_Liste_Ports_Program_Param, FALSE, FALSE, 2);

	entry_Liste_Ports_Program_Param = gtk_entry_new ();
	gtk_widget_show (entry_Liste_Ports_Program_Param);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports_Change_Program_Params), entry_Liste_Ports_Program_Param, TRUE, TRUE, 0);

	hbox_Liste_Ports_Change_Program_Button = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Ports_Change_Program_Button);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports_Change_Program_Program), hbox_Liste_Ports_Change_Program_Button, FALSE, TRUE, 3);

	fixed_Liste_Ports_Change_Program_Button_Gauche = gtk_fixed_new ();
	gtk_widget_show (fixed_Liste_Ports_Change_Program_Button_Gauche);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports_Change_Program_Button), fixed_Liste_Ports_Change_Program_Button_Gauche, TRUE, TRUE, 0);

	button_Liste_Ports_Program_Add = gtk_button_new_from_stock ("gtk-add");
	gtk_widget_show (button_Liste_Ports_Program_Add);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports_Change_Program_Button), button_Liste_Ports_Program_Add, FALSE, FALSE, 10);

	button_Liste_Ports_Program_Delete = gtk_button_new_from_stock ("gtk-remove");
	gtk_widget_show (button_Liste_Ports_Program_Delete);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports_Change_Program_Button), button_Liste_Ports_Program_Delete, FALSE, FALSE, 0);

	fixed_Liste_Ports_Change_Program_Droite = gtk_fixed_new ();
	gtk_widget_show (fixed_Liste_Ports_Change_Program_Droite);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports_Change_Program_Button), fixed_Liste_Ports_Change_Program_Droite, TRUE, TRUE, 0);

	vbox_Liste_Ports_Change_Program_Icon = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Liste_Ports_Change_Program_Icon);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports_Change_Program), vbox_Liste_Ports_Change_Program_Icon, FALSE, TRUE, 8);

	fixed_Liste_Ports_Change_Program_Icon_Haut = gtk_fixed_new ();
	gtk_widget_show (fixed_Liste_Ports_Change_Program_Icon_Haut);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports_Change_Program_Icon), fixed_Liste_Ports_Change_Program_Icon_Haut, TRUE, TRUE, 0);

	combobox_Liste_Ports_Program = creation_combo (FALSE,FALSE);
	Creation_Combo_Liste_Fichier_Image (combobox_Liste_Ports_Program, "Port/", TRUE);
	gtk_widget_show (combobox_Liste_Ports_Program);	
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports_Change_Program_Icon), combobox_Liste_Ports_Program, FALSE, TRUE, 3);



	fixed_Liste_Ports_Change_Program_Icon_Bas = gtk_fixed_new ();
	gtk_widget_show (fixed_Liste_Ports_Change_Program_Icon_Bas);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports_Change_Program_Icon), fixed_Liste_Ports_Change_Program_Icon_Bas, TRUE, TRUE, 0);

	label_Liste_Ports_Program = gtk_label_new ("Programs");
	gtk_widget_show (label_Liste_Ports_Program);
	gtk_frame_set_label_widget (GTK_FRAME (frame_Liste_Ports_Program), label_Liste_Ports_Program);
	gtk_label_set_use_markup (GTK_LABEL (label_Liste_Ports_Program), TRUE);

	label_Frame_Liste_Ports = gtk_label_new ("Change, add, delete port");
	gtk_widget_show (label_Frame_Liste_Ports);
	gtk_frame_set_label_widget (GTK_FRAME (frame_Liste_Ports), label_Frame_Liste_Ports);
	gtk_label_set_use_markup (GTK_LABEL (label_Frame_Liste_Ports), TRUE);

	vbox_Liste_Ports_Button = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Liste_Ports_Button);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Ports), vbox_Liste_Ports_Button, FALSE, TRUE, 9);

	fixed_Liste_Ports_Button_Haut = gtk_fixed_new ();
	gtk_widget_show (fixed_Liste_Ports_Button_Haut);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports_Button), fixed_Liste_Ports_Button_Haut, TRUE, TRUE, 0);

	button_Liste_Ports_Add = gtk_button_new_from_stock ("gtk-add");
	gtk_widget_show (button_Liste_Ports_Add);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports_Button), button_Liste_Ports_Add, FALSE, FALSE, 5);

	button_Liste_Ports_Delete = gtk_button_new_from_stock ("gtk-remove");
	gtk_widget_show (button_Liste_Ports_Delete);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports_Button), button_Liste_Ports_Delete, FALSE, FALSE, 0);

	fixed_Liste_Ports_Button_Milieu = gtk_fixed_new ();
	gtk_widget_show (fixed_Liste_Ports_Button_Milieu);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports_Button), fixed_Liste_Ports_Button_Milieu, TRUE, TRUE, 0);

	button_Liste_Ports_Ok = gtk_button_new_from_stock ("gtk-apply");
	gtk_widget_show (button_Liste_Ports_Ok);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports_Button), button_Liste_Ports_Ok, FALSE, FALSE, 5);

	button_Liste_Ports_Cancel = gtk_button_new_from_stock ("gtk-cancel");
	gtk_widget_show (button_Liste_Ports_Cancel);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports_Button), button_Liste_Ports_Cancel, FALSE, FALSE, 0);

	fixed_Liste_Ports_Button_Bas = gtk_fixed_new ();
	gtk_widget_show (fixed_Liste_Ports_Button_Bas);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports_Button), fixed_Liste_Ports_Button_Bas, TRUE, TRUE, 0);

	vbox_Liste_Ports_Icone = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Liste_Ports_Icone);
	gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook_Settings), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Settings), 1), vbox_Liste_Ports_Icone);

	image_Liste_Ports = (GtkWidget *)Load_Pixmap ("Port.png");
	gtk_widget_show (image_Liste_Ports);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports_Icone), image_Liste_Ports, FALSE, FALSE, 0);

	label_Liste_Ports = gtk_label_new ("Ports");
	gtk_widget_show (label_Liste_Ports);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Ports_Icone), label_Liste_Ports, FALSE, FALSE, 0);

	scrolledwindow_Liste_Signature_Root = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow_Liste_Signature_Root);
	gtk_container_add (GTK_CONTAINER (notebook_Settings), scrolledwindow_Liste_Signature_Root);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_Liste_Signature_Root), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

	viewport_Liste_Signature = gtk_viewport_new (NULL, NULL);
	gtk_widget_show (viewport_Liste_Signature);
	gtk_container_add (GTK_CONTAINER (scrolledwindow_Liste_Signature_Root), viewport_Liste_Signature);
	gtk_viewport_set_shadow_type (GTK_VIEWPORT (viewport_Liste_Signature), GTK_SHADOW_NONE);

	vbox_Liste_Signature = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (vbox_Liste_Signature);
	gtk_container_add (GTK_CONTAINER (viewport_Liste_Signature), vbox_Liste_Signature);

	scrolledwindow_Liste_Signature = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow_Liste_Signature);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature), scrolledwindow_Liste_Signature, TRUE, TRUE, 0);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_Liste_Signature), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow_Liste_Signature), GTK_SHADOW_IN);
	

	Create_Liste_Signature ();
	gtk_widget_show (treeview_Liste_Signature);
	gtk_container_add (GTK_CONTAINER (scrolledwindow_Liste_Signature), treeview_Liste_Signature);
	gtk_tree_view_set_enable_search (GTK_TREE_VIEW (treeview_Liste_Signature), FALSE);


	hbox_Liste_Signature = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Signature);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature), hbox_Liste_Signature, FALSE, TRUE, 0);

	frame_Liste_Signature = gtk_frame_new (NULL);
	gtk_widget_show (frame_Liste_Signature);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature), frame_Liste_Signature, TRUE, TRUE, 0);

	vbox_Liste_Signature_Change = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Liste_Signature_Change);
	gtk_container_add (GTK_CONTAINER (frame_Liste_Signature), vbox_Liste_Signature_Change);

	hbox_Liste_Signature_Change_Haut = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Signature_Change_Haut);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature_Change), hbox_Liste_Signature_Change_Haut, FALSE, TRUE, 2);

	vbox_Liste_Signature_Change_Haut_Gauche = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Liste_Signature_Change_Haut_Gauche);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_Haut), vbox_Liste_Signature_Change_Haut_Gauche, TRUE, TRUE, 0);

	hbox_Liste_Signature_Change_Name = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Signature_Change_Name);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature_Change_Haut_Gauche), hbox_Liste_Signature_Change_Name, FALSE, TRUE, 0);

	label_Liste_Signature_System_Name = gtk_label_new ("System name : ");
	gtk_widget_show (label_Liste_Signature_System_Name);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_Name), label_Liste_Signature_System_Name, FALSE, FALSE, 5);

	entry_Liste_Signature_System_name = gtk_entry_new ();
	gtk_widget_show (entry_Liste_Signature_System_name);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_Name), entry_Liste_Signature_System_name, FALSE, TRUE, 7);
	gtk_widget_set_size_request (entry_Liste_Signature_System_name, 255, -1);

	hbox_Liste_Signature_Change_Type = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Signature_Change_Type);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature_Change_Haut_Gauche), hbox_Liste_Signature_Change_Type, FALSE, TRUE, 0);

	label_Liste_Signature_Type = gtk_label_new ("Type  :");
	gtk_widget_show (label_Liste_Signature_Type);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_Type), label_Liste_Signature_Type, FALSE, FALSE, 8);

	combobox_Liste_Signature_Type = creation_combo (FALSE,FALSE);
	creation_combo_type (combobox_Liste_Signature_Type);
	gtk_widget_show (combobox_Liste_Signature_Type);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_Type), combobox_Liste_Signature_Type, FALSE, TRUE, 0);

	checkbutton_Liste_Signature_Firewall = gtk_check_button_new_with_mnemonic ("Firewall");
	gtk_widget_show (checkbutton_Liste_Signature_Firewall);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_Type), checkbutton_Liste_Signature_Firewall, FALSE, FALSE, 10);

	
	hbox_Liste_Signature_Change_Signature = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Signature_Change_Signature);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature_Change_Haut_Gauche), hbox_Liste_Signature_Change_Signature, TRUE, TRUE, 0);

	label_Liste_Signature_Md5 = gtk_label_new ("Md5 (IPV4):");
	gtk_widget_show (label_Liste_Signature_Md5);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_Signature), label_Liste_Signature_Md5, FALSE, FALSE, 0);
	gtk_widget_set_size_request (label_Liste_Signature_Md5, 86, 16);

	entry_Liste_Signature_Md5 = gtk_entry_new ();
	gtk_widget_show (entry_Liste_Signature_Md5);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_Signature), entry_Liste_Signature_Md5, TRUE, TRUE, 8);


	vbox_Liste_Signature_Change_Haut_Icon = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Liste_Signature_Change_Haut_Icon);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_Haut), vbox_Liste_Signature_Change_Haut_Icon, FALSE, TRUE, 0);

	combobox_Liste_Signature = creation_combo (FALSE,TRUE);
	Creation_Combo_Liste_Fichier_Image (combobox_Liste_Signature, "Equipment/", TRUE);
	gtk_widget_show (combobox_Liste_Signature);	
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature_Change_Haut_Icon), combobox_Liste_Signature, FALSE, FALSE, 0);


	hbox_Liste_Signature_Change_MAC = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Signature_Change_MAC);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature_Change), hbox_Liste_Signature_Change_MAC, FALSE, FALSE, 0);

	
	label_Liste_Signature_MAC = gtk_label_new ("MAC :");
	gtk_widget_show (label_Liste_Signature_MAC);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_MAC), label_Liste_Signature_MAC, FALSE, FALSE, 8);

	entry_Liste_Signature_MAC = gtk_entry_new ();
	gtk_widget_show (entry_Liste_Signature_MAC);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_MAC), entry_Liste_Signature_MAC, FALSE, TRUE, 0);
	gtk_widget_set_size_request (entry_Liste_Signature_MAC, 140, -1);

	
	label_Liste_Signature_Open_Port = gtk_label_new ("TCP port (Open):");
	gtk_widget_show (label_Liste_Signature_Open_Port);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_MAC), label_Liste_Signature_Open_Port, FALSE, FALSE, 3);

	spinbutton_Liste_Signature_Open_Port_adj = gtk_adjustment_new (-1, -1, 100, 1, 10, 10);
	spinbutton_Liste_Signature_Open_Port = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_Liste_Signature_Open_Port_adj), 1, 0);
	gtk_widget_show (spinbutton_Liste_Signature_Open_Port);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_MAC), spinbutton_Liste_Signature_Open_Port, FALSE, TRUE, 0);
	gtk_widget_set_size_request (spinbutton_Liste_Signature_Open_Port, 52, -1);
	gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinbutton_Liste_Signature_Open_Port), TRUE);
	
	label_Liste_Signature_Close_Port = gtk_label_new ("TCP port (Close):");
	gtk_widget_show (label_Liste_Signature_Close_Port);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_MAC), label_Liste_Signature_Close_Port, FALSE, FALSE, 3);

	spinbutton_Liste_Signature_Close_Port_adj = (GtkWidget *)gtk_adjustment_new (-1, -1, 100, 1, 10, 10);
	spinbutton_Liste_Signature_Close_Port = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_Liste_Signature_Close_Port_adj), 1, 0);
	gtk_widget_show (spinbutton_Liste_Signature_Close_Port);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_MAC), spinbutton_Liste_Signature_Close_Port, FALSE, TRUE, 0);
	gtk_widget_set_size_request (spinbutton_Liste_Signature_Close_Port, 52, -1);
	gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinbutton_Liste_Signature_Close_Port), TRUE);


	hbox_Liste_Signature_Change_UDP = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Signature_Change_UDP);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature_Change), hbox_Liste_Signature_Change_UDP, FALSE, FALSE, 0);

	label_Liste_Signature_UDP = gtk_label_new ("UDP :");
	gtk_widget_show (label_Liste_Signature_UDP);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_UDP), label_Liste_Signature_UDP, FALSE, FALSE, 8);

	entry_Liste_Signature_UDP = gtk_entry_new ();
	gtk_widget_show (entry_Liste_Signature_UDP);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_UDP), entry_Liste_Signature_UDP, FALSE, TRUE, 0);
	gtk_widget_set_size_request (entry_Liste_Signature_UDP, 150, -1);
	
	

	hbox_Liste_Signature_Change_SNMP_NAME = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Signature_Change_SNMP_NAME);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature_Change), hbox_Liste_Signature_Change_SNMP_NAME, FALSE, FALSE, 0);

	label_Liste_Signature_SNMP_NAME = gtk_label_new ("Snmp Name :");
	gtk_widget_show (label_Liste_Signature_SNMP_NAME);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_SNMP_NAME), label_Liste_Signature_SNMP_NAME, FALSE, FALSE, 8);

	combobox_Liste_Signature_SNMP_NAME = creation_combo (FALSE,FALSE);
	creation_combo_etat_snmp (combobox_Liste_Signature_SNMP_NAME);
	gtk_widget_show (combobox_Liste_Signature_SNMP_NAME);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_SNMP_NAME), combobox_Liste_Signature_SNMP_NAME, FALSE, TRUE, 0);
	gtk_widget_set_size_request (combobox_Liste_Signature_SNMP_NAME, 100, -1);
	
	entry_Liste_Signature_SNMP_NAME = gtk_entry_new ();
	gtk_widget_show (entry_Liste_Signature_SNMP_NAME);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_SNMP_NAME), entry_Liste_Signature_SNMP_NAME, FALSE, TRUE, 0);
	gtk_widget_set_size_request (entry_Liste_Signature_SNMP_NAME, 200, -1);
	

	hbox_Liste_Signature_Change_SNMP_DEVICE = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Signature_Change_SNMP_DEVICE);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature_Change), hbox_Liste_Signature_Change_SNMP_DEVICE, FALSE, FALSE, 0);
	
	label_Liste_Signature_SNMP_DEVICE = gtk_label_new ("Snmp Device :");
	gtk_widget_show (label_Liste_Signature_SNMP_DEVICE);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_SNMP_DEVICE), label_Liste_Signature_SNMP_DEVICE, FALSE, FALSE, 8);

	combobox_Liste_Signature_SNMP_DEVICE = creation_combo (FALSE,FALSE);
	creation_combo_etat_snmp (combobox_Liste_Signature_SNMP_DEVICE);
	gtk_widget_show (combobox_Liste_Signature_SNMP_DEVICE);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_SNMP_DEVICE), combobox_Liste_Signature_SNMP_DEVICE, FALSE, TRUE, 0);
	gtk_widget_set_size_request (combobox_Liste_Signature_SNMP_DEVICE, 100, -1);


	entry_Liste_Signature_SNMP_DEVICE = gtk_entry_new ();
	gtk_widget_show (entry_Liste_Signature_SNMP_DEVICE);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_SNMP_DEVICE), entry_Liste_Signature_SNMP_DEVICE, FALSE, TRUE, 0);
	gtk_widget_set_size_request (entry_Liste_Signature_SNMP_DEVICE, 200, -1);
	
	
/*	checkbutton_Liste_Signature_Gateway = gtk_check_button_new_with_mnemonic ("Gateway");
	gtk_widget_show (checkbutton_Liste_Signature_Gateway);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_SNMP_DEVICE), checkbutton_Liste_Signature_Gateway, FALSE, FALSE, 10);
*/
	

	hbox_Liste_Signature_Change_SNMP_DESCRIPTION = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Signature_Change_SNMP_DESCRIPTION);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature_Change), hbox_Liste_Signature_Change_SNMP_DESCRIPTION, FALSE, FALSE, 0);

	label_Liste_Signature_SNMP_DESCRIPTION = gtk_label_new ("Snmp Description :");
	gtk_widget_show (label_Liste_Signature_SNMP_DESCRIPTION);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_SNMP_DESCRIPTION), label_Liste_Signature_SNMP_DESCRIPTION, FALSE, FALSE, 8);

	combobox_Liste_Signature_SNMP_DESCRIPTION = creation_combo (FALSE,FALSE);
	creation_combo_etat_snmp (combobox_Liste_Signature_SNMP_DESCRIPTION);
	gtk_widget_show (combobox_Liste_Signature_SNMP_DESCRIPTION);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_SNMP_DESCRIPTION), combobox_Liste_Signature_SNMP_DESCRIPTION, FALSE, TRUE, 0);
	gtk_widget_set_size_request (combobox_Liste_Signature_SNMP_DESCRIPTION, 100, -1);
	
	entry_Liste_Signature_SNMP_DESCRIPTION = gtk_entry_new ();
	gtk_widget_show (entry_Liste_Signature_SNMP_DESCRIPTION);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_SNMP_DESCRIPTION), entry_Liste_Signature_SNMP_DESCRIPTION, FALSE, TRUE, 0);
	gtk_widget_set_size_request (entry_Liste_Signature_SNMP_DESCRIPTION, 200, -1);
	
/*	checkbutton_Liste_Signature_Routage = gtk_check_button_new_with_mnemonic ("Routage");
	gtk_widget_show (checkbutton_Liste_Signature_Routage);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_SNMP_DESCRIPTION), checkbutton_Liste_Signature_Routage, FALSE, FALSE, 10);
*/


	hbox_Liste_Signature_Change_GATEWAY = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Signature_Change_GATEWAY);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature_Change), hbox_Liste_Signature_Change_GATEWAY, FALSE, FALSE, 0);
	
	label_Liste_Signature_GATEWAY = gtk_label_new ("Gateway :");
	gtk_widget_show (label_Liste_Signature_GATEWAY);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_GATEWAY), label_Liste_Signature_GATEWAY, FALSE, FALSE, 8);

	combobox_Liste_Signature_GATEWAY = creation_combo (FALSE,FALSE);
	creation_combo_etat_GW_RT (combobox_Liste_Signature_GATEWAY);
	gtk_widget_show (combobox_Liste_Signature_GATEWAY);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_GATEWAY), combobox_Liste_Signature_GATEWAY, FALSE, TRUE, 0);
	gtk_widget_set_size_request (combobox_Liste_Signature_GATEWAY, 60, -1);
	
	




	label_Liste_Signature_Snmp = gtk_label_new ("Snmp :");
	gtk_widget_show (label_Liste_Signature_Snmp);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_GATEWAY), label_Liste_Signature_Snmp, FALSE, FALSE, 8);

	combobox_Liste_Signature_Snmp = creation_combo (FALSE,FALSE);
	creation_combo_etat_GW_RT (combobox_Liste_Signature_Snmp);
	gtk_widget_show (combobox_Liste_Signature_Snmp);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_GATEWAY), combobox_Liste_Signature_Snmp, FALSE, TRUE, 0);
	gtk_widget_set_size_request (combobox_Liste_Signature_Snmp, 60, -1);

	
	label_Liste_Signature_Smb = gtk_label_new ("Smb :");
	gtk_widget_show (label_Liste_Signature_Smb);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_GATEWAY), label_Liste_Signature_Smb, FALSE, FALSE, 8);

	combobox_Liste_Signature_Smb = creation_combo (FALSE,FALSE);
	creation_combo_etat_GW_RT (combobox_Liste_Signature_Smb);
	gtk_widget_show (combobox_Liste_Signature_Smb);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_GATEWAY), combobox_Liste_Signature_Smb, FALSE, TRUE, 0);
	gtk_widget_set_size_request (combobox_Liste_Signature_Smb, 60, -1);


	label_Liste_Signature_Sip = gtk_label_new ("Sip :");
	gtk_widget_show (label_Liste_Signature_Sip);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_GATEWAY), label_Liste_Signature_Sip, FALSE, FALSE, 8);

	combobox_Liste_Signature_Sip = creation_combo (FALSE,FALSE);
	creation_combo_etat_GW_RT (combobox_Liste_Signature_Sip);
	gtk_widget_show (combobox_Liste_Signature_Sip);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_GATEWAY), combobox_Liste_Signature_Sip, FALSE, TRUE, 0);
	gtk_widget_set_size_request (combobox_Liste_Signature_Sip, 60, -1);

	/*
	checkbutton_Liste_Signature_Smb = gtk_check_button_new_with_mnemonic ("Smb");
	gtk_widget_show (checkbutton_Liste_Signature_Smb);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_UDP), checkbutton_Liste_Signature_Smb, FALSE, FALSE, 10);

	checkbutton_Liste_Signature_SIP = gtk_check_button_new_with_mnemonic ("Sip");
	gtk_widget_show (checkbutton_Liste_Signature_SIP);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_UDP), checkbutton_Liste_Signature_SIP, FALSE, FALSE, 10);
	
*/
	
	


	hbox_Liste_Signature_Change_ROUTAGE = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Signature_Change_ROUTAGE);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature_Change), hbox_Liste_Signature_Change_ROUTAGE, FALSE, FALSE, 0);
	
	label_Liste_Signature_ROUTAGE = gtk_label_new ("Routage :");
	gtk_widget_show (label_Liste_Signature_ROUTAGE);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_ROUTAGE), label_Liste_Signature_ROUTAGE, FALSE, FALSE, 8);

	combobox_Liste_Signature_ROUTAGE = creation_combo (FALSE,FALSE);
	creation_combo_etat_GW_RT (combobox_Liste_Signature_ROUTAGE);
	gtk_widget_show (combobox_Liste_Signature_ROUTAGE);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_ROUTAGE), combobox_Liste_Signature_ROUTAGE, FALSE, TRUE, 0);
	gtk_widget_set_size_request (combobox_Liste_Signature_ROUTAGE, 60, -1);

	label_Liste_Signature_Printer = gtk_label_new ("Printer :");
	gtk_widget_show (label_Liste_Signature_Printer);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_ROUTAGE), label_Liste_Signature_Printer, FALSE, FALSE, 8);

	combobox_Liste_Signature_Printer = creation_combo (FALSE,FALSE);
	creation_combo_etat_GW_RT (combobox_Liste_Signature_Printer);
	gtk_widget_show (combobox_Liste_Signature_Printer);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_ROUTAGE), combobox_Liste_Signature_Printer, FALSE, TRUE, 0);
	gtk_widget_set_size_request (combobox_Liste_Signature_Printer, 60, -1);

	label_Liste_Signature_JetDirect = gtk_label_new ("JetDirect :");
	gtk_widget_show (label_Liste_Signature_JetDirect);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_ROUTAGE), label_Liste_Signature_JetDirect, FALSE, FALSE, 8);

	combobox_Liste_Signature_JetDirect = creation_combo (FALSE,FALSE);
	creation_combo_etat_GW_RT (combobox_Liste_Signature_JetDirect);
	gtk_widget_show (combobox_Liste_Signature_JetDirect);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_ROUTAGE), combobox_Liste_Signature_JetDirect, FALSE, TRUE, 0);
	gtk_widget_set_size_request (combobox_Liste_Signature_JetDirect, 60, -1);

/*
	checkbutton_Liste_Signature_PRINTER = gtk_check_button_new_with_mnemonic ("Printer");
	gtk_widget_show (checkbutton_Liste_Signature_PRINTER);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_UDP), checkbutton_Liste_Signature_PRINTER, FALSE, FALSE, 10);

	checkbutton_Liste_Signature_JETDIRECT = gtk_check_button_new_with_mnemonic ("JetDirect");
	gtk_widget_show (checkbutton_Liste_Signature_JETDIRECT);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_SNMP_NAME), checkbutton_Liste_Signature_JETDIRECT, FALSE, FALSE, 10);

*/


	hbox_Liste_Signature_Change_FTP = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Signature_Change_FTP);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature_Change), hbox_Liste_Signature_Change_FTP, FALSE, FALSE, 0);

	label_Liste_Signature_Header_FTP = gtk_label_new ("FTP :");
	gtk_widget_show (label_Liste_Signature_Header_FTP);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_FTP), label_Liste_Signature_Header_FTP, FALSE, FALSE, 8);


	combobox_Liste_Signature_FTP = creation_combo (FALSE,FALSE);
	creation_combo_etat_port (combobox_Liste_Signature_FTP);
	gtk_widget_show (combobox_Liste_Signature_FTP);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_FTP), combobox_Liste_Signature_FTP, FALSE, TRUE, 0);
	gtk_widget_set_size_request (combobox_Liste_Signature_FTP, 100, -1);

	entry_Liste_Signature_Header_FTP = gtk_entry_new ();
	gtk_widget_show (entry_Liste_Signature_Header_FTP);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_FTP), entry_Liste_Signature_Header_FTP, TRUE, TRUE, 0);


	hbox_Liste_Signature_Change_HTTP = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Signature_Change_HTTP);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature_Change), hbox_Liste_Signature_Change_HTTP, FALSE, FALSE, 0);

	label_Liste_Signature_Header_HTTP = gtk_label_new ("HTTP :");
	gtk_widget_show (label_Liste_Signature_Header_HTTP);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_HTTP), label_Liste_Signature_Header_HTTP, FALSE, FALSE, 8);


	combobox_Liste_Signature_HTTP = creation_combo (FALSE,FALSE);
	creation_combo_etat_port (combobox_Liste_Signature_HTTP);
	gtk_widget_show (combobox_Liste_Signature_HTTP);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_HTTP), combobox_Liste_Signature_HTTP, FALSE, TRUE, 0);
	gtk_widget_set_size_request (combobox_Liste_Signature_HTTP, 100, -1);

	entry_Liste_Signature_Header_HTTP = gtk_entry_new ();
	gtk_widget_show (entry_Liste_Signature_Header_HTTP);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_HTTP), entry_Liste_Signature_Header_HTTP, TRUE, TRUE, 0);



	hbox_Liste_Signature_Change_HTTPS = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Signature_Change_HTTPS);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature_Change), hbox_Liste_Signature_Change_HTTPS, FALSE, FALSE, 0);

	label_Liste_Signature_Header_HTTPS = gtk_label_new ("HTTPS :");
	gtk_widget_show (label_Liste_Signature_Header_HTTPS);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_HTTPS), label_Liste_Signature_Header_HTTPS, FALSE, FALSE, 8);


	combobox_Liste_Signature_HTTPS = creation_combo (FALSE,FALSE);
	creation_combo_etat_port (combobox_Liste_Signature_HTTPS);
	gtk_widget_show (combobox_Liste_Signature_HTTPS);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_HTTPS), combobox_Liste_Signature_HTTPS, FALSE, TRUE, 0);
	gtk_widget_set_size_request (combobox_Liste_Signature_HTTPS, 100, -1);

	entry_Liste_Signature_Header_HTTPS = gtk_entry_new ();
	gtk_widget_show (entry_Liste_Signature_Header_HTTPS);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_HTTPS), entry_Liste_Signature_Header_HTTPS, TRUE, TRUE, 0);




	hbox_Liste_Signature_Change_IMAP = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Signature_Change_IMAP);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature_Change), hbox_Liste_Signature_Change_IMAP, FALSE, FALSE, 0);

	label_Liste_Signature_Header_IMAP = gtk_label_new ("IMAP :");
	gtk_widget_show (label_Liste_Signature_Header_IMAP);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_IMAP), label_Liste_Signature_Header_IMAP, FALSE, FALSE, 8);


	combobox_Liste_Signature_IMAP = creation_combo (FALSE,FALSE);
	creation_combo_etat_port (combobox_Liste_Signature_IMAP);
	gtk_widget_show (combobox_Liste_Signature_IMAP);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_IMAP), combobox_Liste_Signature_IMAP, FALSE, TRUE, 0);
	gtk_widget_set_size_request (combobox_Liste_Signature_IMAP, 100, -1);

	entry_Liste_Signature_Header_IMAP = gtk_entry_new ();
	gtk_widget_show (entry_Liste_Signature_Header_IMAP);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_IMAP), entry_Liste_Signature_Header_IMAP, TRUE, TRUE, 0);




	hbox_Liste_Signature_Change_SMTP = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Signature_Change_SMTP);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature_Change), hbox_Liste_Signature_Change_SMTP, FALSE, FALSE, 0);

	label_Liste_Signature_Header_SMTP = gtk_label_new ("SMTP :");
	gtk_widget_show (label_Liste_Signature_Header_SMTP);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_SMTP), label_Liste_Signature_Header_SMTP, FALSE, FALSE, 8);


	combobox_Liste_Signature_SMTP = creation_combo (FALSE,FALSE);
	creation_combo_etat_port (combobox_Liste_Signature_SMTP);
	gtk_widget_show (combobox_Liste_Signature_SMTP);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_SMTP), combobox_Liste_Signature_SMTP, FALSE, TRUE, 0);
	gtk_widget_set_size_request (combobox_Liste_Signature_SMTP, 100, -1);

	entry_Liste_Signature_Header_SMTP = gtk_entry_new ();
	gtk_widget_show (entry_Liste_Signature_Header_SMTP);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_SMTP), entry_Liste_Signature_Header_SMTP, TRUE, TRUE, 0);





	hbox_Liste_Signature_Change_SSH = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Signature_Change_SSH);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature_Change), hbox_Liste_Signature_Change_SSH, FALSE, FALSE, 0);

	label_Liste_Signature_Header_SSH = gtk_label_new ("SSH :");
	gtk_widget_show (label_Liste_Signature_Header_SSH);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_SSH), label_Liste_Signature_Header_SSH, FALSE, FALSE, 8);


	combobox_Liste_Signature_SSH = creation_combo (FALSE,FALSE);
	creation_combo_etat_port (combobox_Liste_Signature_SSH);
	gtk_widget_show (combobox_Liste_Signature_SSH);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_SSH), combobox_Liste_Signature_SSH, FALSE, TRUE, 0);
	gtk_widget_set_size_request (combobox_Liste_Signature_SSH, 100, -1);

	entry_Liste_Signature_Header_SSH = gtk_entry_new ();
	gtk_widget_show (entry_Liste_Signature_Header_SSH);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_SSH), entry_Liste_Signature_Header_SSH, TRUE, TRUE, 0);




	hbox_Liste_Signature_Change_Telnet = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Signature_Change_Telnet);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature_Change), hbox_Liste_Signature_Change_Telnet, FALSE, FALSE, 0);

	label_Liste_Signature_Header_TELNET = gtk_label_new ("Telnet :");
	gtk_widget_show (label_Liste_Signature_Header_TELNET);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_Telnet), label_Liste_Signature_Header_TELNET, FALSE, FALSE, 8);


	combobox_Liste_Signature_Telnet = creation_combo (FALSE,FALSE);
	creation_combo_etat_port (combobox_Liste_Signature_Telnet);
	gtk_widget_show (combobox_Liste_Signature_Telnet);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_Telnet), combobox_Liste_Signature_Telnet, FALSE, TRUE, 0);
	gtk_widget_set_size_request (combobox_Liste_Signature_Telnet, 100, -1);

	entry_Liste_Signature_Header_TELNET = gtk_entry_new ();
	gtk_widget_show (entry_Liste_Signature_Header_TELNET);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature_Change_Telnet), entry_Liste_Signature_Header_TELNET, TRUE, TRUE, 0);


	label_Frame_Liste_Signature = gtk_label_new ("Change, add, delete Os Fingerprinting");
	gtk_widget_show (label_Frame_Liste_Signature);
	gtk_frame_set_label_widget (GTK_FRAME (frame_Liste_Signature), label_Frame_Liste_Signature);
	gtk_label_set_use_markup (GTK_LABEL (label_Frame_Liste_Signature), TRUE);

	vbox_Liste_Signature_Button = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Liste_Signature_Button);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Signature), vbox_Liste_Signature_Button, FALSE, TRUE, 9);

	fixed_Liste_Signature_Button_Haut = gtk_fixed_new ();
	gtk_widget_show (fixed_Liste_Signature_Button_Haut);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature_Button), fixed_Liste_Signature_Button_Haut, TRUE, TRUE, 0);

	button_Liste_Signature_Add = gtk_button_new_from_stock ("gtk-add");
	gtk_widget_show (button_Liste_Signature_Add);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature_Button), button_Liste_Signature_Add, FALSE, FALSE, 4);

	button_Liste_Signature_Delete = gtk_button_new_from_stock ("gtk-remove");
	gtk_widget_show (button_Liste_Signature_Delete);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature_Button), button_Liste_Signature_Delete, FALSE, FALSE, 4);

	fixed_Liste_Signature_Button_Milieu = gtk_fixed_new ();
	gtk_widget_show (fixed_Liste_Signature_Button_Milieu);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature_Button), fixed_Liste_Signature_Button_Milieu, TRUE, TRUE, 0);

	button_Liste_Signature_Ok = gtk_button_new_from_stock ("gtk-apply");
	gtk_widget_show (button_Liste_Signature_Ok);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature_Button), button_Liste_Signature_Ok, FALSE, FALSE, 4);

	button_Liste_Signature_Cancel = gtk_button_new_from_stock ("gtk-cancel");
	gtk_widget_show (button_Liste_Signature_Cancel);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature_Button), button_Liste_Signature_Cancel, FALSE, FALSE, 4);

	fixed_Liste_Signature_Button_Bas = gtk_fixed_new ();
	gtk_widget_show (fixed_Liste_Signature_Button_Bas);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature_Button), fixed_Liste_Signature_Button_Bas, TRUE, TRUE, 0);

	vbox_Liste_Signature_Icone = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Liste_Signature_Icone);
	gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook_Settings), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Settings), 2), vbox_Liste_Signature_Icone);

	image_Liste_Signature = (GtkWidget *)Load_Pixmap ("goto.png");
	gtk_widget_show (image_Liste_Signature);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature_Icone), image_Liste_Signature, TRUE, TRUE, 0);

	label_Liste_Signature = gtk_label_new ("Fingerprinting");
	gtk_widget_show (label_Liste_Signature);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Signature_Icone), label_Liste_Signature, FALSE, FALSE, 0);



#ifdef         __SCRIPT_ENABLE
	scrolledwindow_Liste_Scripts_Root = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow_Liste_Scripts_Root);
	gtk_container_add (GTK_CONTAINER (notebook_Settings), scrolledwindow_Liste_Scripts_Root);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_Liste_Scripts_Root), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

	viewport_Liste_Scripts = gtk_viewport_new (NULL, NULL);
	gtk_widget_show (viewport_Liste_Scripts);
	gtk_container_add (GTK_CONTAINER (scrolledwindow_Liste_Scripts_Root), viewport_Liste_Scripts);
	gtk_viewport_set_shadow_type (GTK_VIEWPORT (viewport_Liste_Scripts), GTK_SHADOW_NONE);

	vbox_Liste_Scripts = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Liste_Scripts);
	gtk_container_add (GTK_CONTAINER (viewport_Liste_Scripts), vbox_Liste_Scripts);

	scrolledwindow_Liste_Scripts = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow_Liste_Scripts);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Scripts), scrolledwindow_Liste_Scripts, TRUE, TRUE, 0);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_Liste_Scripts), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow_Liste_Scripts), GTK_SHADOW_IN);


	Create_Liste_Script ();
	gtk_widget_show (treeview_Liste_Scripts);
	gtk_container_add (GTK_CONTAINER (scrolledwindow_Liste_Scripts), treeview_Liste_Scripts);
	gtk_tree_view_set_enable_search (GTK_TREE_VIEW (treeview_Liste_Scripts), FALSE);

	hbox_Liste_Scripts = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Scripts);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Scripts), hbox_Liste_Scripts, FALSE, TRUE, 0);

	frame_Liste_Scripts = gtk_frame_new (NULL);
	gtk_widget_show (frame_Liste_Scripts);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Scripts), frame_Liste_Scripts, TRUE, TRUE, 0);

	hbox_Liste_Scripts_Change = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Scripts_Change);
	gtk_container_add (GTK_CONTAINER (frame_Liste_Scripts), hbox_Liste_Scripts_Change);

	vbox_Liste_Scripts_Change_Gauche = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Liste_Scripts_Change_Gauche);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Scripts_Change), vbox_Liste_Scripts_Change_Gauche, TRUE, TRUE, 0);

	hbox_Liste_Scripts_Change_Name = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Scripts_Change_Name);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Scripts_Change_Gauche), hbox_Liste_Scripts_Change_Name, FALSE, TRUE, 0);

	label_Liste_Scripts_Name = gtk_label_new ("Script name : ");
	gtk_widget_show (label_Liste_Scripts_Name);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Scripts_Change_Name), label_Liste_Scripts_Name, FALSE, FALSE, 13);
	gtk_widget_set_size_request (label_Liste_Scripts_Name, -1, 16);

	entry_Liste_Scripts_name = gtk_entry_new ();
	gtk_widget_show (entry_Liste_Scripts_name);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Scripts_Change_Name), entry_Liste_Scripts_name, FALSE, TRUE, 0);

	hbox_Liste_Scripts_Change_Path = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Scripts_Change_Path);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Scripts_Change_Gauche), hbox_Liste_Scripts_Change_Path, FALSE, TRUE, 0);

	label_Liste_Scripts_Path = gtk_label_new ("Path  :");
	gtk_widget_show (label_Liste_Scripts_Path);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Scripts_Change_Path), label_Liste_Scripts_Path, FALSE, FALSE, 34);

	entry_Liste_Scripts_Path  = gtk_entry_new ();
  	gtk_widget_show (entry_Liste_Scripts_Path );
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Scripts_Change_Path), entry_Liste_Scripts_Path, FALSE, TRUE, 0);
  	gtk_widget_set_sensitive (entry_Liste_Scripts_Path , FALSE);

  	button_Liste_Scripts_Path = gtk_button_new_from_stock ("gtk-open");
  	gtk_widget_show (button_Liste_Scripts_Path);
  	gtk_box_pack_start (GTK_BOX (hbox_Liste_Scripts_Change_Path), button_Liste_Scripts_Path, FALSE, FALSE, 0);
  	gtk_widget_set_sensitive (button_Liste_Scripts_Path, FALSE);



	hbox_Liste_Scripts_Change_Param = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Scripts_Change_Param);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Scripts_Change_Gauche), hbox_Liste_Scripts_Change_Param, FALSE, TRUE, 0);

	label_Liste_Scripts_Params = gtk_label_new ("Params :");
	gtk_widget_show (label_Liste_Scripts_Params);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Scripts_Change_Param), label_Liste_Scripts_Params, FALSE, FALSE, 27);

	entry_Liste_Scripts_Params = gtk_entry_new ();
	gtk_widget_show (entry_Liste_Scripts_Params);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Scripts_Change_Param), entry_Liste_Scripts_Params, FALSE, TRUE, 0);

	vbox_Liste_Scripts_Change_Icon = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Liste_Scripts_Change_Icon);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Scripts_Change), vbox_Liste_Scripts_Change_Icon, FALSE, TRUE, 10);

#ifdef  __GNOME_ENABLE
	iconentry_Liste_Scripts = gnome_icon_entry_new (NULL, NULL);
	gtk_widget_show (iconentry_Liste_Scripts);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Scripts_Change_Icon), iconentry_Liste_Scripts, FALSE, TRUE, 0);
#else

#endif

	fixed_Liste_Scripts_Change_Bas = gtk_fixed_new ();
	gtk_widget_show (fixed_Liste_Scripts_Change_Bas);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Scripts_Change_Icon), fixed_Liste_Scripts_Change_Bas, TRUE, TRUE, 0);

	label_Frame_Liste_Scripts = gtk_label_new ("Change, add, delete Scripts");
	gtk_widget_show (label_Frame_Liste_Scripts);
	gtk_frame_set_label_widget (GTK_FRAME (frame_Liste_Scripts), label_Frame_Liste_Scripts);
	gtk_label_set_use_markup (GTK_LABEL (label_Frame_Liste_Scripts), TRUE);

	vbox_Liste_Scripts_Change_Button = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Liste_Scripts_Change_Button);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Scripts), vbox_Liste_Scripts_Change_Button, FALSE, TRUE, 6);
	gtk_container_set_border_width (GTK_CONTAINER (vbox_Liste_Scripts_Change_Button), 4);

	button_Liste_Scripts_Add = gtk_button_new_from_stock ("gtk-add");
	gtk_widget_show (button_Liste_Scripts_Add);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Scripts_Change_Button), button_Liste_Scripts_Add, FALSE, FALSE, 0);

	button_Liste_Scripts_Delete = gtk_button_new_from_stock ("gtk-remove");
	gtk_widget_show (button_Liste_Scripts_Delete);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Scripts_Change_Button), button_Liste_Scripts_Delete, FALSE, FALSE, 6);

	button_Liste_Scripts_Ok = gtk_button_new_from_stock ("gtk-apply");
	gtk_widget_show (button_Liste_Scripts_Ok);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Scripts_Change_Button), button_Liste_Scripts_Ok, FALSE, FALSE, 6);

	button_Liste_Scripts_Cancel = gtk_button_new_from_stock ("gtk-cancel");
	gtk_widget_show (button_Liste_Scripts_Cancel);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Scripts_Change_Button), button_Liste_Scripts_Cancel, FALSE, FALSE, 0);

	vbox_Liste_Scripts_Icone = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Liste_Scripts_Icone);
	gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook_Settings), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Settings), 3), vbox_Liste_Scripts_Icone);

	image_Liste_Scripts = Load_Pixmap ("openterm.png");
	gtk_widget_show (image_Liste_Scripts);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Scripts_Icone), image_Liste_Scripts, TRUE, TRUE, 0);

	label_Liste_Scripts = gtk_label_new ("Scripts");
	gtk_widget_show (label_Liste_Scripts);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Scripts_Icone), label_Liste_Scripts, FALSE, FALSE, 0);
#endif


	scrolledwindow_Liste_Restore_Root = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow_Liste_Restore_Root);
	gtk_container_add (GTK_CONTAINER (notebook_Settings), scrolledwindow_Liste_Restore_Root);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_Liste_Restore_Root), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

	viewport_Liste_Restore = gtk_viewport_new (NULL, NULL);
	gtk_widget_show (viewport_Liste_Restore);
	gtk_container_add (GTK_CONTAINER (scrolledwindow_Liste_Restore_Root), viewport_Liste_Restore);

	vbox_Liste_Restore = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Liste_Restore);
	gtk_container_add (GTK_CONTAINER (viewport_Liste_Restore), vbox_Liste_Restore);

	scrolledwindow_Liste_Restore = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow_Liste_Restore);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Restore), scrolledwindow_Liste_Restore, TRUE, TRUE, 0);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow_Liste_Restore), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);


	Create_Liste_Restore ();
	gtk_widget_show (treeview_Liste_Restore);
	gtk_container_add (GTK_CONTAINER (scrolledwindow_Liste_Restore), treeview_Liste_Restore);

	hbox_Liste_Restore = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox_Liste_Restore);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Restore), hbox_Liste_Restore, FALSE, TRUE, 0);

	frame_Liest_Restore = gtk_frame_new (NULL);
	gtk_widget_show (frame_Liest_Restore);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Restore), frame_Liest_Restore, TRUE, TRUE, 0);
	gtk_frame_set_shadow_type (GTK_FRAME (frame_Liest_Restore), GTK_SHADOW_NONE);

	vbox_Liste_Restore_Change = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Liste_Restore_Change);
	gtk_container_add (GTK_CONTAINER (frame_Liest_Restore), vbox_Liste_Restore_Change);


	entry_Liste_Restore  = gtk_entry_new ();
  	gtk_widget_show (entry_Liste_Restore );
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Restore_Change), entry_Liste_Restore, FALSE, TRUE, 0);
  	gtk_widget_set_sensitive (entry_Liste_Restore , FALSE);

  	button_Liste_Restore = gtk_button_new_from_stock ("gtk-open");
  	gtk_widget_show (button_Liste_Restore);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Restore_Change), button_Liste_Restore, FALSE, TRUE, 0);
  	gtk_widget_set_sensitive (button_Liste_Restore, FALSE);



	label_Frame_Liste_Restore = gtk_label_new ("Change, add, delete");
	gtk_widget_show (label_Frame_Liste_Restore);
	gtk_frame_set_label_widget (GTK_FRAME (frame_Liest_Restore), label_Frame_Liste_Restore);
	gtk_label_set_use_markup (GTK_LABEL (label_Frame_Liste_Restore), TRUE);

	vbox_Liste_Restore_Change_Button = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Liste_Restore_Change_Button);
	gtk_box_pack_start (GTK_BOX (hbox_Liste_Restore), vbox_Liste_Restore_Change_Button, FALSE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (vbox_Liste_Restore_Change_Button), 4);

	button_Liste_Restore_Add = gtk_button_new_from_stock ("gtk-add");
	gtk_widget_show (button_Liste_Restore_Add);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Restore_Change_Button), button_Liste_Restore_Add, FALSE, FALSE, 0);

	button_Liste_Restore_Delete = gtk_button_new_from_stock ("gtk-remove");
	gtk_widget_show (button_Liste_Restore_Delete);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Restore_Change_Button), button_Liste_Restore_Delete, FALSE, FALSE, 6);

	button_Liste_Restore_Ok = gtk_button_new_from_stock ("gtk-apply");
	gtk_widget_show (button_Liste_Restore_Ok);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Restore_Change_Button), button_Liste_Restore_Ok, FALSE, FALSE, 6);

	button_Liste_Restore_Cancel = gtk_button_new_from_stock ("gtk-cancel");
	gtk_widget_show (button_Liste_Restore_Cancel);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Restore_Change_Button), button_Liste_Restore_Cancel, FALSE, FALSE, 0);

	vbox_Liste_Restore_Icone = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox_Liste_Restore_Icone);
#ifdef         __SCRIPT_ENABLE
	gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook_Settings), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Settings), 4), vbox_Liste_Restore_Icone);
#else
	gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook_Settings), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Settings), 3), vbox_Liste_Restore_Icone);
#endif

	image_Liste_Restore = (GtkWidget *)Load_Pixmap ("Restore.png");
	gtk_widget_show (image_Liste_Restore);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Restore_Icone), image_Liste_Restore, TRUE, TRUE, 0);

	label_Liste_Restore = gtk_label_new ("Restore");
	gtk_widget_show (label_Liste_Restore);
	gtk_box_pack_start (GTK_BOX (vbox_Liste_Restore_Icone), label_Liste_Restore, FALSE, FALSE, 0);


	dialog_action_area_Settings = GTK_DIALOG (dialog_Settings)->action_area;
	gtk_widget_show (dialog_action_area_Settings);
	gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area_Settings), GTK_BUTTONBOX_END);

	button_Settings_Save = gtk_button_new_from_stock ("gtk-save");
	gtk_widget_show (button_Settings_Save);
	gtk_dialog_add_action_widget (GTK_DIALOG (dialog_Settings), button_Settings_Save, GTK_RESPONSE_CLOSE);
	GTK_WIDGET_SET_FLAGS (button_Settings_Save, GTK_CAN_DEFAULT);







	g_signal_connect ((gpointer) spinbutton_Liste_Ports_Info_Port, "changed", G_CALLBACK (Liste_Ports_changed), NULL);
	g_signal_connect ((gpointer) combobox_Liste_Ports_Info_Type, "changed", G_CALLBACK (Liste_Ports_changed), NULL);
	g_signal_connect ((gpointer) entry_Liste_Ports_Info_Service, "changed", G_CALLBACK (Liste_Ports_changed), NULL);
	g_signal_connect ((gpointer) entry_Liste_Ports_Info_Description, "changed", G_CALLBACK (Liste_Ports_changed), NULL);
	g_signal_connect ((gpointer) combobox_Liste_Ports_Info, "changed", G_CALLBACK (Liste_Ports_changed), NULL);
	g_signal_connect ((gpointer) entry_Liste_Ports_Program_Name, "changed", G_CALLBACK (Liste_Ports_changed_Program), NULL);
	g_signal_connect ((gpointer) entry_Liste_Ports_Program_Path, "changed", G_CALLBACK (Liste_Ports_changed_Program), NULL);
	g_signal_connect ((gpointer) entry_Liste_Ports_Program_Param, "changed", G_CALLBACK (Liste_Ports_changed_Program), NULL);
	g_signal_connect ((gpointer) button_Liste_Ports_Program_Add, "clicked", G_CALLBACK (on_button_Liste_Ports_Program_Add_clicked), NULL);
	g_signal_connect ((gpointer) button_Liste_Ports_Program_Delete, "clicked", G_CALLBACK (on_button_Liste_Ports_Program_Delete_clicked), NULL);
	g_signal_connect ((gpointer) combobox_Liste_Ports_Program, "changed", G_CALLBACK (Liste_Ports_changed_Program), NULL);
	g_signal_connect ((gpointer) button_Liste_Ports_Add, "clicked", G_CALLBACK (on_button_Liste_Ports_Add_clicked), NULL);
	g_signal_connect ((gpointer) button_Liste_Ports_Delete, "clicked", G_CALLBACK (on_button_Liste_Ports_Delete_clicked), NULL);
	g_signal_connect ((gpointer) entry_Liste_Signature_System_name, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);
	g_signal_connect ((gpointer) combobox_Liste_Signature_Type, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);

	g_signal_connect ((gpointer) entry_Liste_Signature_Md5, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);
	g_signal_connect ((gpointer) combobox_Liste_Signature, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);
	g_signal_connect ((gpointer) entry_Liste_Signature_MAC, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);
	g_signal_connect ((gpointer) spinbutton_Liste_Signature_Open_Port, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);
	g_signal_connect ((gpointer) spinbutton_Liste_Signature_Close_Port, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);
	
	g_signal_connect ((gpointer) combobox_Liste_Signature_FTP, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);
	g_signal_connect ((gpointer) entry_Liste_Signature_Header_FTP, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);
	g_signal_connect ((gpointer) combobox_Liste_Signature_HTTP, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);
	g_signal_connect ((gpointer) entry_Liste_Signature_Header_HTTP, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);
	g_signal_connect ((gpointer) combobox_Liste_Signature_HTTPS, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);
	g_signal_connect ((gpointer) entry_Liste_Signature_Header_HTTPS, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);
	
	g_signal_connect ((gpointer) combobox_Liste_Signature_IMAP, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);
	g_signal_connect ((gpointer) entry_Liste_Signature_Header_IMAP, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);
	g_signal_connect ((gpointer) combobox_Liste_Signature_SMTP, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);
	g_signal_connect ((gpointer) entry_Liste_Signature_Header_SMTP, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);
	g_signal_connect ((gpointer) combobox_Liste_Signature_SSH, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);
	g_signal_connect ((gpointer) entry_Liste_Signature_Header_SSH, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);

	g_signal_connect ((gpointer) entry_Liste_Signature_UDP, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);
	g_signal_connect ((gpointer) entry_Liste_Signature_SNMP_NAME, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);
	g_signal_connect ((gpointer) entry_Liste_Signature_SNMP_DEVICE, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);
	g_signal_connect ((gpointer) entry_Liste_Signature_SNMP_DESCRIPTION, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);
	g_signal_connect ((gpointer) checkbutton_Liste_Signature_Firewall, "clicked", G_CALLBACK (Liste_Signatures_changed), NULL);
	
	g_signal_connect ((gpointer) combobox_Liste_Signature_SNMP_NAME, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);
	g_signal_connect ((gpointer) combobox_Liste_Signature_SNMP_DEVICE, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);
	g_signal_connect ((gpointer) combobox_Liste_Signature_SNMP_DESCRIPTION, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);

	g_signal_connect ((gpointer) combobox_Liste_Signature_GATEWAY, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);
	g_signal_connect ((gpointer) combobox_Liste_Signature_ROUTAGE, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);
	g_signal_connect ((gpointer) combobox_Liste_Signature_Snmp, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);
	g_signal_connect ((gpointer) combobox_Liste_Signature_Smb, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);
	g_signal_connect ((gpointer) combobox_Liste_Signature_Sip, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);
	g_signal_connect ((gpointer) combobox_Liste_Signature_Printer, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);
	g_signal_connect ((gpointer) combobox_Liste_Signature_JetDirect, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);
	
	g_signal_connect ((gpointer) combobox_Liste_Signature_Telnet, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);
	g_signal_connect ((gpointer) entry_Liste_Signature_Header_TELNET, "changed", G_CALLBACK (Liste_Signatures_changed), NULL);
	g_signal_connect ((gpointer) button_Liste_Signature_Add, "clicked", G_CALLBACK (on_button_Liste_Signature_Add_clicked), NULL);
	g_signal_connect ((gpointer) button_Liste_Signature_Delete, "clicked", G_CALLBACK (on_button_Liste_Signature_Delete_clicked), NULL);
	g_signal_connect ((gpointer) button_Liste_Signature_Ok, "clicked", G_CALLBACK (on_button_Liste_Signature_Ok_clicked), NULL);
	g_signal_connect ((gpointer) button_Liste_Signature_Cancel, "clicked", G_CALLBACK (on_button_Liste_Signature_Cancel_clicked), NULL);
#ifdef         __SCRIPT_ENABLE
	g_signal_connect ((gpointer) entry_Liste_Scripts_name, "changed", G_CALLBACK (Liste_Script_changed), NULL);
	g_signal_connect ((gpointer) entry_Liste_Scripts_Params, "changed", G_CALLBACK (Liste_Script_changed), NULL);
	g_signal_connect ((gpointer) entry_Liste_Scripts_Path, "changed", G_CALLBACK (Liste_Script_changed), NULL);
	g_signal_connect ((gpointer) button_Liste_Scripts_Add, "clicked", G_CALLBACK (on_button_Liste_Scripts_Add_clicked), NULL);
	g_signal_connect ((gpointer) button_Liste_Scripts_Delete, "clicked", G_CALLBACK (on_button_Liste_Scripts_Delete_clicked), NULL);
	g_signal_connect ((gpointer) button_Liste_Scripts_Ok, "clicked", G_CALLBACK (on_button_Liste_Scripts_Ok_clicked), NULL);
	g_signal_connect ((gpointer) button_Liste_Scripts_Cancel, "clicked", G_CALLBACK (on_button_Liste_Scripts_Cancel_clicked), NULL);
#endif	
	g_signal_connect ((gpointer) button_Settings_Save, "clicked", G_CALLBACK (on_button_Settings_Save_clicked), NULL);
	g_signal_connect ((gpointer) button_Liste_Ports_Cancel, "clicked", G_CALLBACK (on_button_Liste_Ports_Cancel_clicked), NULL);
	g_signal_connect ((gpointer) button_Liste_Ports_Ok, "clicked", G_CALLBACK (on_button_Liste_Ports_Ok_clicked), NULL);
	g_signal_connect ((gpointer) dialog_Settings, "delete_event", G_CALLBACK (on_dialog_Settings_delete_event), NULL);


	g_signal_connect ((gpointer) button_Liste_Restore_Add, "clicked", G_CALLBACK (on_button_Liste_Restore_Add_clicked), NULL);
	g_signal_connect ((gpointer) button_Liste_Restore_Delete, "clicked", G_CALLBACK (on_button_Liste_Restore_Delete_clicked), NULL);
	g_signal_connect ((gpointer) button_Liste_Restore_Ok, "clicked", G_CALLBACK (on_button_Liste_Restore_Ok_clicked), NULL);
	g_signal_connect ((gpointer) button_Liste_Restore_Cancel, "clicked", G_CALLBACK (on_button_Liste_Restore_Cancel_clicked), NULL);
	g_signal_connect ((gpointer) button_Liste_Restore , "clicked", G_CALLBACK (on_button_Liste_Restore_Open_clicked), NULL);
	g_signal_connect ((gpointer) button_Liste_Ports_Program_Path , "clicked", G_CALLBACK (on_button_Liste_Ports_Program_Path_Open_clicked), NULL);
#ifdef         __SCRIPT_ENABLE
	g_signal_connect ((gpointer) button_Liste_Scripts_Path, "clicked", G_CALLBACK (on_button_Liste_Scripts_Path_Open_clicked), NULL);
#endif
	Initialisation_Liste_Signature ();
	Initialisation_Liste_Port ();
#ifdef         __SCRIPT_ENABLE
	Initialisation_Liste_Script ();
#endif
	Initialisation_Liste_Restore ();
}
