/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2010 Thierry Lagarde <thierry@autoscan-network.com>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include <gtk/gtk.h>

#ifndef         __WINDOWS_ENABLE
#include <sys/socket.h>
#else
#include <windows.h>
#include "Win32.h"
#endif

#include "Reseau.h"
#include "Root_Interface.h"
#include "Initialisation_Com.h"
#include "Add_Network_Subnet.h"
#include "Declaration_Constante.h"
#include "Modules.h"
#include "Debug.h"
#include "Execute.h"
#include "Image.h"
#include "Mem.h"
#include "Log.h"
#include "Objet.h"
#include "Configuration.h"
#include "Commun.h"

extern struct Struct_Combo_Liste Liste_ComboNetwork[];


gchar    *Gestion_Texte_Etat_Reseau (gpointer * pointer)
{
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gint	Etat_Connection;

	ERROR_if (pointer == NULL);
	Etat_Connection = (gint) Objet->Pointeur_Attacher;
	if ((Etat_Connection<ETAT_NB_MAX) && (Etat_Connection>=0))
		return g_strdup_printf (Objet->Texte_Defaut, Liste_ComboNetwork[Etat_Connection].Chaine);
	else
		return "failed";
}

void Change_Etat_Connection_Reseau(struct Struct_Liste_Reseau *Reseau, gint NouvelleEtat){


	Reseau->Etat_Connection = NouvelleEtat;
	switch (NouvelleEtat){
		case ETAT_DISCONNECTED :
					if (Reseau_Selectionner ==Reseau){
						Affiche_Onglet_Reseau(Reseau);
					}
					gtk_widget_set_sensitive (Reseau->Liste_Equipement_Type, FALSE);
					gtk_widget_set_sensitive (Reseau->Liste_Equipement_IP, FALSE);
					close(Reseau->Socket_Agent);
					break;
		case ETAT_CONNECTED :
					if (Reseau_Selectionner ==Reseau){
						Affiche_Onglet_Reseau(Reseau);
					}
					gtk_widget_set_sensitive (Reseau->Liste_Equipement_Type, TRUE);
					gtk_widget_set_sensitive (Reseau->Liste_Equipement_IP, TRUE);
					break;
		case ETAT_CLOSE :
					break;
		default :
				DEBUG_ERROR("Etat inconnu : %d",NouvelleEtat);
	}
}

void Nouveau_Octet_Envoye (int Nb_Octet)
{
}

void Nouveau_Octet_Recu (int Nb_Octet)
{
}

void Affiche_Onglet_Reseau (struct Struct_Liste_Reseau *Reseau){
	Demande_Stop_Agent_Raffraichir_Tout_Equipement(Reseau_Selectionner); 
	gtk_widget_hide (vbox_Milieu);
	Efface_Toute_Objet_Liste (Reseau_Selectionner, LISTE_INFO);
	Efface_Toute_Objet_Liste (Reseau_Selectionner, LISTE_CONFIG);
	Efface_Toute_Objet_Liste (Reseau_Selectionner, LISTE_INFO_HISTORIQUE);
	if (Reseau_Selectionner != NULL) {
		Efface_Toute_Objet_Liste (Reseau_Selectionner, LISTE_INFO_AUTRE);
		Efface_Toute_Objet_Liste (Reseau_Selectionner, LISTE_INFO_SNMP);
		Efface_Toute_Objet_Liste (Reseau_Selectionner, LISTE_INFO_INVENTAIRE);
		Destruction_Modules(TRUE);
		if (Reseau_Selectionner->Mode_Liste_Detaille) {
			g_object_ref (Reseau_Selectionner->Liste_Equipement_IP);
			gtk_container_remove (GTK_CONTAINER (scrollwin_liste_equipement), Reseau_Selectionner->Liste_Equipement_IP);
		}
		else {
			g_object_ref (Reseau_Selectionner->Liste_Equipement_Type);
			gtk_container_remove (GTK_CONTAINER (scrollwin_liste_equipement), Reseau_Selectionner->Liste_Equipement_Type);
		}
	}
	Equipement_Selectionner = NULL;
	Objet_Equipement_Selectionner = NULL;
	Reseau_Selectionner = Reseau;
	ID_Reseau_En_Cours = Reseau_Selectionner->Id_Reseau;
	if (Reseau->Mode_Liste_Detaille) {
		gtk_container_add (GTK_CONTAINER (scrollwin_liste_equipement), Reseau->Liste_Equipement_IP);
		gtk_widget_show (Reseau->Liste_Equipement_IP);
	}
	else{
		gtk_container_add (GTK_CONTAINER (scrollwin_liste_equipement), Reseau->Liste_Equipement_Type);
		gtk_widget_show (Reseau->Liste_Equipement_Type);
	}
	gtk_widget_set_sensitive (combobox_liste_Modules, FALSE);
	gtk_widget_set_sensitive (button_Refresh, FALSE);
	Modification_Toggle_En_Cours = TRUE;
	gtk_toggle_tool_button_set_active (GTK_TOGGLE_TOOL_BUTTON (toggletoolbutton_Alert_Intrusion), Reseau_Selectionner->Alert_Intrusion);
	gtk_toggle_tool_button_set_active (GTK_TOGGLE_TOOL_BUTTON (toggletoolbutton_Notification), FALSE);
	Modification_Toggle_En_Cours = FALSE;

	Reseau_Selectionner->Octet_Envoyer = 0;
	Reseau_Selectionner->Octet_Recu = 0;
	Reseau_Selectionner->Octet_Envoyer_Agent = 0;
	Reseau_Selectionner->Octet_Recu_Agent = 0;

	gtk_notebook_set_show_tabs (GTK_NOTEBOOK (notebook_Info), TRUE);

	gtk_widget_show(gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info),ONGLET_BASE));
	gtk_widget_show(gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info),ONGLET_CONFIG));

	gtk_widget_hide(gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info),ONGLET_INFO_HISTORIQUE));

	gtk_widget_hide(gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info),ONGLET_INFO_INVENTAIRE));
	gtk_widget_hide(gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info),ONGLET_INFO_AUTRE));
	gtk_widget_hide(gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info),ONGLET_INFO_SNMP));
	gtk_widget_hide(gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info),ONGLET_INFO_SOFT));
	gtk_widget_hide(gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info),ONGLET_INFO_TCP));
	gtk_widget_hide(gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info),ONGLET_INFO_ROUTE));
	gtk_widget_hide(gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info),ONGLET_INFO_ARP));
	gtk_widget_hide(gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info),ONGLET_INFO_PERIPHERIQUE));
	gtk_widget_hide(gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info),ONGLET_INFO_SERVICE));
	gtk_widget_hide(gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info),ONGLET_INFO_INTERFACE));
	gtk_widget_hide(gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_Info),ONGLET_INFO_DEBUG_DAEMON));

	Ajouter_Nouvelle_Objet (INFO_NAME_RESEAU, NULL, (gpointer *) Reseau_Selectionner->Nom_Reseau, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
	Ajouter_Nouvelle_Objet (INFO_INTERFACE_AGENT, NULL, (gpointer *) Reseau_Selectionner->Interface, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
	Ajouter_Nouvelle_Objet (INFO_ETAT_RESEAU, NULL, (gpointer *) Reseau_Selectionner->Etat_Connection, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
	Ajouter_Nouvelle_Objet (INFO_COMMUNAUTE_SNMP_AGENT, NULL, (gpointer *) Reseau_Selectionner->Communaute_Snmp, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
	Ajouter_Nouvelle_Objet (INFO_IP_AGENT, NULL, (gpointer *) Reseau_Selectionner->Ip_Agent, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
	Ajouter_Nouvelle_Objet (INFO_NB_EQUIPEMENT, NULL, (gint)Reseau_Selectionner->Nb_Equipement, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
	Ajouter_Nouvelle_Objet (INFO_NB_EQUIPEMENT_SCAN, NULL,  (gint)Reseau_Selectionner->Nb_Equipement_En_Cours_De_Scan, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
	Ajouter_Nouvelle_Objet (INFO_NB_EQUIPEMENT_ATTENTE, NULL, (gint) Reseau_Selectionner->Nb_Equipement_En_Attente_De_Scan, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
	Ajouter_Nouvelle_Objet (INFO_NB_THREAD, NULL, (gint)Reseau_Selectionner->Nb_Thread_En_Cours, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);

	Ajouter_Nouvelle_Objet (INFO_INTERFACE_AGENT_VERSION, NULL, (gpointer *) Reseau_Selectionner->Agent_Version, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
	Ajouter_Nouvelle_Objet (INFO_INTERFACE_AGENT_CONFIG, NULL, (gpointer *) Reseau_Selectionner->Agent_Config, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
	Ajouter_Nouvelle_Objet (INFO_INTERFACE_AGENT_LOGS, NULL, (gpointer *) Reseau_Selectionner->Agent_Logs, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
	Ajouter_Nouvelle_Objet (INFO_INTERFACE_AGENT_COMPIL, NULL, (gpointer *) Reseau_Selectionner->Agent_Compil, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);

	Ajouter_Nouvelle_Objet (INFO_GLOBAL_SSH_USER, NULL, (gpointer *) &Reseau_Selectionner->Global_Ssh_User, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_CONFIG);
	Ajouter_Nouvelle_Objet (INFO_GLOBAL_VNC_PASSWORD, NULL, (gpointer *) &Reseau_Selectionner->Global_Vnc_Password, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_CONFIG);
	Ajouter_Nouvelle_Objet (INFO_CONTACT_ADMIN, NULL, (gpointer *) &Reseau_Selectionner->Contact_Admin, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_CONFIG);
	Ajouter_Nouvelle_Objet (INFO_EMAIL_ALERT_INTRUSION, NULL, (gpointer *)&Reseau_Selectionner->Email_Alert_Intrusion, NULL, 0, PERE_RACINE, NULL, PERE_RACINE, PERE_RACINE, PERE_RACINE, PERE_RACINE, ID_Reseau_En_Cours, LISTE_CONFIG);
}


void Change_Etat_Raffraichir_Reseau(struct Struct_Liste_Reseau *Reseau,gboolean Etat){
	GtkTreeModel *model = NULL;

	model = gtk_tree_view_get_model (GTK_TREE_VIEW (treeview_network));
	gtk_tree_store_set (GTK_TREE_STORE (model), &Reseau->ID_Arbre_Ligne,LISTE_ICON_ETAT_VISIBLE_NETWORK,Etat,-1);
}


void Retour_Debut_Rafraichir_Reseau (gpointer * Donnee)
{
	struct struct_Retour_Debut_Rafraichir_Tout_Equipement *Message = (struct struct_Retour_Debut_Rafraichir_Tout_Equipement *) Donnee;
	struct Struct_Liste_Reseau *Reseau = NULL;

	ERROR_if (Donnee == NULL);
	Reseau = Recupere_Pointeur_Structure_Reseau (Message->ID_Reseau);
	Change_Etat_Raffraichir_Reseau(Reseau,TRUE);
}


void Retour_Fin_Rafraichir_Reseau (gpointer * Donnee)
{
	struct struct_Retour_Fin_Rafraichir_Tout_Equipement *Message = (struct struct_Retour_Fin_Rafraichir_Tout_Equipement *) Donnee;
	struct Struct_Liste_Reseau *Reseau = NULL;

	ERROR_if (Donnee == NULL);
	Reseau = Recupere_Pointeur_Structure_Reseau (Message->ID_Reseau);
	Change_Etat_Raffraichir_Reseau(Reseau,FALSE);
}

gboolean Selectionne_Network (GtkWidget * widget, GdkEventButton * event, gpointer user_data)
{
	struct Struct_Liste_Reseau *Reseau = NULL;
	struct 	struct_Demande_Rafraichir_Tout_Equipement Message;
	GtkTreeModel *model = NULL;
	GtkTreePath *path = NULL;
	GtkTreeIter iter;
	gint      x, y;

	if (event->type == GDK_BUTTON_PRESS) {
		GdkEventButton *bev = (GdkEventButton *) event;

		model = gtk_tree_view_get_model (GTK_TREE_VIEW (widget));
		gdk_window_get_pointer (event->window, &x, &y, NULL);
		if (!gtk_tree_view_get_path_at_pos (GTK_TREE_VIEW (widget), x, y, &path, NULL, NULL, NULL)) {
			return FALSE;
		}
		gtk_tree_model_get_iter (GTK_TREE_MODEL (model), &iter, path);
		gtk_tree_model_get (model, &iter, POINTER_LIST, &Reseau, -1);
		switch (bev->button) {
		    case 1:
						Affiche_Onglet_Reseau (Reseau);
						break;
		    case 2:
			    break;
		    case 3:
						
							bzero (&Message, sizeof (struct struct_Demande_Rafraichir_Tout_Equipement));
							Message.ID_Reseau = Reseau->Id_Reseau;
							Communication_Envoie_Donnee (Reseau->Pid_Agent, DEMANDE_RAFRAICHIR_TOUT_EQUIPEMENT, (gpointer *) & Message, sizeof (Message), Reseau);
						break;
		}
	}
	return FALSE;
}



void Affiche_Info_Reseau (struct Struct_Liste_Reseau *Reseau)
{
	gchar    *Text_Octet_Agent = NULL,*Text_Total = NULL,*Text_Thread = NULL,*Text_recu = NULL,*Text_envoye = NULL;
	gdouble   Total, A_Faire;
	GtkTreeModel *model = NULL;

	Reseau->Compteur_Activite_Agent = 0; 

	if (Reseau->Nb_Equipement != 0) {
		if (Reseau->Octet_Recu > 1024)
			Text_recu = g_strdup_printf ("R : %.1f Ko/s", (((double) Reseau->Octet_Recu) / 1024));
		else
			Text_recu = g_strdup_printf ("R : %d o/s", Reseau->Octet_Recu);

		if (Reseau->Octet_Envoyer > 1024)
			Text_envoye = g_strdup_printf ("S : %.1f Ko/s", (((double) Reseau->Octet_Envoyer) / 1024));
		else
			Text_envoye = g_strdup_printf ("S : %d o/s", Reseau->Octet_Envoyer);

		Text_Octet_Agent = g_strdup_printf("%s %s",Text_recu,Text_envoye);
		Total = Reseau->Nb_Equipement - Reseau->Nb_Equipement_Erase;
		A_Faire = Reseau->Nb_Equipement_En_Cours_De_Scan + Reseau->Nb_Equipement_En_Attente_De_Scan;
		Text_Total = g_strdup_printf ("  Total : %d  (%d/%d)%%%d ", Reseau->Nb_Equipement - Reseau->Nb_Equipement_Erase, Reseau->Nb_Equipement_En_Cours_De_Scan, Reseau->Nb_Equipement_En_Attente_De_Scan, (int) (((Total - A_Faire) / Total) * 100));
	
		if (Rachaichi_Info_ListeReseau) {
			model = gtk_tree_view_get_model (GTK_TREE_VIEW (treeview_network));
			gtk_tree_store_set (GTK_TREE_STORE (model), &Reseau->ID_Arbre_Ligne,LISTE_POURCENTAGE_TEXTE_NETWORK, Text_Total, LISTE_POURCENTAGE_NETWORK, (int) (((Total - A_Faire) / Total) * 100) ,LISTE_POURCENTAGE_VISIBLE_NETWORK, TRUE, -1);//,USAGE_NETWORK,Text_Octet_Agent,THREAD_AGENT_NETWORK,Text_Thread,-1);
		}
		MYFREE (Text_Total);
	
		MYFREE (Text_recu);
		MYFREE (Text_envoye);
		MYFREE (Text_Octet_Agent);
	}
}



void Arreter_Tous_Les_Agents (void)
{
	struct Struct_Liste_Reseau *Reseau = NULL;
	guint     Nb_Objet_Liste, i;

	Nb_Objet_Liste = g_list_length (GList_Liste_Reseau);
	Log_free(Donnee_Cle_Main,g_strdup_printf( "Arret des agents (%d)******************\n", Nb_Objet_Liste));
	for (i = 0; i < Nb_Objet_Liste; i++) {
		Reseau = g_list_nth_data (GList_Liste_Reseau, i);
		if (Reseau->Etat_Connection == ETAT_CONNECTED){
			Log_free(Donnee_Cle_Main,g_strdup_printf( "Arret agent %d : [%d][%s]\n", i, Reseau->Id_Reseau, Reseau->Nom_Complet_Reseau));
		
		
			Log_free(Donnee_Cle_Main,g_strdup_printf("Arret Connection tcp : %s    socket : %d\n",Reseau->Nom_Complet_Reseau,Reseau->Socket_Agent));
		
#ifndef         __WINDOWS_ENABLE
		
			close(Reseau->Socket_Agent);
#else
#endif
		}
		else{
				Log_free(Donnee_Cle_Main,g_strdup_printf( "Arret agent [Close] %d : [%d][%s]\n", i, Reseau->Id_Reseau, Reseau->Nom_Complet_Reseau));
		}
	}
	Log_free(Donnee_Cle_Main,g_strdup_printf("Fin Arret des agents ****************\n"));
}

void Afficher_Liste_Reseau (void)
{
	struct Struct_Liste_Reseau *Reseau = NULL;
	guint     Nb_Objet_Liste, i;

	Nb_Objet_Liste = g_list_length (GList_Liste_Reseau);
	DEBUG_INFO("Affiche Les reseaux (%d)******************", Nb_Objet_Liste);
	for (i = 0; i < Nb_Objet_Liste; i++) {
		Reseau = g_list_nth_data (GList_Liste_Reseau, i);
		DEBUG_INFO("%d : [%d][%s]", i, Reseau->Id_Reseau, Reseau->Nom_Complet_Reseau);
	}
	DEBUG_INFO("Fin Reseau *****************");
}


struct Struct_Liste_Reseau *Recupere_Pointeur_Structure_Reseau (gint ID_Reseau)
{
	struct Struct_Liste_Reseau *Reseau = NULL;
	guint     Nb_Objet_Liste, i;



	Nb_Objet_Liste = g_list_length (GList_Liste_Reseau);
	for (i = 0; i < Nb_Objet_Liste; i++) {
		Reseau = g_list_nth_data (GList_Liste_Reseau, i);
		if (Reseau->Id_Reseau == ID_Reseau)
			return Reseau;
	}
	return NULL;
}

/*struct Struct_Liste_Reseau *Recupere_Pointeur_Reseau_Selectionner (GtkWidget * scrollwin)
{
	struct Struct_Liste_Reseau *Reseau = NULL;
	guint     Nb_Objet_Liste, i;

	Nb_Objet_Liste = g_list_length (GList_Liste_Reseau);
	for (i = 0; i < Nb_Objet_Liste; i++) {
		Reseau = g_list_nth_data (GList_Liste_Reseau, i);
		if (Reseau->scrollwin == scrollwin)
			return Reseau;
	}
	DEBUG_ERROR("Reseau Inconnu");
	return NULL;
}*/

gboolean Recherche_Si_Reseau_Existe_Deja (gchar * Nom_Complet_Reseau)
{
	struct Struct_Liste_Reseau *Reseau = NULL;
	guint     Nb_Objet_Liste, i;

	ERROR_if (Nom_Complet_Reseau == NULL);

	Nb_Objet_Liste = g_list_length (GList_Liste_Reseau);
	for (i = 0; i < Nb_Objet_Liste; i++) {
		Reseau = g_list_nth_data (GList_Liste_Reseau, i);
	
		if (strcmp (Reseau->Nom_Reseau, Nom_Complet_Reseau) == 0)
			return TRUE;
	}
	return FALSE;
}


struct Struct_Liste_Reseau *Creation_Structure_Nouveau_Reseau (gchar * Nom_Complet_Reseau, gchar * Nom_Reseau, gchar * Interface, gchar * Ip, gchar * Communaute_Snmp,gchar *Ip_Agent,gint Port_Agent)
{
	struct Struct_Liste_Reseau *Reseau = NULL;

	ERROR_if (Nom_Reseau == NULL);
	MALLOC(Reseau,sizeof (struct Struct_Liste_Reseau));
	Reseau->Nom_Complet_Reseau = Nom_Complet_Reseau;
	Reseau->Nom_Reseau = Nom_Reseau;
	Reseau->Interface = Interface;
	Reseau->Ip = Ip;
	Reseau->Ip_Agent = Ip_Agent;
	Reseau->Port_Agent = Port_Agent;
	Reseau->Communaute_Snmp = Communaute_Snmp;
	Reseau->Id_Reseau = Genere_ID_Reseau;
	Reseau->Pid_Agent = Pid_Agent_Initialisation;
	Reseau->Mode_Liste_Detaille = TRUE;
	Reseau->Ip_Dynamic = Config_Ip_Dynamic;
	Reseau->Compteur_Activite_Agent = 0;
	DEBUG_INFO("Ajouter Nouveau Reseau  Nom[%s]  ID[%d]", Reseau->Nom_Complet_Reseau, Reseau->Id_Reseau);
	return Reseau;
}


static gboolean expose_event (GtkWidget * widget, GdkEventExpose * event, gpointer data)
{
	struct Struct_Liste_Reseau *Reseau = (struct Struct_Liste_Reseau *) data;

	gdk_draw_drawable (widget->window, widget->style->fg_gc[GTK_WIDGET_STATE (widget)], Reseau->pixmap, event->area.x, event->area.y, event->area.x, event->area.y, event->area.width, event->area.height);
	return TRUE;
}

gboolean Network_leave_notify_event (GtkWidget * widget, GdkEventCrossing * event, gpointer user_data)
{
#ifdef         __BULLE_NETWORK_ENABLE
	gtk_widget_hide (Bulle_Reseau);
#endif
	return FALSE;
}


/*gboolean Network_notebook_click (GtkWidget * widget, GdkEventCrossing * event, gpointer data)
{
	struct Struct_Liste_Reseau *Reseau = (struct Struct_Liste_Reseau *) data;

	gtk_notebook_set_page (GTK_NOTEBOOK (notebook_reseau), Reseau->Id_Reseau);
	return FALSE;
}*/


void Copie_Subnet (struct Struct_Liste_Reseau *Reseau, GList * Glist)
{
	struct Struct_Subnet *Subnet = NULL, *Subnet_Copie = NULL;
	guint     Nb_Objet_Liste, i;

	Nb_Objet_Liste = g_list_length (Glist);
	for (i = 0; i < Nb_Objet_Liste; i++) {
		Subnet = g_list_nth_data (Glist, i);
		Subnet_Copie = NULL;
		MALLOC (Subnet_Copie, sizeof (struct Struct_Subnet));
	
		Subnet_Copie->Masque = Subnet->Masque;
		Subnet_Copie->A = Subnet->A;
		Subnet_Copie->B = Subnet->B;
		Subnet_Copie->C = Subnet->C;
		G_LIST_APPEND (Reseau->Glist_Subnet_Equipement, Subnet_Copie);
	}
}


/*
Attention : Toute les pointeurs de chaine seront stockés dans la structure donc il faut copie les chaines avant d'appeler cette fonction
*/
struct Struct_Liste_Reseau *Creation_Nouveau_Reseau (gchar * Nom_Reseau, gchar * Interface, gchar * Ip, gchar * Communaute_Snmp, gchar * Icon,int Socket_Agent_Init,gchar *Ip_Agent,gint Port_Agent)
{
	struct Struct_Liste_Reseau *Reseau = NULL;
	GtkTreeModel *model = NULL;
	GtkTreeIter Ligne;
	gchar    *Nom_Complet_Reseau = NULL;
	gint 	nb_reseau = 0;



	ERROR_if (Nom_Reseau == NULL);
	ERROR_if (Interface == NULL);
	ERROR_if (Ip == NULL);
	ERROR_if (Icon == NULL);
	ERROR_if (Ip_Agent == NULL);
	Reseau_Initialisation = NULL;
	Nom_Complet_Reseau = g_strdup_printf ("%s - %s:%s", Nom_Reseau, Interface, Ip);
	DEBUG_INFO("Nom_Complet_Reseau : [%s]   %s:%d",Nom_Complet_Reseau,Ip_Agent,Port_Agent);
	if (!Recherche_Si_Reseau_Existe_Deja (Nom_Reseau)) {
		Reseau = Creation_Structure_Nouveau_Reseau (Nom_Complet_Reseau, Nom_Reseau, Interface, Ip, Communaute_Snmp,Ip_Agent,Port_Agent);
		Reseau_Initialisation = Reseau;
		G_LIST_APPEND (GList_Liste_Reseau, Reseau);
	
		STRDUP(Reseau_Initialisation->Agent_Version, Reseau_Init_Info.Version);
		STRDUP(Reseau->Agent_Config, Reseau_Init_Info.Config);
		STRDUP(Reseau->Agent_Logs, Reseau_Init_Info.Logs);
		STRDUP(Reseau->Agent_Compil, Reseau_Init_Info.Compil);
		STRDUP(Reseau->Agent_Compil_Options, Reseau_Init_Info.Compil_Option);

	
#ifdef __DEBUG_COM
		Reseau->Log_Send = Create_Log(CATEG_COMM_SEND,Nom_Reseau,NULL,FALSE);
		Reseau->Log_Recv = Create_Log(CATEG_COMM_RECV,Nom_Reseau,NULL,FALSE);
#endif
	
		Demande_Demarrage_Agent (Genere_ID_Reseau,Nom_Reseau, Interface, Communaute_Snmp, TRUE);
		Genere_ID_Reseau++;
	
		Reseau->Liste_Equipement_Type = Create_Liste_Equipement (FALSE);
	
		Reseau->Liste_Equipement_IP = Create_Liste_Equipement (TRUE);
		if (Reseau->Id_Reseau == 0){
			gtk_container_add (GTK_CONTAINER (scrollwin_liste_equipement), Reseau->Liste_Equipement_IP);
			gtk_widget_show (Reseau->Liste_Equipement_Type);
		}
	
		Reseau->Socket_Agent = Socket_Agent_Init;
	
		Reseau->Icone_Reseau = Icon;
	
		Afficher_Liste_Reseau ();
	
		Reseau->icone = Chargement_Image (Reseau->Icone_Reseau, COULEUR);
	
		model = gtk_tree_view_get_model (GTK_TREE_VIEW (treeview_network));
		gtk_tree_store_append (GTK_TREE_STORE (model), &Ligne, NULL);
		Reseau->ID_Arbre_Ligne = Ligne;

		Reseau->Etat_Connection = ETAT_CONNECTED;
		gtk_tree_store_set (GTK_TREE_STORE (model), &Ligne,COL_ICON_NETWORK, Reseau->icone, POINTER_NETWORK, Reseau,
		COL_IS_DIRECTORY_NETWORK, FALSE, COL_TEXT_NETWORK,Reseau->Nom_Reseau ,
		LISTE_POURCENTAGE_TEXTE_NETWORK, "Total : -- (--/--)%---",
		LISTE_POURCENTAGE_NETWORK, 50 ,LISTE_POURCENTAGE_VISIBLE_NETWORK, TRUE,
		LISTE_ICON_ETAT_NETWORK,pixbuf_network_reload,
		LISTE_ICON_ETAT_VISIBLE_NETWORK,FALSE,
	
	
	
	
	
	
		COL_TEXT_LIST_VISIBLE_NETWORK, TRUE,
		LISTE_COMBOLIST_VISIBLE,TRUE,LISTE_COMBOLIST, Liste_ComboNetwork[Reseau->Etat_Connection].Chaine,
		-1);

	
		nb_reseau = g_list_length (GList_Liste_Reseau);
		if (nb_reseau<4)
			gtk_widget_set_size_request(scrolledwindow_network,-1,30*nb_reseau);
		else
			gtk_widget_set_size_request(scrolledwindow_network,-1,30*3);

		if (Reseau->Id_Reseau == 0){
			Reseau_Selectionner = Reseau;
			gtk_tree_selection_select_iter ( gtk_tree_view_get_selection (GTK_TREE_VIEW (treeview_network)),&Ligne);
		}
		return Reseau;
	}
	else {
		debug_printf (D_INFO_USER, __FILE__, __PRETTY_FUNCTION__, __LINE__, "[%s] : already exist", Nom_Complet_Reseau);
		MYFREE (Nom_Complet_Reseau);
		MYFREE (Nom_Reseau);
		MYFREE (Interface);
		MYFREE (Ip);
		MYFREE (Communaute_Snmp);
		MYFREE (Icon);
		MYFREE (Ip_Agent);
	
		return NULL;
	}
	Reseau_Initialisation = NULL;
	return NULL;
}


void Initialisation_Variable_Reseau (void)
{
	ID_Reseau_En_Cours = 0;
	GList_Liste_Reseau = NULL;
	Genere_ID_Reseau = 0;
	Reseau_Selectionner = NULL;
	Reseau_Initialisation = NULL;
	Equipement_Raffraichir_Tout = NULL;
	Rachaichi_Info_ListeReseau = TRUE;
}
