/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2010 Thierry Lagarde <thierry@autoscan-network.com>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include "Configuration.h"
#include "Xml.h"
#include "Debug.h"
#include "main.h"
#include "Settings_Interface.h"
#include "Root_Interface.h"


void Write_Config(void){
	xmlDocPtr doc = NULL;
	xmlNodePtr newxml = NULL;
	xmlNodePtr root_element = NULL;
	gchar    *Chemin = NULL;
	gint      hauteur, largeur;
	
	if (Config_Copy_Config) {
		Chemin = g_strdup_printf (DEFAULT_CONFIG, Info_User->pw_dir);
		XML_CREATE(Chemin, doc, root_element, CONFIG_NAME, "Copyright (c) Lagarde thierry. \nThis Database is available for free use by open source software under the terms of the GNU General Public License.\nContact <tlagarde@users.sourceforge.net>  for more information", "");
	}
	else
		XML_CREATE(DEFAULT_CONFIG_STATIC, doc, root_element, CONFIG_NAME, "Copyright (c) Lagarde thierry. \nThis Database is available for free use by open source software under the terms of the GNU General Public License.\nContact <tlagarde@users.sourceforge.net>  for more information", "");



	newxml = root_element;   
	XML_WRITE_STRING("Path_Logs", Config_Path_Logs);
	XML_WRITE_STRING("Path_Icon", Config_Path_Icon);
	XML_WRITE_STRING("Path_Config", Config_Path_Config);
	XML_WRITE_BOOLEAN("First_Start",FALSE);
	XML_WRITE_STRING("Path_Daemon", Config_Path_Daemon);	
	XML_WRITE_INT("Level_Debug",Config_Level_Debug);
#ifdef         __EGGTRAYICON_ENABLE
	XML_WRITE_BOOLEAN("Start_Minimized",gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (checkbutton_General_Interface_Minimized)));
	XML_WRITE_BOOLEAN("Minimized_Tray_Icon",gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (checkbutton_General_Interface_TrayIcon)));
#else
	XML_WRITE_BOOLEAN("Start_Minimized",FALSE);
	XML_WRITE_BOOLEAN("Minimized_Tray_Icon",FALSE);	
#endif	
	XML_WRITE_STRING("Server_Smtp", (gchar *) gtk_entry_get_text (GTK_ENTRY (entry_General_SMTP)));
#ifdef  __SOUND_ENABLE
	XML_WRITE_INT("Audio_Device",gtk_combo_box_get_active (GTK_COMBO_BOX (combobox_General_Audio_Device)));	
#else
	XML_WRITE_INT("Audio_Device",0);
#endif		
	XML_WRITE_STRING("Directory_Sound_Alert", Config_Directory_Sound_Alert);	
	XML_WRITE_INT("Root_Position_X",30);
	XML_WRITE_INT("Root_Position_Y",30);
	gtk_window_get_size ((GtkWindow *) window_root, &largeur, &hauteur);
	XML_WRITE_INT("Root_Size_X",largeur);
	XML_WRITE_INT("Root_Size_Y",hauteur);
	gtk_window_get_size ((GtkWindow *) dialog_Settings, &largeur, &hauteur);
	XML_WRITE_INT("Setting_Size_X",largeur);
	XML_WRITE_INT("Setting_Size_Y",hauteur);
	XML_WRITE_INT("IconList_Icon_Width",Config_IconList_Icon_Width);
	XML_WRITE_INT("V_Paned_Position",gtk_paned_get_position (GTK_PANED (vpaned_root)));
	XML_WRITE_INT("H_Paned_Position",gtk_paned_get_position (GTK_PANED (hpaned_root)));
	XML_WRITE_BOOLEAN("Tree_View_Set_Hover_Expand",Config_Tree_View_Set_Hover_Expand);
	XML_WRITE_BOOLEAN("Tree_View_Set_Rules_Hint",Config_Tree_View_Set_Rules_Hint);
	XML_WRITE_INT("Thread_Max",Config_Thread_Max);
	XML_WRITE_BOOLEAN("Normal_Mode",Config_Normal_Mode);
	XML_WRITE_BOOLEAN("Ip_Dynamic",Config_Ip_Dynamic);
	XML_WRITE_STRING("Wizard_Name_Network", Config_Wizard_Name_Network);
	XML_WRITE_STRING("Wizard_Icon_Network", Config_Wizard_Icon_Network);
	XML_WRITE_STRING("Wizard_Restore_Folder", Config_Wizard_Restore_Folder);
	XML_WRITE_STRING("Wizard_Connect_Ip_address", Config_Wizard_Connect_Ip_address);
	XML_WRITE_INT("Wizard_Connect_Port",Config_Wizard_Connect_Port);
	XML_WRITE_STRING("Wizard_Connect_Password", Config_Wizard_Connect_Password);

	if (Config_Copy_Config){
		XML_SAVE(Chemin, doc);
		MYFREE(Chemin);
	}
	else
		XML_SAVE(DEFAULT_CONFIG_STATIC, doc);
	XML_CLOSE (doc);
}

void Read_Config(void){
	xmlDocPtr doc = NULL;
	xmlNode  *root_element = NULL;
	xmlNodePtr xmlnode = NULL;
	gchar    *Chemin = NULL;
	

	Config_Copy_Config = FALSE;
	Config_Path_Logs = NULL;
	Config_Path_Icon = NULL;
	Config_Path_Config = NULL;
	Config_Server_Smtp = NULL;
	Config_Directory_Sound_Alert = NULL;
	Config_Wizard_Name_Network = NULL;
	Config_Wizard_Icon_Network = NULL;
	Config_Wizard_Restore_Folder = NULL;
	Config_Wizard_Connect_Ip_address = NULL;
	Config_Wizard_Connect_User = NULL;
	Config_Wizard_Connect_Password = NULL;	

	if (Info_User==NULL){
		printf("Error : Info_User==NULL");
		exit(-1);
	}
	if (Info_User->pw_dir==NULL){
		printf("Error : Info_User->pw_dir==NULL");
		exit(-1);
	}
	Chemin = g_strdup_printf (DEFAULT_CONFIG, Info_User->pw_dir);
    if ((root_element = OpenXml(DEFAULT_CONFIG_STATIC, CONFIG_NAME, &doc)) == NULL){
		Config_Copy_Config = TRUE;
		 if ((root_element = OpenXml(Chemin, CONFIG_NAME, &doc)) == NULL)
			 if ((root_element = OpenXml(DEFAULT_CONFIG_START, CONFIG_NAME, &doc)) == NULL)	{
				printf("File not found [" CONFIG_NAME "]\n");
			 	exit(-1);
		 	}
	}
	xmlnode = root_element;
	XML_READ_STRING(Config_Path_Logs,"Path_Logs",NULL) ;
	XML_READ_STRING(Config_Path_Icon,"Path_Icon",NULL) ;
	XML_READ_STRING(Config_Path_Config,"Path_Config","/usr/share/apps/autoscan-network") ;
	XML_READ_BOOL(Config_First_Start,"First_Start",TRUE);
	XML_READ_STRING(Config_Path_Daemon,"Path_Daemon",NULL);
	XML_READ_INT(Config_Level_Debug,"Level_Debug",D_INFO);
	XML_READ_BOOL(Config_Start_Minimized,"Start_Minimized",FALSE);		
	XML_READ_BOOL(Config_Minimized_Tray_Icon,"Minimized_Tray_Icon",FALSE);
	XML_READ_STRING(Config_Server_Smtp,"Server_Smtp","smtp.server.com") ;
	XML_READ_INT(Config_Audio_Device,"Audio_Device",0);
	XML_READ_STRING(Config_Directory_Sound_Alert,"Directory_Sound_Alert","/usr/share/sounds/autoscan-network/redalert.ogg") ;
	XML_READ_INT(Config_Root_Position_X,"Root_Position_X",0);
	XML_READ_INT(Config_Root_Position_Y,"Root_Position_Y",0);	
	XML_READ_INT(Config_Root_Size_X,"Root_Size_X",600);		
	XML_READ_INT(Config_Root_Size_Y,"Root_Size_Y",600);			
	XML_READ_INT(Config_Setting_Size_X,"Setting_Size_X",600);
	XML_READ_INT(Config_Setting_Size_Y,"Setting_Size_Y",600);
	XML_READ_INT(Config_IconList_Icon_Width,"IconList_Icon_Width",70);
	XML_READ_INT(Config_V_Paned_Position,"V_Paned_Position",150);
	XML_READ_INT(Config_H_Paned_Position,"H_Paned_Position",195);
	XML_READ_BOOL(Config_Tree_View_Set_Hover_Expand,"Tree_View_Set_Hover_Expand",FALSE);	
	XML_READ_BOOL(Config_Tree_View_Set_Rules_Hint,"Tree_View_Set_Rules_Hint",FALSE);	
	XML_READ_INT(Config_Thread_Max,"Thread_Max",50);	
	XML_READ_BOOL(Config_Normal_Mode,"Normal_Mode",TRUE);		
	XML_READ_BOOL(Config_Ip_Dynamic,"Ip_Dynamic",TRUE);	
	XML_READ_STRING(Config_Wizard_Name_Network,"Wizard_Name_Network","Local network") ;
	XML_READ_STRING(Config_Wizard_Icon_Network,"Wizard_Icon_Network","Network/drop.png") ;
	XML_READ_STRING(Config_Wizard_Restore_Folder,"Wizard_Restore_Folder","/home/") ;
	XML_READ_STRING(Config_Wizard_Connect_Ip_address,"Wizard_Connect_Ip_address","daemon.mynetwork.com") ;
	XML_READ_INT(Config_Wizard_Connect_Port,"Wizard_Connect_Port",4555);	
	XML_READ_STRING(Config_Wizard_Connect_User,"Wizard_Connect_User","User") ;	
	XML_READ_STRING(Config_Wizard_Connect_Password,"Wizard_Connect_Password","autoscan-network-passwd") ;	
	XML_CLOSE (doc);
}
