/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2010 Thierry Lagarde <thierry@autoscan-network.com>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#include "Restoration_Interface.h"
#include "Equipement.h"
#include "Equipement_Port.h"
#include "Equipement_Historique.h"
#include "Reseau.h"
#include "Debug.h"
#include "Objet.h"
#include "Commun.h"
#include "Initialisation_Com.h"
#include "Reseau.h"
#include "Animation.h"
#include "Objet_Liste.h"
#include "Xml.h"
#include "Win32.h"

extern struct Struct_Liste_Port_UDP Liste_Port_UDP[];

void Lit_Donnee_Xml_Restoration_Interface (xmlNodePtr xmlnodecurrent, gint ID_Reseau, gboolean Ip_Dynamic)
{
	struct Struct_Equipement *Equipement = NULL;
	struct Struct_Port *Port_Equipement = NULL;
	struct Struct_Modele_Objet *Objet_Equipement_Par_Ip = NULL,*Objet_Equipement_Par_Type = NULL;
	struct Struct_Historique *Historique = NULL;
	struct struct_Demande_Notication_Critique_Etat_Equipement Message;
	struct Struct_Liste_Reseau *Reseau = NULL;
	struct struct_Demande_Notication_Critique_Etat_Port Message_Port;
	GtkTreeModel *model = NULL;
	GtkTreePath *path = NULL;
	xmlNodePtr xml_Enfant = NULL, xml_Enfant_Port = NULL;
	xmlNodePtr xmlnode = NULL;
	gchar    *Address_IP = NULL, *Address_MAC = NULL;
	gint      NumPort, Erreur_Sscanf, NumRegistration;
	gchar    *Point_DNS = NULL, Dns[TAILLE_CHAINE_NOM_DNS + 1],*Text = NULL;
	gint      Taille_Chaine,udp,Port,Level;

	XML_CHECK_NODE(xmlnodecurrent,"Equipment");
	Reseau = Recupere_Pointeur_Structure_Reseau (ID_Reseau);
	MALLOC (Equipement, sizeof (struct Struct_Equipement));

	xmlnode = xmlnodecurrent;
	XML_READ_BOOL(Equipement->Agent_AutoScan ,"Agent_AutoScan",FALSE);

	XML_READ_STRING(Address_MAC,"Address_MAC","???");
	if ((Erreur_Sscanf = sscanf (Address_MAC, "%02X:%02X:%02X:%02X:%02X:%02X", (int *) &Equipement->ID_Equipement[0], (int *) &Equipement->ID_Equipement[1], (int *) &Equipement->ID_Equipement[2], (int *) &Equipement->ID_Equipement[3], (int *) &Equipement->ID_Equipement[4], (int *) &Equipement->ID_Equipement[5])) != 6) {
		DEBUG_ERROR("Recuperation Erreur(%d) MAC ID_Equipement %02X:%02X:%02X:%02X:%02X:%02X\n", Erreur_Sscanf);
	}
	strcpy ((char *)Equipement->Adresse_MAC_Char, Address_MAC);
	MYFREE (Address_MAC);

	XML_READ_STRING(Address_IP ,"Address_IP","???");
	if ((!Ip_Dynamic) || (Equipement->Agent_AutoScan)) {
		if ((Erreur_Sscanf = sscanf (Address_IP, "%d.%d.%d.%d", (int *) &Equipement->ID_Equipement[6], (int *) &Equipement->ID_Equipement[7], (int *) &Equipement->ID_Equipement[8], (int *) &Equipement->ID_Equipement[9])) != 4) {
			DEBUG_ERROR("Recuperation IP ID_Equipement  (%d)", Erreur_Sscanf);
		}
		strcpy ((char *)Equipement->Adresse_Ip_Char, Address_IP);
	}
	else
		strcpy ((char *)Equipement->Adresse_Ip_Char, "0.0.0.0");
	MYFREE (Address_IP);

	XML_READ_BOOL(Equipement->Equipement_Allumer,"Agent_AutoScan",FALSE);

	XML_READ_STRING(Equipement->User_Smb,"User_Smb",NULL);
	XML_READ_STRING(Equipement->Password_Smb,"Password_Smb",NULL);
	XML_READ_STRING(Equipement->Contact_Admin,"Admin_Email",NULL);
	XML_READ_STRING(Equipement->Localisation,"Localisation",NULL);
	XML_READ_STRING(Equipement->Num_Serie,"Serial_Number",NULL);
	XML_READ_STRING(Equipement->Num_Serie_Ecran,"Serial_Number_Display",NULL);
	XML_READ_STRING(Equipement->Num_Serie_Imprimante,"Serial_Number_Printer",NULL);
	XML_READ_STRING(Equipement->Num_Serie_OS,"Serial_Number_OS",NULL);
	XML_READ_STRING(Equipement->Num_Serie_Office_Suite,"Serial_Number_Office_Suite",NULL);
	XML_READ_STRING(Equipement->Processeur,"Processor",NULL);;
	XML_READ_STRING(Equipement->Memoire,"Memory",NULL);
	XML_READ_STRING(Equipement->Disque,"Disk",NULL);
	XML_READ_STRING(Equipement->Contact,"Contact",NULL);
	XML_READ_STRING(Equipement->Tel_Contact,"Tel_Contact",NULL);
	XML_READ_STRING(Equipement->Notes,"Notes",NULL);
	XML_READ_STRING(Equipement->Nom_DNS_Complet,"Dns",NULL);
	if (Equipement->Nom_DNS_Complet != NULL) {
		Point_DNS = index (Equipement->Nom_DNS_Complet, '.');
		if (Point_DNS != NULL) {
			Taille_Chaine = Point_DNS - Equipement->Nom_DNS_Complet;
			strncpy (Dns, Equipement->Nom_DNS_Complet, Taille_Chaine);
			Dns[Taille_Chaine] = 0;
			Equipement->Nom_DNS = g_strdup (Dns);
		}
	}
	XML_READ_STRING(Equipement->Alias,"Alias",NULL);
	XML_READ_BOOL(Equipement->Notification_En_Cours,"Notification",FALSE);
	XML_READ_BOOL(Equipement->GateWay,"Gateway",FALSE);
	XML_READ_BOOL(Equipement->Routage,"Routage",FALSE);
	XML_READ_BOOL(Equipement->mss,"Mss",FALSE);
	XML_READ_BOOL(Equipement->Snmp_Ouvert,"Snmp_Open",FALSE);
	XML_READ_BOOL(Equipement->Deplier,"Expand",FALSE);
	XML_READ_BOOL(Equipement->User_SSH_Default,"User_SSH_Default",TRUE);
	XML_READ_STRING(Equipement->User_SSH,"User_SSH",NULL);
	XML_READ_BOOL(Equipement->Password_VNC_Default,"Password_VNC_Default",TRUE);
	XML_READ_STRING(Equipement->password_vnc,"Password_Vnc",NULL);
	XML_READ_BOOL(Equipement->View_Only_VNC,"View_Only_VNC",FALSE);	


	xmlnodecurrent = xmlnodecurrent->children;
	while ((xmlnodecurrent != NULL) && (xmlnodecurrent->type != XML_ELEMENT_NODE))
		xmlnodecurrent = xmlnodecurrent->next;
	if (xmlnodecurrent) {
	
		if (!xmlnodecurrent->name || g_strcasecmp ((char *)xmlnodecurrent->name, "FingerPrinting") != 0)
			return;
	
		xmlnode = xmlnodecurrent;
		XML_READ_STRING_COPY(Equipement->Md5_Signature,"MD5");
		XML_READ_STRING_COPY(Equipement->Md5_Signature_W,"MD5_W");
		XML_READ_STRING(Equipement->Entete_FTP,"Header_FTP",NULL);
		XML_READ_STRING(Equipement->Entete_HTTP,"Header_HTTP",NULL);
		XML_READ_STRING(Equipement->Entete_IMAP,"Header_IMAP",NULL);
		XML_READ_STRING(Equipement->Entete_SMTP,"Header_SMTP",NULL);
		XML_READ_STRING(Equipement->Entete_SSH,"Header_SSH",NULL);
		XML_READ_STRING(Equipement->Entete_TELNET,"Header_TELNET",NULL);
		XML_READ_STRING(Equipement->Entete_SIP,"Header_SIP",NULL);
		XML_READ_STRING(Equipement->Entete_POP3,"Header_POP3",NULL);
		XML_READ_STRING(Equipement->Entete_VNC0,"Header_VNC0",NULL);
		XML_READ_STRING(Equipement->Entete_VNC1,"Header_VNC1",NULL);
		XML_READ_STRING(Equipement->Entete_RTSP ,"Header_RTSP",NULL);
		XML_READ_STRING(Equipement->Entete_IPP,"Header_IPP",NULL);
		XML_READ_STRING(Equipement->Entete_VNC_HTTP,"Header_VNC_HTTP",NULL);
		XML_READ_STRING(Equipement->Debug_Signature ,"Debug",NULL);
	

	
		xmlnodecurrent = xmlnodecurrent->next;
		while ((xmlnodecurrent != NULL) && (xmlnodecurrent->type != XML_ELEMENT_NODE))
			xmlnodecurrent = xmlnodecurrent->next;
		if (!xmlnodecurrent->name || g_strcasecmp ((char *)xmlnodecurrent->name, "Ports") != 0)
			return;
	
		xmlnode = xmlnodecurrent;
		XML_READ_INT(Equipement->Nb_Port_Ouvert,"Open",0);
		XML_READ_INT(Equipement->Nb_Port_Total_Scanner,"Total",0);
		XML_READ_INT(Equipement->Nb_Port_Firewaller ,"firewalled",0);
	

		xml_Enfant_Port = xmlnodecurrent->children;
		while ((xml_Enfant_Port != NULL) && (xml_Enfant_Port->type != XML_ELEMENT_NODE))
			xml_Enfant_Port = xml_Enfant_Port->next;
	
		while (xml_Enfant_Port->name && g_strcasecmp ((char *)xml_Enfant_Port->name, "Open") != 0) {
			xml_Enfant_Port = xml_Enfant_Port->next;
			while ((xml_Enfant_Port != NULL) && (xml_Enfant_Port->type != XML_ELEMENT_NODE))
				xml_Enfant_Port = xml_Enfant_Port->next;
		}
		if (!xml_Enfant_Port->name || g_strcasecmp ((char *)xml_Enfant_Port->name, "Open") != 0)
			return;

		xml_Enfant_Port = xml_Enfant_Port->children;
		while ((xml_Enfant_Port != NULL) && (xml_Enfant_Port->type != XML_ELEMENT_NODE))
			xml_Enfant_Port = xml_Enfant_Port->next;
		while (xml_Enfant_Port) {
			if (!xml_Enfant_Port->name || g_strcasecmp ((char *)xml_Enfant_Port->name, "Port") != 0)
				return;
		
			xmlnode = xml_Enfant_Port;
			XML_READ_INT(Port,"Num",0);
			Port_Equipement = Ajouter_Nouveau_Port_Equipement (Equipement, Port, OUVERT);
		
			XML_READ_BOOL(Port_Equipement->Notification_En_Cours,"Notification",FALSE);
			if (Port_Equipement->Notification_En_Cours) {
				bzero (&Message_Port, sizeof (struct struct_Demande_Notication_Critique_Etat_Port));
				Message_Port.ID_Reseau = ID_Reseau;
				memcpy (Message_Port.ID_Equipement, Equipement->ID_Equipement, MAC_ADDR_LEN + IP_ADDR_LEN + 1);
				Message_Port.Num_Port = Port_Equipement->Num_Port;
				Communication_Envoie_Donnee (Reseau->Pid_Agent, DEMANDE_NOTIFICATION_CRITIQUE_ETAT_PORT, (gpointer *) & Message_Port, sizeof (Message_Port), Reseau);
			}
		
			xml_Enfant_Port = xml_Enfant_Port->next;
			while ((xml_Enfant_Port != NULL) && (xml_Enfant_Port->type != XML_ELEMENT_NODE))
				xml_Enfant_Port = xml_Enfant_Port->next;
		}
		xml_Enfant_Port = xmlnodecurrent->children;
		while ((xml_Enfant_Port != NULL) && (xml_Enfant_Port->type != XML_ELEMENT_NODE))
			xml_Enfant_Port = xml_Enfant_Port->next;
		while (xml_Enfant_Port->name && g_strcasecmp ((char *)xml_Enfant_Port->name, "Close") != 0) {
			xml_Enfant_Port = xml_Enfant_Port->next;
			while ((xml_Enfant_Port != NULL) && (xml_Enfant_Port->type != XML_ELEMENT_NODE))
				xml_Enfant_Port = xml_Enfant_Port->next;
		}
		if (!xml_Enfant_Port->name || g_strcasecmp ((char *)xml_Enfant_Port->name, "Close") != 0)
			return;
		xml_Enfant_Port = xml_Enfant_Port->children;
		while ((xml_Enfant_Port != NULL) && (xml_Enfant_Port->type != XML_ELEMENT_NODE))
			xml_Enfant_Port = xml_Enfant_Port->next;

		while (xml_Enfant_Port) {
			if (!xml_Enfant_Port->name || g_strcasecmp ((char *)xml_Enfant_Port->name, "Port") != 0)
				return;
		
			xmlnode = xml_Enfant_Port;
			XML_READ_INT(Port,"Num",0);
			Ajouter_Nouveau_Port_Equipement_Fermer_Firewall (Equipement, Port,FERMER,0);
		
			xml_Enfant_Port = xml_Enfant_Port->next;
			while ((xml_Enfant_Port != NULL) && (xml_Enfant_Port->type != XML_ELEMENT_NODE))
				xml_Enfant_Port = xml_Enfant_Port->next;
		}
		xml_Enfant_Port = xmlnodecurrent->children;
		while ((xml_Enfant_Port != NULL) && (xml_Enfant_Port->type != XML_ELEMENT_NODE))
			xml_Enfant_Port = xml_Enfant_Port->next;
		while (xml_Enfant_Port->name && g_strcasecmp ((char *)xml_Enfant_Port->name, "Firewall") != 0) {
			xml_Enfant_Port = xml_Enfant_Port->next;
			while ((xml_Enfant_Port != NULL) && (xml_Enfant_Port->type != XML_ELEMENT_NODE))
				xml_Enfant_Port = xml_Enfant_Port->next;
		}
		if (!xml_Enfant_Port->name || g_strcasecmp ((char *)xml_Enfant_Port->name, "Firewall") != 0)
			return;
		xml_Enfant_Port = xml_Enfant_Port->children;
		while ((xml_Enfant_Port != NULL) && (xml_Enfant_Port->type != XML_ELEMENT_NODE))
			xml_Enfant_Port = xml_Enfant_Port->next;

		while (xml_Enfant_Port) {
			if (!xml_Enfant_Port->name || g_strcasecmp ((char *)xml_Enfant_Port->name, "Port") != 0)
				return;
		
			xmlnode = xml_Enfant_Port;
			XML_READ_INT(Port,"Num",0);
			Ajouter_Nouveau_Port_Equipement_Fermer_Firewall (Equipement,Port ,FIREWALLED,0);
		
			xml_Enfant_Port = xml_Enfant_Port->next;
			while ((xml_Enfant_Port != NULL) && (xml_Enfant_Port->type != XML_ELEMENT_NODE))
				xml_Enfant_Port = xml_Enfant_Port->next;
		}
		xml_Enfant_Port = xmlnodecurrent->children;
		while ((xml_Enfant_Port != NULL) && (xml_Enfant_Port->type != XML_ELEMENT_NODE))
			xml_Enfant_Port = xml_Enfant_Port->next;
		while (xml_Enfant_Port->name && g_strcasecmp ((char *)xml_Enfant_Port->name, "UDP") != 0) {
			xml_Enfant_Port = xml_Enfant_Port->next;
			while ((xml_Enfant_Port != NULL) && (xml_Enfant_Port->type != XML_ELEMENT_NODE))
				xml_Enfant_Port = xml_Enfant_Port->next;
		}
		if (!xml_Enfant_Port->name || g_strcasecmp ((char *)xml_Enfant_Port->name, "UDP") != 0)
			return;
		xml_Enfant_Port = xml_Enfant_Port->children;
		while ((xml_Enfant_Port != NULL) && (xml_Enfant_Port->type != XML_ELEMENT_NODE))
			xml_Enfant_Port = xml_Enfant_Port->next;

		udp = 0;
		while (xml_Enfant_Port) {
			if (!xml_Enfant_Port->name || g_strcasecmp ((char *)xml_Enfant_Port->name, "Port") != 0)
				return;
		
			xmlnode = xml_Enfant_Port;
			XML_READ_INT(NumPort,"Num",0);
			ERROR_if (NumPort!=Liste_Port_UDP[udp].Num_Port_UDP);
			XML_READ_INT(Equipement->Liste_Etat_Udp[udp],"State",UNKOWN_UDP);
		
			xml_Enfant_Port = xml_Enfant_Port->next;
			while ((xml_Enfant_Port != NULL) && (xml_Enfant_Port->type != XML_ELEMENT_NODE))
				xml_Enfant_Port = xml_Enfant_Port->next;
			udp++;
		}

		xmlnodecurrent = xmlnodecurrent->next; 
		while ((xmlnodecurrent != NULL) && (xmlnodecurrent->type != XML_ELEMENT_NODE))
			xmlnodecurrent = xmlnodecurrent->next;
		if (!xmlnodecurrent->name || g_strcasecmp ((char *)xmlnodecurrent->name, "History") != 0)
			return;
		xml_Enfant = xmlnodecurrent->children;
		while ((xml_Enfant != NULL) && (xml_Enfant->type != XML_ELEMENT_NODE))
			xml_Enfant = xml_Enfant->next;
		while (xml_Enfant) {
			if (!xml_Enfant->name || g_strcasecmp ((char *)xml_Enfant->name, "History") != 0)
				return;
		
			xmlnode = xml_Enfant;
			Text = NULL;
			XML_READ_STRING(Text,"Text",NULL);
			XML_READ_INT(Level,"Level",HISTORIQUE_INFO);
			Historique = Ajouter_Historique (Equipement, Text, Level);
		
		
			xml_Enfant = xml_Enfant->next;
			while ((xml_Enfant != NULL) && (xml_Enfant->type != XML_ELEMENT_NODE))
				xml_Enfant = xml_Enfant->next;
		}

	
		xmlnodecurrent = xmlnodecurrent->next;
		while ((xmlnodecurrent != NULL) && (xmlnodecurrent->type != XML_ELEMENT_NODE))
			xmlnodecurrent = xmlnodecurrent->next;
		if (!xmlnodecurrent->name || g_strcasecmp ((char *)xmlnodecurrent->name, "Smb") != 0)
			return;
	
		xmlnode = xmlnodecurrent;
		XML_READ_STRING_COPY((char *)Equipement->Smb.HostName,"Host_Name");
		XML_READ_STRING_COPY((char *)Equipement->Smb.DomainName,"Domain_Name");
		XML_READ_STRING_COPY((char *)Equipement->Smb.Utilisateur,"User");
	
	
		NumRegistration = 0;
		xml_Enfant = xmlnodecurrent->children;
		while ((xml_Enfant != NULL) && (xml_Enfant->type != XML_ELEMENT_NODE))
			xml_Enfant = xml_Enfant->next;
		while (xml_Enfant) {
			if (!xml_Enfant->name || g_strcasecmp ((char *)xml_Enfant->name, "Registration") != 0)
				return;
		
			xmlnode = xml_Enfant;
			XML_READ_INT(Equipement->Smb.Smb_Registration[NumRegistration].Numero,"Number",0);
			XML_READ_INT(Equipement->Smb.Smb_Registration[NumRegistration].Type,"Type",0);
			XML_READ_STRING_COPY((char *)Equipement->Smb.Smb_Registration[NumRegistration].Name,"Name");
		
			xml_Enfant = xml_Enfant->next;
			while ((xml_Enfant != NULL) && (xml_Enfant->type != XML_ELEMENT_NODE))
				xml_Enfant = xml_Enfant->next;
			NumRegistration++;
		}

		xmlnodecurrent = xmlnodecurrent->next;
		while ((xmlnodecurrent != NULL) && (xmlnodecurrent->type != XML_ELEMENT_NODE))
			xmlnodecurrent = xmlnodecurrent->next;
		if (!xmlnodecurrent->name || g_strcasecmp ((char *)xmlnodecurrent->name, "Snmp") != 0)
			return;
		if (xmlnodecurrent){
		
			xmlnode = xmlnodecurrent;
			XML_READ_STRING_COPY(Equipement->Snmp.System_Name,"System_Name");
			XML_READ_STRING_COPY(Equipement->Snmp.Description,"Description");
			XML_READ_STRING(Equipement->Snmp_Info_Device ,"Info_Device",NULL);
		
		}
	}
	Optimisation_Info_Equipement(Equipement);

	Objet_Equipement_Par_Type = Afficher_Nouveau_Equipement (Equipement, ID_Reseau);
	if (Equipement->Deplier) {
		model = gtk_tree_view_get_model (GTK_TREE_VIEW (Widget_Liste (Objet_Equipement_Par_Type, Reseau)));
		path = gtk_tree_model_get_path (model, &Objet_Equipement_Par_Type->ID_Arbre_Ligne);
		gtk_tree_view_expand_to_path (GTK_TREE_VIEW (Widget_Liste (Objet_Equipement_Par_Type, Reseau)), path);
	}

	if (!Equipement->Agent_AutoScan){
		Affiche_Icone_Defaut_Griser_Objet_liste (Objet_Equipement_Par_Type, Reseau);
		Change_Couleur_Gris_Texte_liste (Objet_Equipement_Par_Type, Reseau);
	}

	Objet_Equipement_Par_Ip = Afficher_Nouveau_Equipement_Liste_Detaille (Equipement, ID_Reseau,FALSE);
	if (!Equipement->Agent_AutoScan){
		Affiche_Icone_Defaut_Griser_Objet_liste (Objet_Equipement_Par_Ip, Reseau);
		Change_Couleur_Gris_Texte_liste (Objet_Equipement_Par_Ip, Reseau);
	}


	if (Equipement->Notification_En_Cours) {
		Objet_Equipement_Par_Type->Notification_En_Cours = TRUE;
		Objet_Equipement_Par_Ip->Notification_En_Cours = TRUE;
		bzero (&Message, sizeof (struct struct_Demande_Notication_Critique_Etat_Equipement));
		Message.ID_Reseau = Objet_Equipement_Par_Type->ID_Reseau;
		memcpy (Message.ID_Equipement, Equipement->ID_Equipement, MAC_ADDR_LEN + IP_ADDR_LEN + 1);
		Communication_Envoie_Donnee (Reseau->Pid_Agent, DEMANDE_NOTIFICATION_CRITIQUE_ETAT_EQUIPEMENT, (gpointer *) & Message, sizeof (Message), Reseau);
	
		model = gtk_tree_view_get_model (GTK_TREE_VIEW (Widget_Liste (Objet_Equipement_Par_Ip, Reseau)));
		gtk_tree_store_set (GTK_TREE_STORE (model), &Objet_Equipement_Par_Ip->ID_Arbre_Ligne, NOTIFICATION, "YES", -1);
	}
}



void Lit_Xml_Restoration_Interface (xmlDocPtr doc, gint ID_Reseau, gboolean Ip_Dynamic)
{
	struct Struct_Liste_Reseau *Reseau = NULL;
	xmlNode  *root_element = NULL;
	xmlNodePtr node;

	ERROR_if (doc == NULL);
	Reseau = Recupere_Pointeur_Structure_Reseau (ID_Reseau);
	root_element = xmlDocGetRootElement (doc);
	for (node = root_element->children; node != NULL; node = node->next) {
		if (node->type == XML_ELEMENT_NODE)
			Lit_Donnee_Xml_Restoration_Interface (node, ID_Reseau, Ip_Dynamic);
	}
}


gboolean Restoration_Interface (char *fname, gint ID_Reseau)
{
	xmlDocPtr doc = NULL;
	xmlNode  *xmlnode = NULL;
	struct Struct_Liste_Reseau *Reseau = NULL;
	gboolean  Ip_Dynamic;

	if ((xmlnode = OpenXml(fname, "autoscan-network", &doc)) == NULL)
		return FALSE;
	Reseau = Recupere_Pointeur_Structure_Reseau (ID_Reseau);

	XML_READ_BOOL(Reseau->Mode_Liste_Detaille,"Mode_IP",FALSE);
	XML_READ_BOOL(Ip_Dynamic,"Ip_Dynamic",FALSE);
	XML_READ_STRING(Reseau->Email_Alert_Intrusion ,"Email_Alert_Intrusion",NULL);
	XML_READ_STRING(Reseau->Global_Ssh_User ,"Global_Ssh_User",NULL);	
	XML_READ_STRING(Reseau->Global_Vnc_Password ,"Global_Vnc_Password",NULL);	

	Lit_Xml_Restoration_Interface (doc, ID_Reseau, Ip_Dynamic);
	XML_CLOSE (doc);
	return TRUE;
}
