/* ***********************IMPORTANT *********************************************
 *  Copyright (C) 2004-2010 Thierry Lagarde <thierry@autoscan-network.com>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License.
 *
 *
 *                      ********************
 *
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *
 *                      ********************
 *
 *
 * You are highly encouraged to send your changes to <tlagarde@users.sourceforge.net>
 * for possible incorporation into the main distribution.
 * By sending these changes to <tlagarde@users.sourceforge.net>,
 * it is assumed that you are offering <tlagarde@users.sourceforge.net>
 * the unlimited, non-exclusive right to reuse, modify, and relicense the code.
 *
 *
 *                      ********************
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 **************************************************************************************/
#ifndef         __XML
#define        __XML

#include <glib.h>
#include <time.h>
#include <libxml/tree.h>
#include <libxml/parser.h>
#include "Declaration_Constante.h"
#include "Mem.h"
#include "Win32.h"

xmlNodePtr Node_Courant;

xmlNode  * OpenXml(gchar *filexml, gchar *name_root_element, xmlDocPtr *doc);
gboolean CreateXml(gchar *filexml, xmlDocPtr *doc, xmlNodePtr *root_element, char * NameNodeRoot, char *copyright, char *stylesheet);
gboolean SaveXml(char *filexml, xmlDocPtr *doc);
void CloseXml(xmlDocPtr *doc);
gboolean Check_Current_Node(xmlNodePtr xmlnode,char *name);
xmlNodePtr Create_Node(xmlNodePtr xmlnode,char *name);
gchar *LitXml_string_default(gchar *key,gchar *default_reponse);
gchar *LitXml_string(gchar *key);
void LitXml_string_copie(gchar *key,gchar *copie);
time_t64 LitXml_time(gchar *key);
gint LitXml_int_default(gchar *key,gint default_gint);
gint LitXml_int(gchar *key);
gboolean LitXml_boolean_default(gchar *key,gboolean default_boolean);
gboolean LitXml_boolean(gchar *key);

void StockXml_string(gchar *key,gchar *chaine);
void StockXml_time(gchar *key,time_t64 *time);
void StockXml_int(gchar *key,gint etat);
void StockXml_boolean(gchar *key,gboolean etat);



#define XML_READ_STRING(_result,_key,_default_reponse)	G_STMT_START{			\
		Node_Courant = xmlnode;																			\
		FREE_GCHAR (_result);																						\
		_result = LitXml_string_default(_key,_default_reponse);										\
		}G_STMT_END

#define XML_READ_STRING_COPY(_result,_key)	G_STMT_START{						\
		Node_Courant = xmlnode;																			\
		LitXml_string_copie(_key,_result);							\
		}G_STMT_END
		
#define XML_READ_INT(_result,_key,_default_reponse)	G_STMT_START{					\
		Node_Courant = xmlnode;																			\
		_result = LitXml_int_default(_key,_default_reponse);											\
		}G_STMT_END

#define XML_READ_BOOL(_result,_key,_default_reponse)	G_STMT_START{				\
		Node_Courant = xmlnode;																			\
		_result = LitXml_boolean_default(_key,_default_reponse);									\
		}G_STMT_END

#define XML_WRITE_STRING(_key,_chaine)	G_STMT_START{												\
		Node_Courant = newxml;																				\
		StockXml_string(_key,_chaine);																					\
		}G_STMT_END			
		
#define XML_WRITE_INT(_key,_etat)	G_STMT_START{												\
		Node_Courant = newxml;																				\
		StockXml_int(_key,_etat);																					\
		}G_STMT_END	

		
#define XML_WRITE_BOOLEAN(_key,_etat)	G_STMT_START{												\
		Node_Courant = newxml;																				\
		StockXml_boolean(_key,_etat);																					\
		}G_STMT_END			
		
#define XML_CHECK_NODE(_node,_name)	G_STMT_START{									\
		if (!Check_Current_Node(_node,_name)) 															\
			return;																										\
		}G_STMT_END
	
#define XML_CREATE(_filexml, _doc, _root_element, _NameNodeRoot, _copyright,_stylesheet)	G_STMT_START{			\
		if (!CreateXml(_filexml, &_doc, &_root_element, _NameNodeRoot, _copyright,_stylesheet))											\
				DEBUG_ERROR( "Fichier XML  : [%s]", _filexml);																								\
		}G_STMT_END


#define XML_SAVE(_filexml, _doc)	G_STMT_START{												\
		if (!SaveXml(_filexml, &_doc))																			\
				DEBUG_ERROR( "Fichier XML  : [%s]", _filexml);											\
		}G_STMT_END		
		
#define XML_CLOSE(_doc)	G_STMT_START{															\
		ERROR_if (_doc == NULL);																				\
		CloseXml(&_doc);																									\
		}G_STMT_END		
 


		
#define XML_CREATE_NODE(_newxml,_node,_name)	G_STMT_START{							\
		_newxml = Create_Node(_node,_name);																\
		}G_STMT_END
#endif
